import { LitElement, type PropertyValueMap } from 'lit';
import { type Ref } from 'lit/directives/ref.js';
export declare class DiscordMediaLifecycle extends LitElement {
    protected mediaComponentRef: Ref<HTMLAudioElement | HTMLVideoElement>;
    protected seekSliderRef: Ref<HTMLInputElement>;
    protected volumeControlRef: Ref<HTMLDivElement>;
    protected volumeControlInputRef: Ref<HTMLInputElement>;
    protected accessor currentPlaybackPosition: string;
    protected accessor totalMediaDuration: string;
    protected accessor isPlaying: boolean;
    private accessor raf;
    protected accessor isMuted: boolean;
    /**
     * Volume is a fractional value between 0 and 1
     */
    protected accessor currentVolume: number;
    protected accessor hasEnded: boolean;
    private accessor hasRunUpdate;
    protected calculateTime(secs: number): string;
    protected displayMediaDuration(): void;
    protected setSliderMax(): void;
    protected displayBufferedAmount(): void;
    protected whilePlaying: () => void;
    protected handleEnded(): void;
    protected handleClickPlayPauseIcon: () => void;
    protected handleSpaceToPlayPause: (event: KeyboardEvent) => void;
    protected handleClickMuteIcon(): void;
    protected handleSeekSliderInput(event: Event): void;
    protected handleSeekSliderChange: () => void;
    protected handleVolumeSliderInput(event: Event): void;
    protected handleVolumeVerticalEnter(): void;
    protected handleVolumeVerticalLeave(): void;
    protected handleVolumeVerticalFocus(): void;
    protected handleVolumeVerticalBlur(): void;
    protected handleVolumeControlKeyboard(event: KeyboardEvent): void;
    protected adjustVolume(change: number, event: KeyboardEvent): void;
    protected mediaMetadataLoaded: () => void;
    shouldUpdate(changedProperties: Map<PropertyKey, unknown> | PropertyValueMap<any>): boolean;
    firstUpdated(changedProperties: Map<PropertyKey, unknown>): void;
    disconnectedCallback(): void;
}
//# sourceMappingURL=DiscordMediaLifecycle.d.ts.map