import '../discord-verified-author-tag/DiscordVerifiedAuthorTag.js';
import { LitElement } from 'lit';
export declare class DiscordAuthorInfo extends LitElement {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The name of the author
     */
    accessor author: string | undefined;
    /**
     * Whether this author is a bot. Only works if `server` and `officialApp` is `false` or `undefined`.
     */
    accessor bot: boolean;
    /**
     * Whether this author is a `server` crosspost webhook. Only works if `bot` and `officialApp` is `false` or `undefined`.
     */
    accessor server: boolean;
    /**
     * Whether this author is a `official app` crosspost webhook. Only works if `bot` and `server` is `false` or `undefined`.
     */
    accessor officialApp: boolean;
    /**
     * Whether this author is the original poster.
     */
    accessor op: boolean;
    /**
     * The colour of the author, which comes from their highest role
     */
    accessor roleColor: string | undefined;
    /**
     * The role icon of the author, which comes from their highest role
     */
    accessor roleIcon: string | undefined;
    /**
     * The role name of the author, which comes from their highest role
     */
    accessor roleName: string | undefined;
    /**
     * The clan icon of the author, which comes from the enabled clan tag
     */
    accessor clanIcon: string | undefined;
    /**
     * The clan name of the author, which comes from the enabled clan tag
     */
    accessor clanTag: string | undefined;
    /**
     * Whether this bot is verified by Discord. Only works if `bot` is `true`
     */
    accessor verified: boolean;
    /**
     * Whether to reverse the order of the author info for compact mode.
     */
    accessor compactMode: boolean;
    accessor lightTheme: boolean;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-author-info': DiscordAuthorInfo;
    }
}
//# sourceMappingURL=DiscordAuthorInfo.d.ts.map