var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import '../discord-verified-author-tag/DiscordVerifiedAuthorTag.js';
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { getClanIcon } from '../../util.js';
import { messagesCompactMode, messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import VerifiedTick from '../svgs/VerifiedTick.js';
let DiscordAuthorInfo = (() => {
    let _classDecorators = [customElement('discord-author-info')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _author_decorators;
    let _author_initializers = [];
    let _author_extraInitializers = [];
    let _bot_decorators;
    let _bot_initializers = [];
    let _bot_extraInitializers = [];
    let _server_decorators;
    let _server_initializers = [];
    let _server_extraInitializers = [];
    let _officialApp_decorators;
    let _officialApp_initializers = [];
    let _officialApp_extraInitializers = [];
    let _op_decorators;
    let _op_initializers = [];
    let _op_extraInitializers = [];
    let _roleColor_decorators;
    let _roleColor_initializers = [];
    let _roleColor_extraInitializers = [];
    let _roleIcon_decorators;
    let _roleIcon_initializers = [];
    let _roleIcon_extraInitializers = [];
    let _roleName_decorators;
    let _roleName_initializers = [];
    let _roleName_extraInitializers = [];
    let _clanIcon_decorators;
    let _clanIcon_initializers = [];
    let _clanIcon_extraInitializers = [];
    let _clanTag_decorators;
    let _clanTag_initializers = [];
    let _clanTag_extraInitializers = [];
    let _verified_decorators;
    let _verified_initializers = [];
    let _verified_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordAuthorInfo = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _author_decorators = [property()];
            _bot_decorators = [property({ type: Boolean })];
            _server_decorators = [property({ type: Boolean })];
            _officialApp_decorators = [property({ type: Boolean, attribute: 'official-app' })];
            _op_decorators = [property({ type: Boolean })];
            _roleColor_decorators = [property({ attribute: 'role-color' })];
            _roleIcon_decorators = [property({ attribute: 'role-icon' })];
            _roleName_decorators = [property({ attribute: 'role-name' })];
            _clanIcon_decorators = [property({ attribute: 'clan-icon' })];
            _clanTag_decorators = [property({ attribute: 'clan-tag' })];
            _verified_decorators = [property({ type: Boolean })];
            _compactMode_decorators = [consume({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _author_decorators, { kind: "accessor", name: "author", static: false, private: false, access: { has: obj => "author" in obj, get: obj => obj.author, set: (obj, value) => { obj.author = value; } }, metadata: _metadata }, _author_initializers, _author_extraInitializers);
            __esDecorate(this, null, _bot_decorators, { kind: "accessor", name: "bot", static: false, private: false, access: { has: obj => "bot" in obj, get: obj => obj.bot, set: (obj, value) => { obj.bot = value; } }, metadata: _metadata }, _bot_initializers, _bot_extraInitializers);
            __esDecorate(this, null, _server_decorators, { kind: "accessor", name: "server", static: false, private: false, access: { has: obj => "server" in obj, get: obj => obj.server, set: (obj, value) => { obj.server = value; } }, metadata: _metadata }, _server_initializers, _server_extraInitializers);
            __esDecorate(this, null, _officialApp_decorators, { kind: "accessor", name: "officialApp", static: false, private: false, access: { has: obj => "officialApp" in obj, get: obj => obj.officialApp, set: (obj, value) => { obj.officialApp = value; } }, metadata: _metadata }, _officialApp_initializers, _officialApp_extraInitializers);
            __esDecorate(this, null, _op_decorators, { kind: "accessor", name: "op", static: false, private: false, access: { has: obj => "op" in obj, get: obj => obj.op, set: (obj, value) => { obj.op = value; } }, metadata: _metadata }, _op_initializers, _op_extraInitializers);
            __esDecorate(this, null, _roleColor_decorators, { kind: "accessor", name: "roleColor", static: false, private: false, access: { has: obj => "roleColor" in obj, get: obj => obj.roleColor, set: (obj, value) => { obj.roleColor = value; } }, metadata: _metadata }, _roleColor_initializers, _roleColor_extraInitializers);
            __esDecorate(this, null, _roleIcon_decorators, { kind: "accessor", name: "roleIcon", static: false, private: false, access: { has: obj => "roleIcon" in obj, get: obj => obj.roleIcon, set: (obj, value) => { obj.roleIcon = value; } }, metadata: _metadata }, _roleIcon_initializers, _roleIcon_extraInitializers);
            __esDecorate(this, null, _roleName_decorators, { kind: "accessor", name: "roleName", static: false, private: false, access: { has: obj => "roleName" in obj, get: obj => obj.roleName, set: (obj, value) => { obj.roleName = value; } }, metadata: _metadata }, _roleName_initializers, _roleName_extraInitializers);
            __esDecorate(this, null, _clanIcon_decorators, { kind: "accessor", name: "clanIcon", static: false, private: false, access: { has: obj => "clanIcon" in obj, get: obj => obj.clanIcon, set: (obj, value) => { obj.clanIcon = value; } }, metadata: _metadata }, _clanIcon_initializers, _clanIcon_extraInitializers);
            __esDecorate(this, null, _clanTag_decorators, { kind: "accessor", name: "clanTag", static: false, private: false, access: { has: obj => "clanTag" in obj, get: obj => obj.clanTag, set: (obj, value) => { obj.clanTag = value; } }, metadata: _metadata }, _clanTag_initializers, _clanTag_extraInitializers);
            __esDecorate(this, null, _verified_decorators, { kind: "accessor", name: "verified", static: false, private: false, access: { has: obj => "verified" in obj, get: obj => obj.verified, set: (obj, value) => { obj.verified = value; } }, metadata: _metadata }, _verified_initializers, _verified_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordAuthorInfo = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			display: inline-flex;
			align-items: center;
			font-size: 16px;
			text-underline-offset: 1px;
			margin-right: 0.25rem;
		}

		:host .discord-author-username {
			color: #fff;
			font-size: 1em;
			font-weight: 500;
		}

		:host .discord-author-username:hover {
			text-decoration: underline;
			cursor: pointer;
		}

		:host([light-theme]) .discord-author-username {
			color: #23262a;
		}

		:host .discord-clan-tag {
			background-color: oklab(0.431937 0.00109309 -0.0132537 / 0.54);
			color: #fff;
			font-size: 12px;
			font-weight: 500;
			margin-left: 0.25rem;
			border-radius: 4px;
			line-height: 100%;
			text-transform: uppercase;
			display: inline-flex;
			width: max-content;
			gap: 0.25rem;
			justify-content: space-between;
			align-items: center;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			height: 1.2rem;
			min-width: 45px;
			line-height: 1rem !important;
			transition: background-color 100ms ease-in-out;
			cursor: pointer;
		}

		:host .discord-clan-tag:hover {
			background-color: oklab(0.431937 0.00109309 -0.0132537 / 0.34);
		}

		:host([light-theme]) .discord-clan-tag {
			background-color: hsl(0 calc(1 * 0%) 0.8%/0.09);
			color: #000;
		}

		:host([light-theme]) .discord-clan-tag:hover {
			background-color: hsl(0 calc(1 * 0%) 0.8%/0.03);
		}

		:host([compact-mode]) .discord-clan-tag {
			margin-left: 0rem;
		}

		:host .discord-clan-tag span,
		:host .discord-clan-tag svg,
		:host .discord-clan-tag img {
			user-select: none;
			-webkit-user-select: none;
		}

		:host .discord-application-tag {
			background-color: #5865f2;
			color: #fff;
			font-size: 0.625em;
			border-radius: 3px;
			line-height: 100%;
			text-transform: uppercase;

			/* Use flex layout to ensure both verified icon and "BOT" text are aligned to center */
			display: inline-flex;
			align-items: center;

			/* Styling taken through Inspect Element on Discord client for Windows */
			height: 0.9375rem;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			border-radius: 0.1875rem;
		}

		:host .discord-official-application {
			background-color: #5865f2;
			color: #fff;
			font-size: 0.625em;
			margin-left: 4px;
			border-radius: 3px;
			line-height: 100%;
			text-transform: uppercase;

			/* Use flex layout to ensure both verified icon and "BOT" text are aligned to center */
			display: flex;
			align-items: center;

			/* Styling taken through Inspect Element on Discord client for Windows */
			height: 0.9375rem;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			border-radius: 0.1875rem;
		}

		:host([compact-mode]) .discord-official-application {
			margin-right: 5px;
			margin-left: 0px !important;
		}

		:host .discord-application-tag.discord-application-tag-op {
			background-color: #c9cdfb;
			color: #4752c4;
			border-radius: 0.4rem;
		}

		:host .discord-author-role-icon {
			margin-left: 0.25rem;
			vertical-align: top;
			height: calc(1rem + 4px);
			width: calc(1rem + 4px);
		}

		:host([compact-mode]) .discord-author-username {
			margin-right: 0.25rem;
		}

		:host([compact-mode]) .discord-application-tag {
			padding-left: 10px;
			padding-right: 4px;
			margin-right: 0.25rem;
		}
	`;
        #author_accessor_storage = __runInitializers(this, _author_initializers, undefined);
        /**
         * The name of the author
         */
        get author() { return this.#author_accessor_storage; }
        set author(value) { this.#author_accessor_storage = value; }
        #bot_accessor_storage = (__runInitializers(this, _author_extraInitializers), __runInitializers(this, _bot_initializers, false));
        /**
         * Whether this author is a bot. Only works if `server` and `officialApp` is `false` or `undefined`.
         */
        get bot() { return this.#bot_accessor_storage; }
        set bot(value) { this.#bot_accessor_storage = value; }
        #server_accessor_storage = (__runInitializers(this, _bot_extraInitializers), __runInitializers(this, _server_initializers, false));
        /**
         * Whether this author is a `server` crosspost webhook. Only works if `bot` and `officialApp` is `false` or `undefined`.
         */
        get server() { return this.#server_accessor_storage; }
        set server(value) { this.#server_accessor_storage = value; }
        #officialApp_accessor_storage = (__runInitializers(this, _server_extraInitializers), __runInitializers(this, _officialApp_initializers, false));
        /**
         * Whether this author is a `official app` crosspost webhook. Only works if `bot` and `server` is `false` or `undefined`.
         */
        get officialApp() { return this.#officialApp_accessor_storage; }
        set officialApp(value) { this.#officialApp_accessor_storage = value; }
        #op_accessor_storage = (__runInitializers(this, _officialApp_extraInitializers), __runInitializers(this, _op_initializers, false));
        /**
         * Whether this author is the original poster.
         */
        get op() { return this.#op_accessor_storage; }
        set op(value) { this.#op_accessor_storage = value; }
        #roleColor_accessor_storage = (__runInitializers(this, _op_extraInitializers), __runInitializers(this, _roleColor_initializers, undefined));
        /**
         * The colour of the author, which comes from their highest role
         */
        get roleColor() { return this.#roleColor_accessor_storage; }
        set roleColor(value) { this.#roleColor_accessor_storage = value; }
        #roleIcon_accessor_storage = (__runInitializers(this, _roleColor_extraInitializers), __runInitializers(this, _roleIcon_initializers, undefined));
        /**
         * The role icon of the author, which comes from their highest role
         */
        get roleIcon() { return this.#roleIcon_accessor_storage; }
        set roleIcon(value) { this.#roleIcon_accessor_storage = value; }
        #roleName_accessor_storage = (__runInitializers(this, _roleIcon_extraInitializers), __runInitializers(this, _roleName_initializers, undefined));
        /**
         * The role name of the author, which comes from their highest role
         */
        get roleName() { return this.#roleName_accessor_storage; }
        set roleName(value) { this.#roleName_accessor_storage = value; }
        #clanIcon_accessor_storage = (__runInitializers(this, _roleName_extraInitializers), __runInitializers(this, _clanIcon_initializers, undefined));
        /**
         * The clan icon of the author, which comes from the enabled clan tag
         */
        get clanIcon() { return this.#clanIcon_accessor_storage; }
        set clanIcon(value) { this.#clanIcon_accessor_storage = value; }
        #clanTag_accessor_storage = (__runInitializers(this, _clanIcon_extraInitializers), __runInitializers(this, _clanTag_initializers, undefined));
        /**
         * The clan name of the author, which comes from the enabled clan tag
         */
        get clanTag() { return this.#clanTag_accessor_storage; }
        set clanTag(value) { this.#clanTag_accessor_storage = value; }
        #verified_accessor_storage = (__runInitializers(this, _clanTag_extraInitializers), __runInitializers(this, _verified_initializers, false));
        /**
         * Whether this bot is verified by Discord. Only works if `bot` is `true`
         */
        get verified() { return this.#verified_accessor_storage; }
        set verified(value) { this.#verified_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _verified_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to reverse the order of the author info for compact mode.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        render() {
            const clanIcon = getClanIcon(this.clanIcon);
            const slicedClanTag = this.clanTag?.slice(0, 4);
            return html `${when(this.compactMode, () => null, () => html `<span class="discord-author-username" style="${styleMap({ color: this.roleColor ?? undefined })}">${this.author}</span>`)}
		${when(this.roleIcon && !this.compactMode, () => html `<img
					class="discord-author-role-icon"
					src=${ifDefined(this.roleIcon)}
					height="20"
					width="20"
					alt=${ifDefined(this.roleName)}
					draggable="false"
				/>`)}
		${when(this.bot && !this.server && !this.officialApp, () => html `<discord-verified-author-tag .verified=${this.verified}></discord-verified-author-tag>`)}
		${when(this.server && !this.bot && !this.officialApp, () => html `<span class="discord-application-tag">Server</span>`)}
		${when(this.officialApp && !this.server && !this.bot, () => html `<span class="discord-official-application">${VerifiedTick()}OFFICIAL</span>`)}
		${when(this.op, () => html `<span class="discord-application-tag discord-application-tag-op">OP</span>`)}
		${when(this.compactMode, () => html `<span class="discord-author-username" style="${styleMap({ color: this.roleColor ?? undefined })}">${this.author}</span>`)}
		${when(this.clanIcon && this.clanTag && this.clanTag?.length > 0, () => html `
				<span class="discord-clan-tag">
					${clanIcon === 'string'
                ? html `<img srcset=${ifDefined(clanIcon)} alt=${ifDefined(slicedClanTag)} width="12" height="12" draggable="false" />`
                : clanIcon}
					<span>${slicedClanTag}</span>
				</span>
			`)} `;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordAuthorInfo = _classThis;
})();
export { DiscordAuthorInfo };
//# sourceMappingURL=DiscordAuthorInfo.js.map