var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { when } from 'lit/directives/when.js';
import { DiscordComponentsError } from '../../util.js';
import LaunchIcon from '../svgs/LaunchIcon.js';
let DiscordButton = (() => {
    let _classDecorators = [customElement('discord-button')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _emoji_decorators;
    let _emoji_initializers = [];
    let _emoji_extraInitializers = [];
    let _emojiName_decorators;
    let _emojiName_initializers = [];
    let _emojiName_extraInitializers = [];
    let _url_decorators;
    let _url_initializers = [];
    let _url_extraInitializers = [];
    let _disabled_decorators;
    let _disabled_initializers = [];
    let _disabled_extraInitializers = [];
    let _type_decorators;
    let _type_initializers = [];
    let _type_extraInitializers = [];
    let _modalId_decorators;
    let _modalId_initializers = [];
    let _modalId_extraInitializers = [];
    var DiscordButton = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _emoji_decorators = [property({ reflect: true, attribute: 'emoji' })];
            _emojiName_decorators = [property({ reflect: true, attribute: 'emoji-name' })];
            _url_decorators = [property({ reflect: true, attribute: 'url' })];
            _disabled_decorators = [property({ type: Boolean, reflect: true, attribute: 'disabled' })];
            _type_decorators = [property({ reflect: true, attribute: 'type' })];
            _modalId_decorators = [property({ reflect: true, attribute: 'modal-id' })];
            __esDecorate(this, null, _emoji_decorators, { kind: "accessor", name: "emoji", static: false, private: false, access: { has: obj => "emoji" in obj, get: obj => obj.emoji, set: (obj, value) => { obj.emoji = value; } }, metadata: _metadata }, _emoji_initializers, _emoji_extraInitializers);
            __esDecorate(this, null, _emojiName_decorators, { kind: "accessor", name: "emojiName", static: false, private: false, access: { has: obj => "emojiName" in obj, get: obj => obj.emojiName, set: (obj, value) => { obj.emojiName = value; } }, metadata: _metadata }, _emojiName_initializers, _emojiName_extraInitializers);
            __esDecorate(this, null, _url_decorators, { kind: "accessor", name: "url", static: false, private: false, access: { has: obj => "url" in obj, get: obj => obj.url, set: (obj, value) => { obj.url = value; } }, metadata: _metadata }, _url_initializers, _url_extraInitializers);
            __esDecorate(this, null, _disabled_decorators, { kind: "accessor", name: "disabled", static: false, private: false, access: { has: obj => "disabled" in obj, get: obj => obj.disabled, set: (obj, value) => { obj.disabled = value; } }, metadata: _metadata }, _disabled_initializers, _disabled_extraInitializers);
            __esDecorate(this, null, _type_decorators, { kind: "accessor", name: "type", static: false, private: false, access: { has: obj => "type" in obj, get: obj => obj.type, set: (obj, value) => { obj.type = value; } }, metadata: _metadata }, _type_initializers, _type_extraInitializers);
            __esDecorate(this, null, _modalId_decorators, { kind: "accessor", name: "modalId", static: false, private: false, access: { has: obj => "modalId" in obj, get: obj => obj.modalId, set: (obj, value) => { obj.modalId = value; } }, metadata: _metadata }, _modalId_initializers, _modalId_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordButton = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host > *:first-child {
			display: flex;
			justify-content: center;
			align-items: center;
			cursor: pointer;
			margin: 4px 8px 4px 0;
			padding: 2px 16px;
			width: auto;
			height: 32px;
			min-width: 60px;
			min-height: 32px;
			-webkit-transition:
				background-color 0.17s ease,
				color 0.17s ease;
			transition:
				background-color 0.17s ease,
				color 0.17s ease;
			border-radius: 3px;
			font-size: 14px;
			font-weight: 500;
			line-height: 16px;
			text-decoration: none !important;
			/* CSS Reset to unset button styling */
			border-width: unset;
			border-style: unset;
			border-color: unset;
			border-image: unset;
			box-sizing: unset;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;
		}

		.success {
			color: #fff;
			background-color: #3ba55d;
		}

		.success.hoverable:hover {
			background-color: #2d7d46;
		}

		.destructive {
			color: #fff;
			background-color: #ed4245;
		}

		.destructive.hoverable:hover {
			background-color: #c03537;
		}

		.primary {
			color: #fff;
			background-color: #5865f2;
		}

		.primary.hoverable:hover {
			background-color: #4752c4;
		}

		.secondary {
			color: #fff;
			background-color: #4f545c;
		}

		.secondary.hoverable:hover {
			background-color: #5d6269;
		}

		.disabled {
			cursor: not-allowed !important;
			opacity: 0.5;
		}

		.launch {
			margin-left: 8px;
		}

		.emoji {
			margin-right: 4px;
			object-fit: contain;
			width: 1.375em;
			height: 1.375em;
			vertical-align: bottom;
		}
	`;
        #emoji_accessor_storage = __runInitializers(this, _emoji_initializers, void 0);
        /**
         * The emoji URL to use in the button.
         */
        get emoji() { return this.#emoji_accessor_storage; }
        set emoji(value) { this.#emoji_accessor_storage = value; }
        #emojiName_accessor_storage = (__runInitializers(this, _emoji_extraInitializers), __runInitializers(this, _emojiName_initializers, 'emoji'));
        /**
         * The name of the emoji used in the button.
         */
        get emojiName() { return this.#emojiName_accessor_storage; }
        set emojiName(value) { this.#emojiName_accessor_storage = value; }
        #url_accessor_storage = (__runInitializers(this, _emojiName_extraInitializers), __runInitializers(this, _url_initializers, void 0));
        /**
         * The URL for the button. Setting this will force the button type to be `secondary`.
         */
        get url() { return this.#url_accessor_storage; }
        set url(value) { this.#url_accessor_storage = value; }
        #disabled_accessor_storage = (__runInitializers(this, _url_extraInitializers), __runInitializers(this, _disabled_initializers, false));
        /**
         * Whether to show the button as disabled.
         */
        get disabled() { return this.#disabled_accessor_storage; }
        set disabled(value) { this.#disabled_accessor_storage = value; }
        #type_accessor_storage = (__runInitializers(this, _disabled_extraInitializers), __runInitializers(this, _type_initializers, 'secondary'));
        /**
         * The type of button this is, this will change the color of the button.
         * Valid values: `primary`, `secondary`, `success`, `destructive`.
         */
        get type() { return this.#type_accessor_storage; }
        set type(value) { this.#type_accessor_storage = value; }
        #modalId_accessor_storage = (__runInitializers(this, _type_extraInitializers), __runInitializers(this, _modalId_initializers, void 0));
        /**
         * An `id` of a modal that should be opened when this button is clicked. This should match the `modal-id` of a `discord-modal` element.
         *
         * @remarks
         * - `discord-modal`s use the HTML [dialog](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/dialog) element. and are opened through `<ref>.showModal()`
         * - If {@link DiscordButton.url} is set this will be ignored.
         * - If {@link DiscordButton.disabled} is set this will be ignored.
         */
        get modalId() { return this.#modalId_accessor_storage; }
        set modalId(value) { this.#modalId_accessor_storage = value; }
        validButtonTypes = (__runInitializers(this, _modalId_extraInitializers), new Set(['primary', 'secondary', 'success', 'destructive']));
        checkType() {
            if (this.type) {
                if (typeof this.type !== 'string') {
                    throw new TypeError('DiscordButton `type` prop must be a string.');
                }
                else if (!this.validButtonTypes.has(this.type)) {
                    throw new RangeError("DiscordButton `type` prop must be one of: 'primary', 'secondary', 'success', 'destructive'");
                }
            }
        }
        checkParentElement() {
            if (this.parentElement?.tagName.toLowerCase() !== 'discord-action-row') {
                throw new DiscordComponentsError('All <discord-button> components must be direct children of <discord-action-row>.');
            }
        }
        handleButtonClick() {
            if (this.modalId) {
                const rootDiscordMessagesElement = this.parentElement?.parentElement?.parentElement?.parentElement;
                if (rootDiscordMessagesElement?.tagName?.toLowerCase() === 'discord-messages') {
                    const discordModalComponent = rootDiscordMessagesElement?.querySelector(`discord-modal`);
                    const dialogElement = discordModalComponent?.shadowRoot?.querySelector(`dialog#${this.modalId}`);
                    const divRootModal = dialogElement?.querySelector(`div.discord-modal-box`);
                    if (dialogElement instanceof HTMLDialogElement && divRootModal instanceof HTMLDivElement) {
                        dialogElement.showModal();
                        divRootModal.style.display = 'flex';
                        if (discordModalComponent) {
                            const originalDocumentOverflowStyle = globalThis.getComputedStyle(globalThis.document.body).overflow;
                            discordModalComponent.originalBodyOverflow = originalDocumentOverflowStyle;
                            globalThis.document.body.style.overflow = 'hidden';
                        }
                    }
                }
            }
        }
        render() {
            this.checkType();
            this.checkParentElement();
            const isActiveLinkButton = this.url && !this.disabled;
            const content = html `
			${when(this.emoji, () => html `<img src=${this.emoji} alt=${this.emojiName} draggable="true" class="emoji" />`)}
			<span>
				<slot></slot>
			</span>
			${when(this.url, () => LaunchIcon())}
		`;
            if (isActiveLinkButton) {
                return html `<a class="secondary" href=${this.url} target="_blank" rel="noopener noreferrer">${content}</a>`;
            }
            return html `<button
			class=${classMap({
                [this.type]: true,
                disabled: this.disabled,
                hoverable: !this.disabled
            })}
			@click=${this.handleButtonClick}
		>
			${content}
		</button>`;
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordButton = _classThis;
})();
export { DiscordButton };
//# sourceMappingURL=DiscordButton.js.map