import { LitElement } from 'lit';
import type { LightTheme } from '../../types.js';
export declare class DiscordCode extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * Whether this code block is a multi-line code block
     */
    accessor multiline: boolean;
    accessor lightTheme: boolean;
    /**
     * Whether this code block exists within a `discord-embed` component.
     */
    accessor embed: boolean;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-code': DiscordCode;
    }
}
//# sourceMappingURL=DiscordCode.d.ts.map