var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordCode = (() => {
    let _classDecorators = [customElement('discord-code')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _multiline_decorators;
    let _multiline_initializers = [];
    let _multiline_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let _embed_decorators;
    let _embed_initializers = [];
    let _embed_extraInitializers = [];
    var DiscordCode = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _multiline_decorators = [property({ type: Boolean, reflect: true })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            _embed_decorators = [property({ type: Boolean, reflect: true })];
            __esDecorate(this, null, _multiline_decorators, { kind: "accessor", name: "multiline", static: false, private: false, access: { has: obj => "multiline" in obj, get: obj => obj.multiline, set: (obj, value) => { obj.multiline = value; } }, metadata: _metadata }, _multiline_initializers, _multiline_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, _embed_decorators, { kind: "accessor", name: "embed", static: false, private: false, access: { has: obj => "embed" in obj, get: obj => obj.embed, set: (obj, value) => { obj.embed = value; } }, metadata: _metadata }, _embed_initializers, _embed_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordCode = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			background-color: #2f3136;
			white-space: break-spaces;
			font-family:
				Consolas,
				Andale Mono WT,
				Andale Mono,
				Lucida Console,
				Lucida Sans Typewriter,
				DejaVu Sans Mono,
				Bitstream Vera Sans Mono,
				Liberation Mono,
				Nimbus Mono L,
				Monaco,
				Courier New,
				Courier,
				monospace;
			border-radius: 3px;
		}

		code {
			padding: 0.2em;
			margin: -0.2em;
			border-radius: 3px;
			border: none;
			font-size: 85%;
			text-indent: 0;
			white-space: pre-wrap;
		}

		:host([multiline]) code {
			display: block;
			width: 90%;
			font-size: 0.875rem;
			line-height: 1.125rem;
			padding: 0.5em;
			background: #2b2d31;
			border: 1px solid #1e1f22;
		}

		:host([embed]) code {
			background-color: #1e1f22;
		}

		:host([embed][multiline]) code {
			display: block;
			width: 100%;
			padding: 7px;
			border-radius: 4px;
			background: #1e1f22;
		}

		:host([light-theme]) code {
			border-color: #e3e5e8;
			background-color: #f2f3f5;
		}

		:host([light-theme][embed]) code {
			background-color: #e3e5e8;
		}
	`;
        #multiline_accessor_storage = __runInitializers(this, _multiline_initializers, false);
        /**
         * Whether this code block is a multi-line code block
         */
        get multiline() { return this.#multiline_accessor_storage; }
        set multiline(value) { this.#multiline_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _multiline_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #embed_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), __runInitializers(this, _embed_initializers, false));
        /**
         * Whether this code block exists within a `discord-embed` component.
         */
        get embed() { return this.#embed_accessor_storage; }
        set embed(value) { this.#embed_accessor_storage = value; }
        render() {
            if (this.multiline) {
                return html `<discord-pre ?embed=${this.embed}
				><code><slot></slot></code
			></discord-pre>`;
            }
            return html `<code><slot></slot></code>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _embed_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordCode = _classThis;
})();
export { DiscordCode };
//# sourceMappingURL=DiscordCode.js.map