var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { avatars, profiles } from '../../config.js';
import { messagesCompactMode, messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import { DiscordReply } from '../discord-reply/DiscordReply.js';
import AttachmentReply from '../svgs/AttachmentReply.js';
import CommandIcon from '../svgs/CommandIcon.js';
import CommandIconName from '../svgs/CommandIconName.js';
import CommandReply from '../svgs/CommandReply.js';
import ExpandMore from '../svgs/ExpandMore.js';
import MessageIcon from '../svgs/MessageIcon.js';
import VerifiedTick from '../svgs/VerifiedTick.js';
let DiscordCommand = (() => {
    let _classDecorators = [customElement('discord-command')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _profile_decorators;
    let _profile_initializers = [];
    let _profile_extraInitializers = [];
    let _author_decorators;
    let _author_initializers = [];
    let _author_extraInitializers = [];
    let _avatar_decorators;
    let _avatar_initializers = [];
    let _avatar_extraInitializers = [];
    let _roleColor_decorators;
    let _roleColor_initializers = [];
    let _roleColor_extraInitializers = [];
    let _command_decorators;
    let _command_initializers = [];
    let _command_extraInitializers = [];
    let _type_decorators;
    let _type_initializers = [];
    let _type_extraInitializers = [];
    let _contextUserProfile_decorators;
    let _contextUserProfile_initializers = [];
    let _contextUserProfile_extraInitializers = [];
    let _contextUserName_decorators;
    let _contextUserName_initializers = [];
    let _contextUserName_extraInitializers = [];
    let _contextUserAvatar_decorators;
    let _contextUserAvatar_initializers = [];
    let _contextUserAvatar_extraInitializers = [];
    let _contextUserRoleColor_decorators;
    let _contextUserRoleColor_initializers = [];
    let _contextUserRoleColor_extraInitializers = [];
    let _contextUserBot_decorators;
    let _contextUserBot_initializers = [];
    let _contextUserBot_extraInitializers = [];
    let _contextUserBotVerified_decorators;
    let _contextUserBotVerified_initializers = [];
    let _contextUserBotVerified_extraInitializers = [];
    let _contextCommandReply_decorators;
    let _contextCommandReply_initializers = [];
    let _contextCommandReply_extraInitializers = [];
    let _contextAttachmentReply_decorators;
    let _contextAttachmentReply_initializers = [];
    let _contextAttachmentReply_extraInitializers = [];
    let _contextMessageReply_decorators;
    let _contextMessageReply_initializers = [];
    let _contextMessageReply_extraInitializers = [];
    let _contextMessageDeleted_decorators;
    let _contextMessageDeleted_initializers = [];
    let _contextMessageDeleted_extraInitializers = [];
    let _contextUserOfficialApplication_decorators;
    let _contextUserOfficialApplication_initializers = [];
    let _contextUserOfficialApplication_extraInitializers = [];
    let _contextUserServer_decorators;
    let _contextUserServer_initializers = [];
    let _contextUserServer_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordCommand = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _profile_decorators = [property({ attribute: 'profile' })];
            _author_decorators = [property({ attribute: 'author' })];
            _avatar_decorators = [property({ attribute: 'avatar' })];
            _roleColor_decorators = [property({ attribute: 'role-color' })];
            _command_decorators = [property({ attribute: 'command' })];
            _type_decorators = [property({ attribute: 'type' })];
            _contextUserProfile_decorators = [property({ attribute: 'context-user-profile' })];
            _contextUserName_decorators = [property({ attribute: 'context-user-name' })];
            _contextUserAvatar_decorators = [property({ attribute: 'context-user-image' })];
            _contextUserRoleColor_decorators = [property({ attribute: 'context-user-role-color' })];
            _contextUserBot_decorators = [property({ type: Boolean, attribute: 'context-user-bot' })];
            _contextUserBotVerified_decorators = [property({ type: Boolean, attribute: 'context-user-bot-verified' })];
            _contextCommandReply_decorators = [property({ type: Boolean, attribute: 'context-command-reply' })];
            _contextAttachmentReply_decorators = [property({ type: Boolean, attribute: 'context-attachment-reply' })];
            _contextMessageReply_decorators = [property({ type: String, attribute: 'context-message-reply' })];
            _contextMessageDeleted_decorators = [property({ type: Boolean, attribute: 'context-message-deleted' })];
            _contextUserOfficialApplication_decorators = [property({ type: Boolean, attribute: 'context-user-application-official' })];
            _contextUserServer_decorators = [property({ type: Boolean, attribute: 'context-user-server' })];
            _compactMode_decorators = [consume({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _profile_decorators, { kind: "accessor", name: "profile", static: false, private: false, access: { has: obj => "profile" in obj, get: obj => obj.profile, set: (obj, value) => { obj.profile = value; } }, metadata: _metadata }, _profile_initializers, _profile_extraInitializers);
            __esDecorate(this, null, _author_decorators, { kind: "accessor", name: "author", static: false, private: false, access: { has: obj => "author" in obj, get: obj => obj.author, set: (obj, value) => { obj.author = value; } }, metadata: _metadata }, _author_initializers, _author_extraInitializers);
            __esDecorate(this, null, _avatar_decorators, { kind: "accessor", name: "avatar", static: false, private: false, access: { has: obj => "avatar" in obj, get: obj => obj.avatar, set: (obj, value) => { obj.avatar = value; } }, metadata: _metadata }, _avatar_initializers, _avatar_extraInitializers);
            __esDecorate(this, null, _roleColor_decorators, { kind: "accessor", name: "roleColor", static: false, private: false, access: { has: obj => "roleColor" in obj, get: obj => obj.roleColor, set: (obj, value) => { obj.roleColor = value; } }, metadata: _metadata }, _roleColor_initializers, _roleColor_extraInitializers);
            __esDecorate(this, null, _command_decorators, { kind: "accessor", name: "command", static: false, private: false, access: { has: obj => "command" in obj, get: obj => obj.command, set: (obj, value) => { obj.command = value; } }, metadata: _metadata }, _command_initializers, _command_extraInitializers);
            __esDecorate(this, null, _type_decorators, { kind: "accessor", name: "type", static: false, private: false, access: { has: obj => "type" in obj, get: obj => obj.type, set: (obj, value) => { obj.type = value; } }, metadata: _metadata }, _type_initializers, _type_extraInitializers);
            __esDecorate(this, null, _contextUserProfile_decorators, { kind: "accessor", name: "contextUserProfile", static: false, private: false, access: { has: obj => "contextUserProfile" in obj, get: obj => obj.contextUserProfile, set: (obj, value) => { obj.contextUserProfile = value; } }, metadata: _metadata }, _contextUserProfile_initializers, _contextUserProfile_extraInitializers);
            __esDecorate(this, null, _contextUserName_decorators, { kind: "accessor", name: "contextUserName", static: false, private: false, access: { has: obj => "contextUserName" in obj, get: obj => obj.contextUserName, set: (obj, value) => { obj.contextUserName = value; } }, metadata: _metadata }, _contextUserName_initializers, _contextUserName_extraInitializers);
            __esDecorate(this, null, _contextUserAvatar_decorators, { kind: "accessor", name: "contextUserAvatar", static: false, private: false, access: { has: obj => "contextUserAvatar" in obj, get: obj => obj.contextUserAvatar, set: (obj, value) => { obj.contextUserAvatar = value; } }, metadata: _metadata }, _contextUserAvatar_initializers, _contextUserAvatar_extraInitializers);
            __esDecorate(this, null, _contextUserRoleColor_decorators, { kind: "accessor", name: "contextUserRoleColor", static: false, private: false, access: { has: obj => "contextUserRoleColor" in obj, get: obj => obj.contextUserRoleColor, set: (obj, value) => { obj.contextUserRoleColor = value; } }, metadata: _metadata }, _contextUserRoleColor_initializers, _contextUserRoleColor_extraInitializers);
            __esDecorate(this, null, _contextUserBot_decorators, { kind: "accessor", name: "contextUserBot", static: false, private: false, access: { has: obj => "contextUserBot" in obj, get: obj => obj.contextUserBot, set: (obj, value) => { obj.contextUserBot = value; } }, metadata: _metadata }, _contextUserBot_initializers, _contextUserBot_extraInitializers);
            __esDecorate(this, null, _contextUserBotVerified_decorators, { kind: "accessor", name: "contextUserBotVerified", static: false, private: false, access: { has: obj => "contextUserBotVerified" in obj, get: obj => obj.contextUserBotVerified, set: (obj, value) => { obj.contextUserBotVerified = value; } }, metadata: _metadata }, _contextUserBotVerified_initializers, _contextUserBotVerified_extraInitializers);
            __esDecorate(this, null, _contextCommandReply_decorators, { kind: "accessor", name: "contextCommandReply", static: false, private: false, access: { has: obj => "contextCommandReply" in obj, get: obj => obj.contextCommandReply, set: (obj, value) => { obj.contextCommandReply = value; } }, metadata: _metadata }, _contextCommandReply_initializers, _contextCommandReply_extraInitializers);
            __esDecorate(this, null, _contextAttachmentReply_decorators, { kind: "accessor", name: "contextAttachmentReply", static: false, private: false, access: { has: obj => "contextAttachmentReply" in obj, get: obj => obj.contextAttachmentReply, set: (obj, value) => { obj.contextAttachmentReply = value; } }, metadata: _metadata }, _contextAttachmentReply_initializers, _contextAttachmentReply_extraInitializers);
            __esDecorate(this, null, _contextMessageReply_decorators, { kind: "accessor", name: "contextMessageReply", static: false, private: false, access: { has: obj => "contextMessageReply" in obj, get: obj => obj.contextMessageReply, set: (obj, value) => { obj.contextMessageReply = value; } }, metadata: _metadata }, _contextMessageReply_initializers, _contextMessageReply_extraInitializers);
            __esDecorate(this, null, _contextMessageDeleted_decorators, { kind: "accessor", name: "contextMessageDeleted", static: false, private: false, access: { has: obj => "contextMessageDeleted" in obj, get: obj => obj.contextMessageDeleted, set: (obj, value) => { obj.contextMessageDeleted = value; } }, metadata: _metadata }, _contextMessageDeleted_initializers, _contextMessageDeleted_extraInitializers);
            __esDecorate(this, null, _contextUserOfficialApplication_decorators, { kind: "accessor", name: "contextUserOfficialApplication", static: false, private: false, access: { has: obj => "contextUserOfficialApplication" in obj, get: obj => obj.contextUserOfficialApplication, set: (obj, value) => { obj.contextUserOfficialApplication = value; } }, metadata: _metadata }, _contextUserOfficialApplication_initializers, _contextUserOfficialApplication_extraInitializers);
            __esDecorate(this, null, _contextUserServer_decorators, { kind: "accessor", name: "contextUserServer", static: false, private: false, access: { has: obj => "contextUserServer" in obj, get: obj => obj.contextUserServer, set: (obj, value) => { obj.contextUserServer = value; } }, metadata: _metadata }, _contextUserServer_initializers, _contextUserServer_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordCommand = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = [
            DiscordReply.styles,
            css `
			:host .discord-slash-command-name {
				color: color-mix(in oklab, hsl(200 calc(1 * 100%) 49.4% / 1) 100%, black 0%) !important;
				font-weight: 500;
				background-color: #3c4270;
				border-radius: 3px;
				display: flex;
				padding: 0 5px;
				align-items: center;
				gap: 2px;
				cursor: default;
			}

			:host .discord-slash-command-name:hover {
				color: #fffffd !important;
				background-color: #5865f2;
			}

			.discord-context-command-name {
				color: color-mix(in oklab, hsl(200 calc(1 * 100%) 49.4% / 1) 100%, black 0%) !important;
				opacity: 0.64;
				cursor: default;
				font-weight: 500;
			}

			.discord-arrow-right-icon {
				transform: rotate(267deg);
				width: 12px;
				height: 12px;
				fill: none;
				margin-right: 2px;
				margin-left: 2px;
				margin-top: 3px;
			}

			.discord-context-user {
				display: flex;
				align-items: center;
				margin-top: 3px;
			}

			.discord-message-margintop {
				margin-top: 3px;
			}

			:host .discord-message-deleted {
				color: rgb(185, 187, 190) !important;
				cursor: default;
			}

			:host .discord-replied-message-username {
				margin-right: 0;
			}

			:host([light-theme]) .discord-replied-message-username {
				color: rgb(46, 51, 56);
			}

			:host([compact-mode]) .discord-context-user {
				display: flex;
				align-items: center;
				margin: 0 !important;
			}

			:host([compact-mode]) .discord-message-margintop {
				margin-top: 0 !important;
			}
		`
        ];
        #profile_accessor_storage = __runInitializers(this, _profile_initializers, void 0);
        /**
         * The id of the profile data to use.
         */
        get profile() { return this.#profile_accessor_storage; }
        set profile(value) { this.#profile_accessor_storage = value; }
        #author_accessor_storage = (__runInitializers(this, _profile_extraInitializers), __runInitializers(this, _author_initializers, 'User'));
        /**
         * The message author's username.
         *
         * @defaultValue 'User'
         */
        get author() { return this.#author_accessor_storage; }
        set author(value) { this.#author_accessor_storage = value; }
        #avatar_accessor_storage = (__runInitializers(this, _author_extraInitializers), __runInitializers(this, _avatar_initializers, void 0));
        /**
         * The message author's avatar. Can be an avatar shortcut, relative path, or external link.
         */
        get avatar() { return this.#avatar_accessor_storage; }
        set avatar(value) { this.#avatar_accessor_storage = value; }
        #roleColor_accessor_storage = (__runInitializers(this, _avatar_extraInitializers), __runInitializers(this, _roleColor_initializers, void 0));
        /**
         * The message author's primary role color.
         * Can be any [CSS color value](https://www.w3schools.com/cssref/css_colors_legal.asp).
         */
        get roleColor() { return this.#roleColor_accessor_storage; }
        set roleColor(value) { this.#roleColor_accessor_storage = value; }
        #command_accessor_storage = (__runInitializers(this, _roleColor_extraInitializers), __runInitializers(this, _command_initializers, void 0));
        /**
         * The name of the command invoked.
         */
        get command() { return this.#command_accessor_storage; }
        set command(value) { this.#command_accessor_storage = value; }
        #type_accessor_storage = (__runInitializers(this, _command_extraInitializers), __runInitializers(this, _type_initializers, 'slash_command'));
        /**
         * The type of command
         */
        get type() { return this.#type_accessor_storage; }
        set type(value) { this.#type_accessor_storage = value; }
        #contextUserProfile_accessor_storage = (__runInitializers(this, _type_extraInitializers), __runInitializers(this, _contextUserProfile_initializers, void 0));
        /**
         * The id of the profile data to use.
         */
        get contextUserProfile() { return this.#contextUserProfile_accessor_storage; }
        set contextUserProfile(value) { this.#contextUserProfile_accessor_storage = value; }
        #contextUserName_accessor_storage = (__runInitializers(this, _contextUserProfile_extraInitializers), __runInitializers(this, _contextUserName_initializers, 'User'));
        /**
         * The name of user mentioned in context menu
         */
        get contextUserName() { return this.#contextUserName_accessor_storage; }
        set contextUserName(value) { this.#contextUserName_accessor_storage = value; }
        #contextUserAvatar_accessor_storage = (__runInitializers(this, _contextUserName_extraInitializers), __runInitializers(this, _contextUserAvatar_initializers, void 0));
        /**
         * The image of user mentioned in context menu
         */
        get contextUserAvatar() { return this.#contextUserAvatar_accessor_storage; }
        set contextUserAvatar(value) { this.#contextUserAvatar_accessor_storage = value; }
        #contextUserRoleColor_accessor_storage = (__runInitializers(this, _contextUserAvatar_extraInitializers), __runInitializers(this, _contextUserRoleColor_initializers, void 0));
        /**
         * The role color of user mentioned in context menu
         */
        get contextUserRoleColor() { return this.#contextUserRoleColor_accessor_storage; }
        set contextUserRoleColor(value) { this.#contextUserRoleColor_accessor_storage = value; }
        #contextUserBot_accessor_storage = (__runInitializers(this, _contextUserRoleColor_extraInitializers), __runInitializers(this, _contextUserBot_initializers, false));
        /**
         * If the message command user  are bot
         */
        get contextUserBot() { return this.#contextUserBot_accessor_storage; }
        set contextUserBot(value) { this.#contextUserBot_accessor_storage = value; }
        #contextUserBotVerified_accessor_storage = (__runInitializers(this, _contextUserBot_extraInitializers), __runInitializers(this, _contextUserBotVerified_initializers, false));
        /**
         * If the user bot are verified
         */
        get contextUserBotVerified() { return this.#contextUserBotVerified_accessor_storage; }
        set contextUserBotVerified(value) { this.#contextUserBotVerified_accessor_storage = value; }
        #contextCommandReply_accessor_storage = (__runInitializers(this, _contextUserBotVerified_extraInitializers), __runInitializers(this, _contextCommandReply_initializers, false));
        /**
         * Whether the referenced context message is from a response of a slash command.
         */
        get contextCommandReply() { return this.#contextCommandReply_accessor_storage; }
        set contextCommandReply(value) { this.#contextCommandReply_accessor_storage = value; }
        #contextAttachmentReply_accessor_storage = (__runInitializers(this, _contextCommandReply_extraInitializers), __runInitializers(this, _contextAttachmentReply_initializers, false));
        /**
         * Whether the referenced context message contains attachments.
         */
        get contextAttachmentReply() { return this.#contextAttachmentReply_accessor_storage; }
        set contextAttachmentReply(value) { this.#contextAttachmentReply_accessor_storage = value; }
        #contextMessageReply_accessor_storage = (__runInitializers(this, _contextAttachmentReply_extraInitializers), __runInitializers(this, _contextMessageReply_initializers, void 0));
        /**
         * The referenced message in message command
         */
        get contextMessageReply() { return this.#contextMessageReply_accessor_storage; }
        set contextMessageReply(value) { this.#contextMessageReply_accessor_storage = value; }
        #contextMessageDeleted_accessor_storage = (__runInitializers(this, _contextMessageReply_extraInitializers), __runInitializers(this, _contextMessageDeleted_initializers, false));
        /**
         * If the referenced messaga has deleted
         */
        get contextMessageDeleted() { return this.#contextMessageDeleted_accessor_storage; }
        set contextMessageDeleted(value) { this.#contextMessageDeleted_accessor_storage = value; }
        #contextUserOfficialApplication_accessor_storage = (__runInitializers(this, _contextMessageDeleted_extraInitializers), __runInitializers(this, _contextUserOfficialApplication_initializers, false));
        /**
         * If the context user is a application official of discord
         */
        get contextUserOfficialApplication() { return this.#contextUserOfficialApplication_accessor_storage; }
        set contextUserOfficialApplication(value) { this.#contextUserOfficialApplication_accessor_storage = value; }
        #contextUserServer_accessor_storage = (__runInitializers(this, _contextUserOfficialApplication_extraInitializers), __runInitializers(this, _contextUserServer_initializers, false));
        /**
         * If the context user is a server
         */
        get contextUserServer() { return this.#contextUserServer_accessor_storage; }
        set contextUserServer(value) { this.#contextUserServer_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _contextUserServer_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to use compact mode or not.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        validCommandTypes = (__runInitializers(this, _lightTheme_extraInitializers), new Set(['user_command', 'message_command', 'slash_command']));
        checkType() {
            if (this.type) {
                if (typeof this.type !== 'string') {
                    throw new TypeError('DiscordCommand `type` prop must be a string.');
                }
                else if (!this.validCommandTypes.has(this.type)) {
                    throw new RangeError("DiscordCommand `type` prop must be one of: 'uer_command', 'message_command' or 'slash_command'");
                }
            }
        }
        resolveAvatar(avatar) {
            return avatars[avatar] ?? avatar ?? avatars.default;
        }
        render() {
            this.checkType();
            const defaultData = { author: this.author, bot: false, verified: false, server: false, roleColor: this.roleColor };
            const profileData = Reflect.get(profiles, this.profile) ?? {};
            const profile = { ...defaultData, ...profileData, avatar: this.resolveAvatar(profileData.avatar ?? this.avatar) };
            const defaultDataContext = {
                author: this.contextUserName,
                bot: this.contextUserBot,
                verified: this.contextUserBotVerified,
                server: false,
                roleColor: this.contextUserRoleColor
            };
            const profileDataContext = Reflect.get(profiles, this.contextUserProfile) ?? {};
            const profileContext = {
                ...defaultDataContext,
                ...profileDataContext,
                avatar: this.resolveAvatar(profileDataContext.avatar ?? this.contextUserAvatar)
            };
            const contentContextMessage = this.contextMessageDeleted
                ? html `<em class="discord-message-deleted">Original message was deleted</em>`
                : this.contextMessageReply;
            return html `
			${when(this.compactMode, () => html `<div class="discord-reply-badge">${CommandIcon()}</div>`, () => html `<img class="discord-replied-message-avatar" src="${ifDefined(profile.avatar)}" alt="${ifDefined(profile.author)}" />`)}
			<span class="discord-replied-message-username" style=${styleMap({ color: profile.roleColor ?? '' })}>${profile.author}</span>
			<span> used </span>
			${when(this.type === 'slash_command', () => html `<div class="discord-replied-message-content discord-slash-command-name">
						${CommandIconName()}<span>${this.command}</span>
					</div>`)}
			${when(this.type === 'user_command', () => html `<div class="discord-replied-message-content discord-context-command-name"><span>${this.command}</span></div>
						${ExpandMore({ class: 'discord-arrow-right-icon' })}
						<div class="discord-context-user">
							${when(!this.compactMode, () => html `<img
										class="discord-replied-message-avatar"
										src="${ifDefined(profileContext.avatar)}"
										alt="${ifDefined(profileContext.author)}"
									/>`)}
							<span class="discord-replied-message-username" style=${styleMap({ color: profileContext.roleColor ?? '' })}
								>${profileContext.author}</span
							>
						</div>`)}
			${when(this.type === 'message_command', () => html `<div class="discord-replied-message-content discord-context-command-name"><span>${this.command}</span></div>
						${ExpandMore({ class: 'discord-arrow-right-icon' })}
						${when(!this.contextMessageDeleted, () => html `<div class="discord-context-user">
									${when(!this.compactMode, () => when(!this.contextUserOfficialApplication, () => html `<img
													class="discord-replied-message-avatar"
													src="${ifDefined(profileContext.avatar)}"
													alt="${ifDefined(profileContext.author)}"
												/>`, () => html `<img
													class="discord-replied-message-avatar"
													src="${ifDefined(avatars.blue)}"
													alt="OFFICIALAPPLICATION"
												/>`))}
									${when(profileContext.bot, () => html `<span class="discord-application-tag">${profileContext.verified ? VerifiedTick() : ''}App</span>`, () => when(this.contextUserServer, () => html `<span class="discord-application-tag">SERVER</span>`, () => when(this.contextUserOfficialApplication, () => html `<span class="discord-application-tag">${VerifiedTick()}OFFICIAL</span>`)))}
									<span class="discord-replied-message-username" style=${styleMap({ color: profileContext.roleColor ?? '' })}
										>${profileContext.author}</span
									><span></span>
								</div>`, () => when(this.contextMessageDeleted, () => MessageIcon({ class: 'discord-message-margintop', style: 'margin-right: 3px;' })))}
						<div class="discord-replied-message-content discord-message-margintop">${contentContextMessage}</div>
						${when(this.contextCommandReply && !this.contextMessageDeleted, () => CommandReply({ class: 'discord-replied-message-content-icon discord-message-margintop' }), () => when(this.contextAttachmentReply, () => AttachmentReply({ class: 'discord-replied-message-content-icon discord-message-margintop' })))} `)}
		`;
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordCommand = _classThis;
})();
export { DiscordCommand };
//# sourceMappingURL=DiscordCommand.js.map