var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { getGlobalEmojiUrl } from '../../util.js';
import '../discord-custom-emoji/DiscordCustomEmoji.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordEmbedField = (() => {
    let _classDecorators = [customElement('discord-embed-field')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _fieldTitle_decorators;
    let _fieldTitle_initializers = [];
    let _fieldTitle_extraInitializers = [];
    let _embedFieldEmojisMap_decorators;
    let _embedFieldEmojisMap_initializers = [];
    let _embedFieldEmojisMap_extraInitializers = [];
    let _inline_decorators;
    let _inline_initializers = [];
    let _inline_extraInitializers = [];
    let _inlineIndex_decorators;
    let _inlineIndex_initializers = [];
    let _inlineIndex_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordEmbedField = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _fieldTitle_decorators = [property({ reflect: true, attribute: 'field-title' })];
            _embedFieldEmojisMap_decorators = [property({ attribute: false })];
            _inline_decorators = [property({ type: Boolean, reflect: true, attribute: 'inline' })];
            _inlineIndex_decorators = [property({ type: Number, reflect: true, attribute: 'inline-index' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _fieldTitle_decorators, { kind: "accessor", name: "fieldTitle", static: false, private: false, access: { has: obj => "fieldTitle" in obj, get: obj => obj.fieldTitle, set: (obj, value) => { obj.fieldTitle = value; } }, metadata: _metadata }, _fieldTitle_initializers, _fieldTitle_extraInitializers);
            __esDecorate(this, null, _embedFieldEmojisMap_decorators, { kind: "accessor", name: "embedFieldEmojisMap", static: false, private: false, access: { has: obj => "embedFieldEmojisMap" in obj, get: obj => obj.embedFieldEmojisMap, set: (obj, value) => { obj.embedFieldEmojisMap = value; } }, metadata: _metadata }, _embedFieldEmojisMap_initializers, _embedFieldEmojisMap_extraInitializers);
            __esDecorate(this, null, _inline_decorators, { kind: "accessor", name: "inline", static: false, private: false, access: { has: obj => "inline" in obj, get: obj => obj.inline, set: (obj, value) => { obj.inline = value; } }, metadata: _metadata }, _inline_initializers, _inline_extraInitializers);
            __esDecorate(this, null, _inlineIndex_decorators, { kind: "accessor", name: "inlineIndex", static: false, private: false, access: { has: obj => "inlineIndex" in obj, get: obj => obj.inlineIndex, set: (obj, value) => { obj.inlineIndex = value; } }, metadata: _metadata }, _inlineIndex_initializers, _inlineIndex_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordEmbedField = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			font-size: 0.875rem;
			line-height: 1.125rem;
			min-width: 0;
			font-weight: 400;
			grid-column: 1/13;
			word-break: break-word;
		}

		:host .discord-field-title {
			color: #ffffff;
			font-weight: 600;
			font-size: 0.875rem;
			line-height: 1.125rem;
			min-width: 0;
			margin-bottom: 2px;
		}

		:host .discord-inline-field {
			flex-grow: 1;
			flex-basis: auto;
			min-width: 150px;
		}

		:host([light-theme]) .discord-field-title {
			color: #313338;
		}
	`;
        #fieldTitle_accessor_storage = __runInitializers(this, _fieldTitle_initializers, void 0);
        get fieldTitle() { return this.#fieldTitle_accessor_storage; }
        set fieldTitle(value) { this.#fieldTitle_accessor_storage = value; }
        #embedFieldEmojisMap_accessor_storage = (__runInitializers(this, _fieldTitle_extraInitializers), __runInitializers(this, _embedFieldEmojisMap_initializers, {}));
        /**
         * An emoji that is prefixed to {@link DiscordEmbedField.fieldTitle | fieldTitle}.
         *
         * This should be keyed as `{ key: { emojiData } }` wherein `key`
         * should occur in the {@link DiscordEmbedField.fieldTitle | fieldTitle}.
         *
         * By default this component will use the global emojis from
         * {@link getGlobalEmojiUrl}, however on SSR frameworks like Nuxt 3 global config doesn't
         * work so we provide this as an alternative method.
         */
        get embedFieldEmojisMap() { return this.#embedFieldEmojisMap_accessor_storage; }
        set embedFieldEmojisMap(value) { this.#embedFieldEmojisMap_accessor_storage = value; }
        #inline_accessor_storage = (__runInitializers(this, _embedFieldEmojisMap_extraInitializers), __runInitializers(this, _inline_initializers, false));
        /**
         * Whether this field should be displayed inline or not.
         */
        get inline() { return this.#inline_accessor_storage; }
        set inline(value) { this.#inline_accessor_storage = value; }
        #inlineIndex_accessor_storage = (__runInitializers(this, _inline_extraInitializers), __runInitializers(this, _inlineIndex_initializers, undefined));
        /**
         * The index of this inline field
         *
         * @remarks
         * - This defines the position of this inline field. 1 is left, 2 is middle and 3 is right.
         * - one of `[1, 2, 3]`
         * @defaultValue 1
         */
        get inlineIndex() { return this.#inlineIndex_accessor_storage; }
        set inlineIndex(value) { this.#inlineIndex_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _inlineIndex_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        validInlineIndices = (__runInitializers(this, _lightTheme_extraInitializers), new Set([1, 2, 3]));
        checkInlineIndex() {
            if (this.inlineIndex) {
                const inlineIndexAsNumber = Number(this.inlineIndex);
                if (!Number.isNaN(inlineIndexAsNumber) && !this.validInlineIndices.has(inlineIndexAsNumber)) {
                    throw new RangeError('DiscordEmbedField `inlineIndex` prop must be one of: 1, 2, or 3');
                }
            }
        }
        render() {
            this.checkInlineIndex();
            const emojiParsedEmbedFieldTitle = this.parseTitle(this.fieldTitle);
            const component = when(emojiParsedEmbedFieldTitle, () => html `<div class="discord-field-title">${[...emojiParsedEmbedFieldTitle]}</div>`);
            return html `${component}<slot></slot>`;
        }
        parseTitle(title) {
            if (!title)
                return null;
            const el = [];
            let complete = '';
            for (const words of title.split('\n')) {
                for (const word of words.split(' ')) {
                    const emoji = getGlobalEmojiUrl(word) ?? this.embedFieldEmojisMap[word] ?? {};
                    if (emoji.name) {
                        el.push(html `<discord-custom-emoji name=${emoji.name} url=${ifDefined(emoji.url)} embed-emoji></discord-custom-emoji>`);
                    }
                    else {
                        complete += `${word} `;
                    }
                    if (complete === ' ') {
                        el.push(html `<br />`);
                    }
                }
                el.push(complete);
                complete = '';
            }
            return el.map((wordOrHtmlTemplate) => {
                if (typeof wordOrHtmlTemplate === 'string') {
                    return html `<span>${wordOrHtmlTemplate}</span>`;
                }
                return wordOrHtmlTemplate;
            });
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordEmbedField = _classThis;
})();
export { DiscordEmbedField };
//# sourceMappingURL=DiscordEmbedField.js.map