import { LitElement } from 'lit';
import type { DiscordTimestamp, LightTheme } from '../../types.js';
export declare class DiscordEmbedFooter extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The image to use next to the footer text.
     */
    accessor footerImage: string;
    /**
     * The alt attribute to use for the {@link DiscordEmbedFooter.footerImage}
     */
    accessor footerImageAlt: string;
    /**
     * The timestamp to use for the message date. When supplying a string, the format must be `01/31/2000`.
     */
    accessor timestamp: DiscordTimestamp;
    accessor lightTheme: boolean;
    updateTimestamp(value?: DiscordTimestamp): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-embed-footer': DiscordEmbedFooter;
    }
}
//# sourceMappingURL=DiscordEmbedFooter.d.ts.map