var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { handleTimestamp } from '../../util.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordEmbedFooter = (() => {
    let _classDecorators = [customElement('discord-embed-footer')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _footerImage_decorators;
    let _footerImage_initializers = [];
    let _footerImage_extraInitializers = [];
    let _footerImageAlt_decorators;
    let _footerImageAlt_initializers = [];
    let _footerImageAlt_extraInitializers = [];
    let _timestamp_decorators;
    let _timestamp_initializers = [];
    let _timestamp_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordEmbedFooter = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _footerImage_decorators = [property({ attribute: 'footer-image' })];
            _footerImageAlt_decorators = [property({ attribute: 'footer-image-alt' })];
            _timestamp_decorators = [property({
                    type: String,
                    reflect: true,
                    converter: (value) => handleTimestamp(value),
                    attribute: true
                })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _footerImage_decorators, { kind: "accessor", name: "footerImage", static: false, private: false, access: { has: obj => "footerImage" in obj, get: obj => obj.footerImage, set: (obj, value) => { obj.footerImage = value; } }, metadata: _metadata }, _footerImage_initializers, _footerImage_extraInitializers);
            __esDecorate(this, null, _footerImageAlt_decorators, { kind: "accessor", name: "footerImageAlt", static: false, private: false, access: { has: obj => "footerImageAlt" in obj, get: obj => obj.footerImageAlt, set: (obj, value) => { obj.footerImageAlt = value; } }, metadata: _metadata }, _footerImageAlt_initializers, _footerImageAlt_extraInitializers);
            __esDecorate(this, null, _timestamp_decorators, { kind: "accessor", name: "timestamp", static: false, private: false, access: { has: obj => "timestamp" in obj, get: obj => obj.timestamp, set: (obj, value) => { obj.timestamp = value; } }, metadata: _metadata }, _timestamp_initializers, _timestamp_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordEmbedFooter = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			-webkit-box-align: center;
			align-items: center;
			display: flex;
			font-size: 12px;
			line-height: 16px;
			font-weight: 500;
			margin-top: 8px;
		}

		:host([light-theme]) {
			color: #747f8d;
		}

		:host .discord-footer-image {
			border-radius: 50%;
			flex-shrink: 0;
			height: 20px;
			margin-right: 8px;
			width: 20px;
		}

		:host .discord-footer-separator {
			color: #dcddde;
			font-weight: 500;
			display: inline-block;
			margin: 0 4px;
		}

		:host([light-theme]) .discord-footer-separator {
			color: #5c5e66;
		}
	`;
        #footerImage_accessor_storage = __runInitializers(this, _footerImage_initializers, void 0);
        /**
         * The image to use next to the footer text.
         */
        get footerImage() { return this.#footerImage_accessor_storage; }
        set footerImage(value) { this.#footerImage_accessor_storage = value; }
        #footerImageAlt_accessor_storage = (__runInitializers(this, _footerImage_extraInitializers), __runInitializers(this, _footerImageAlt_initializers, void 0));
        /**
         * The alt attribute to use for the {@link DiscordEmbedFooter.footerImage}
         */
        get footerImageAlt() { return this.#footerImageAlt_accessor_storage; }
        set footerImageAlt(value) { this.#footerImageAlt_accessor_storage = value; }
        #timestamp_accessor_storage = (__runInitializers(this, _footerImageAlt_extraInitializers), __runInitializers(this, _timestamp_initializers, void 0));
        /**
         * The timestamp to use for the message date. When supplying a string, the format must be `01/31/2000`.
         */
        get timestamp() { return this.#timestamp_accessor_storage; }
        set timestamp(value) { this.#timestamp_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _timestamp_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        updateTimestamp(value) {
            if (value && !Number.isNaN(new Date(value).getTime())) {
                this.timestamp = handleTimestamp(value);
            }
        }
        render() {
            this.updateTimestamp(this.timestamp);
            return html `${when(this.footerImage, () => html `<img src=${ifDefined(this.footerImage)} alt=${ifDefined(this.footerImageAlt)} class="discord-footer-image" />`)}
			<slot></slot>
			${when(this.timestamp, () => html `<span class="discord-footer-separator">&bull;</span>`)}
			${when(this.timestamp, () => ` ${this.timestamp}`, () => null)}`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordEmbedFooter = _classThis;
})();
export { DiscordEmbedFooter };
//# sourceMappingURL=DiscordEmbedFooter.js.map