var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { getGlobalEmojiUrl } from '../../util.js';
import '../discord-custom-emoji/DiscordCustomEmoji.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordEmbed = (() => {
    let _classDecorators = [customElement('discord-embed')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _color_decorators;
    let _color_initializers = [];
    let _color_extraInitializers = [];
    let _authorName_decorators;
    let _authorName_initializers = [];
    let _authorName_extraInitializers = [];
    let _authorImage_decorators;
    let _authorImage_initializers = [];
    let _authorImage_extraInitializers = [];
    let _authorUrl_decorators;
    let _authorUrl_initializers = [];
    let _authorUrl_extraInitializers = [];
    let _embedTitle_decorators;
    let _embedTitle_initializers = [];
    let _embedTitle_extraInitializers = [];
    let _embedEmojisMap_decorators;
    let _embedEmojisMap_initializers = [];
    let _embedEmojisMap_extraInitializers = [];
    let _url_decorators;
    let _url_initializers = [];
    let _url_extraInitializers = [];
    let _thumbnail_decorators;
    let _thumbnail_initializers = [];
    let _thumbnail_extraInitializers = [];
    let _image_decorators;
    let _image_initializers = [];
    let _image_extraInitializers = [];
    let _video_decorators;
    let _video_initializers = [];
    let _video_extraInitializers = [];
    let _provider_decorators;
    let _provider_initializers = [];
    let _provider_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordEmbed = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _color_decorators = [property()];
            _authorName_decorators = [property({ attribute: 'author-name' })];
            _authorImage_decorators = [property({ attribute: 'author-image' })];
            _authorUrl_decorators = [property({ attribute: 'author-url' })];
            _embedTitle_decorators = [property({ attribute: 'embed-title' })];
            _embedEmojisMap_decorators = [property({ attribute: false })];
            _url_decorators = [property()];
            _thumbnail_decorators = [property()];
            _image_decorators = [property()];
            _video_decorators = [property()];
            _provider_decorators = [property()];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _color_decorators, { kind: "accessor", name: "color", static: false, private: false, access: { has: obj => "color" in obj, get: obj => obj.color, set: (obj, value) => { obj.color = value; } }, metadata: _metadata }, _color_initializers, _color_extraInitializers);
            __esDecorate(this, null, _authorName_decorators, { kind: "accessor", name: "authorName", static: false, private: false, access: { has: obj => "authorName" in obj, get: obj => obj.authorName, set: (obj, value) => { obj.authorName = value; } }, metadata: _metadata }, _authorName_initializers, _authorName_extraInitializers);
            __esDecorate(this, null, _authorImage_decorators, { kind: "accessor", name: "authorImage", static: false, private: false, access: { has: obj => "authorImage" in obj, get: obj => obj.authorImage, set: (obj, value) => { obj.authorImage = value; } }, metadata: _metadata }, _authorImage_initializers, _authorImage_extraInitializers);
            __esDecorate(this, null, _authorUrl_decorators, { kind: "accessor", name: "authorUrl", static: false, private: false, access: { has: obj => "authorUrl" in obj, get: obj => obj.authorUrl, set: (obj, value) => { obj.authorUrl = value; } }, metadata: _metadata }, _authorUrl_initializers, _authorUrl_extraInitializers);
            __esDecorate(this, null, _embedTitle_decorators, { kind: "accessor", name: "embedTitle", static: false, private: false, access: { has: obj => "embedTitle" in obj, get: obj => obj.embedTitle, set: (obj, value) => { obj.embedTitle = value; } }, metadata: _metadata }, _embedTitle_initializers, _embedTitle_extraInitializers);
            __esDecorate(this, null, _embedEmojisMap_decorators, { kind: "accessor", name: "embedEmojisMap", static: false, private: false, access: { has: obj => "embedEmojisMap" in obj, get: obj => obj.embedEmojisMap, set: (obj, value) => { obj.embedEmojisMap = value; } }, metadata: _metadata }, _embedEmojisMap_initializers, _embedEmojisMap_extraInitializers);
            __esDecorate(this, null, _url_decorators, { kind: "accessor", name: "url", static: false, private: false, access: { has: obj => "url" in obj, get: obj => obj.url, set: (obj, value) => { obj.url = value; } }, metadata: _metadata }, _url_initializers, _url_extraInitializers);
            __esDecorate(this, null, _thumbnail_decorators, { kind: "accessor", name: "thumbnail", static: false, private: false, access: { has: obj => "thumbnail" in obj, get: obj => obj.thumbnail, set: (obj, value) => { obj.thumbnail = value; } }, metadata: _metadata }, _thumbnail_initializers, _thumbnail_extraInitializers);
            __esDecorate(this, null, _image_decorators, { kind: "accessor", name: "image", static: false, private: false, access: { has: obj => "image" in obj, get: obj => obj.image, set: (obj, value) => { obj.image = value; } }, metadata: _metadata }, _image_initializers, _image_extraInitializers);
            __esDecorate(this, null, _video_decorators, { kind: "accessor", name: "video", static: false, private: false, access: { has: obj => "video" in obj, get: obj => obj.video, set: (obj, value) => { obj.video = value; } }, metadata: _metadata }, _video_initializers, _video_extraInitializers);
            __esDecorate(this, null, _provider_decorators, { kind: "accessor", name: "provider", static: false, private: false, access: { has: obj => "provider" in obj, get: obj => obj.provider, set: (obj, value) => { obj.provider = value; } }, metadata: _metadata }, _provider_initializers, _provider_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordEmbed = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			color: #dcddde;
			display: flex;
			font-size: 13px;
			line-height: 150%;
			margin-bottom: 8px;
			margin-top: 8px;
		}

		:host([light-theme]) {
			color: #2e3338;
		}

		:host .discord-left-border {
			background-color: #202225;
			border-radius: 4px 0 0 4px;
			flex-shrink: 0;
			width: 4px;
		}

		:host([light-theme]) .discord-left-border {
			background-color: #e3e5e8;
		}

		:host .discord-embed-root {
			display: grid;
			grid-auto-flow: row;
			grid-row-gap: 0.25rem;
			min-height: 0;
			min-width: 0;
			text-indent: 0;
		}

		:host .discord-embed-wrapper {
			background-color: #2f3136;
			max-width: 520px;
			border: 1px solid rgba(46, 48, 54, 0.6);
			border-radius: 0 4px 4px 0;
			justify-self: start;
			align-self: start;
			display: grid;
			box-sizing: border-box;
		}

		:host([light-theme]) .discord-embed-wrapper {
			background-color: rgb(242, 243, 245);
			border-color: rgba(205, 205, 205, 0.3);
		}

		:host .discord-embed-wrapper .discord-embed-grid {
			display: inline-grid;
			grid-template-columns: auto -webkit-min-content;
			grid-template-columns: auto min-content;
			grid-template-columns: auto;
			grid-template-rows: auto;
			padding: 0.5rem 1rem 1rem 0.75rem;
		}

		:host .discord-embed-thumbnail {
			border-radius: 4px;
			flex-shrink: 0;
			grid-column: 2/2;
			grid-row: 1/8;
			justify-self: end;
			margin-left: 16px;
			margin-top: 8px;
			max-height: 80px;
			max-width: 80px;
			object-fit: contain;
			object-position: top center;
		}

		:host .discord-embed-author {
			-webkit-box-align: center;
			align-items: center;
			color: #fff;
			font-size: 14px;
			display: flex;
			font-weight: 600;
			grid-column: 1 / 1;
			margin-top: 8px;
			min-width: 0;
		}

		:host([light-theme]) .discord-embed-author {
			color: #060607;
		}

		:host .discord-embed-author a {
			color: #fff;
			font-weight: 600;
			text-decoration: none;
		}

		:host .discord-embed-author a:hover {
			text-decoration: underline;
		}

		:host([light-theme]) .discord-embed-author a {
			color: #060607;
		}

		:host .discord-embed-author .discord-author-image {
			border-radius: 50%;
			height: 24px;
			margin-right: 8px;
			width: 24px;
		}

		:host .discord-embed-author-block,
		:host .discord-embed-author-block > span {
			max-width: 95%;
		}

		:host .discord-embed-provider {
			font-size: 0.75rem;
			line-height: 1rem;
			font-weight: 400;
			grid-column: 1/1;
			margin-top: 8px;
			unicode-bidi: plaintext;
			text-align: left;
		}

		:host([light-theme]) .discord-embed-provider {
			color: #4f545c;
		}

		:host .discord-embed-title {
			-webkit-box-align: center;
			align-items: center;
			color: #fff;
			display: inline-block;
			font-size: 1rem;
			font-weight: 600;
			grid-column: 1 / 1;
			margin-top: 8px;
			min-width: 0;
		}

		:host([light-theme]) .discord-embed-title {
			color: #060607;
		}

		:host .discord-embed-title a {
			color: #00aff4;
			font-weight: 600;
			text-decoration: none;
		}

		:host .discord-embed-title a:hover {
			text-decoration: underline;
		}

		:host .discord-embed-image {
			border-radius: 4px;
			max-width: 300px;
			max-height: 300px;
		}

		:host .discord-embed-media {
			border-radius: 4px;
			contain: paint;
			display: block;
			grid-column: 1/1;
			margin-top: 16px;
		}

		:host .discord-embed-media.discord-embed-media-video {
			height: 225px;
		}

		:host .discord-embed.media .discord-embed-image {
			overflow: hidden;
			position: relative;
			user-select: text;
		}

		:host .discord-embed-media .discord-embed-video {
			-webkit-box-align: center;
			-webkit-box-pack: center;
			align-items: center;
			border-radius: 0;
			cursor: pointer;
			display: flex;
			height: 100%;
			justify-content: center;
			max-height: 100%;
			width: 100%;

			width: 400px;
			height: 225px;
			left: 0px;
			top: 0px;
		}

		.discord-embed-custom-emoji {
			display: inline-block;
		}

		.discord-embed-custom-emoji .discord-embed-custom-emoji-image {
			width: 18px;
			height: 18px;
			vertical-align: bottom;
		}

		slot[name='footer']::slotted(*) {
			grid-column: 1/3;
			grid-row: auto/auto;
		}
	`;
        #color_accessor_storage = __runInitializers(this, _color_initializers, void 0);
        /**
         * The color to use for the embed's left border.
         * Can be any [CSS color value](https://www.w3schools.com/cssref/css_colors_legal.asp).
         */
        get color() { return this.#color_accessor_storage; }
        set color(value) { this.#color_accessor_storage = value; }
        #authorName_accessor_storage = (__runInitializers(this, _color_extraInitializers), __runInitializers(this, _authorName_initializers, void 0));
        /**
         * The author's name.
         */
        get authorName() { return this.#authorName_accessor_storage; }
        set authorName(value) { this.#authorName_accessor_storage = value; }
        #authorImage_accessor_storage = (__runInitializers(this, _authorName_extraInitializers), __runInitializers(this, _authorImage_initializers, void 0));
        /**
         * The author's avatar URL.
         */
        get authorImage() { return this.#authorImage_accessor_storage; }
        set authorImage(value) { this.#authorImage_accessor_storage = value; }
        #authorUrl_accessor_storage = (__runInitializers(this, _authorImage_extraInitializers), __runInitializers(this, _authorUrl_initializers, void 0));
        /**
         * The URL to open when you click on the author's name.
         */
        get authorUrl() { return this.#authorUrl_accessor_storage; }
        set authorUrl(value) { this.#authorUrl_accessor_storage = value; }
        #embedTitle_accessor_storage = (__runInitializers(this, _authorUrl_extraInitializers), __runInitializers(this, _embedTitle_initializers, void 0));
        /**
         * The embed title.
         */
        get embedTitle() { return this.#embedTitle_accessor_storage; }
        set embedTitle(value) { this.#embedTitle_accessor_storage = value; }
        #embedEmojisMap_accessor_storage = (__runInitializers(this, _embedTitle_extraInitializers), __runInitializers(this, _embedEmojisMap_initializers, {}));
        /**
         * An emoji that is prefixed to {@link DiscordEmbed.embedTitle | embedTitle}.
         *
         * This should be keyed as `{ key: { emojiData } }` wherein `key`
         * should occur in the {@link DiscordEmbed.embedTitle | embedTitle}.
         *
         * By default this component will use the global emojis from
         * {@link getGlobalEmojiUrl}, however on SSR frameworks like Nuxt 3 global config doesn't
         * work so we provide this as an alternative method.
         */
        get embedEmojisMap() { return this.#embedEmojisMap_accessor_storage; }
        set embedEmojisMap(value) { this.#embedEmojisMap_accessor_storage = value; }
        #url_accessor_storage = (__runInitializers(this, _embedEmojisMap_extraInitializers), __runInitializers(this, _url_initializers, void 0));
        /**
         * The URL to open when you click on the embed title.
         */
        get url() { return this.#url_accessor_storage; }
        set url(value) { this.#url_accessor_storage = value; }
        #thumbnail_accessor_storage = (__runInitializers(this, _url_extraInitializers), __runInitializers(this, _thumbnail_initializers, void 0));
        /**
         * The thumbnail image to use.
         */
        get thumbnail() { return this.#thumbnail_accessor_storage; }
        set thumbnail(value) { this.#thumbnail_accessor_storage = value; }
        #image_accessor_storage = (__runInitializers(this, _thumbnail_extraInitializers), __runInitializers(this, _image_initializers, void 0));
        /**
         * The embed image to use (displayed at the bottom).
         */
        get image() { return this.#image_accessor_storage; }
        set image(value) { this.#image_accessor_storage = value; }
        #video_accessor_storage = (__runInitializers(this, _image_extraInitializers), __runInitializers(this, _video_initializers, void 0));
        /**
         * The embed video to use (displayed at the bottom, same slot as the image).
         *
         * @remarks
         * - YouTube videos will not be playable on your projects, this is due to YouTube using DASH to play their videos rather
         * than providing the raw media stream (in a container such as mp4 or ogg). Links to regular MP4 files (such as on a CDN) however
         * will autoplay!
         * - Video takes priority over image.
         * - Providing both a video and an image will ensure the image is shown to users with browsers
         * that do not support HTML5 video playback.
         * @example https://download.blender.org/peach/bigbuckbunny_movies/big_buck_bunny_1080p_stereo.ogg
         */
        get video() { return this.#video_accessor_storage; }
        set video(value) { this.#video_accessor_storage = value; }
        #provider_accessor_storage = (__runInitializers(this, _video_extraInitializers), __runInitializers(this, _provider_initializers, void 0));
        /**
         * The provider to show above the embed, for example for YouTube videos it will show "YouTube" at the top of the embed (above the author)
         *
         * @example YouTube
         */
        get provider() { return this.#provider_accessor_storage; }
        set provider(value) { this.#provider_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _provider_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        render() {
            const emojiParsedAuthorName = this.parseTitle(this.authorName);
            const emojiParsedEmbedTitle = this.parseTitle(this.embedTitle);
            return html `<div style=${styleMap({ 'background-color': this.color })} class="discord-left-border"></div>
			<div class="discord-embed-root">
				<div class="discord-embed-wrapper">
					<div class="discord-embed-grid">
						${when(this.provider, () => html `<div class="discord-embed-provider">${this.provider}</div>`)}
						${when(emojiParsedAuthorName, () => html `<div class="discord-embed-author">
									${when(this.authorImage, () => html `<img src=${ifDefined(this.authorImage)} alt="" class="discord-author-image" />`)}
									${when(this.authorUrl, () => html `<a
												href=${ifDefined(this.authorUrl)}
												target="_blank"
												rel="noopener noreferrer"
												class="discord-embed-author-block"
											>
												<span class="discord-embed-author-block">${emojiParsedAuthorName}</span>
											</a>`, () => html `<span class="discord-embed-author-block">${emojiParsedAuthorName}</span>`)}
								</div>`)}
						${when(emojiParsedEmbedTitle, () => html `<div class="discord-embed-title">
									${this.url
                ? html `<a href="${this.url}" target="_blank" rel="noopener noreferrer"> ${emojiParsedEmbedTitle} </a>`
                : html `${emojiParsedEmbedTitle}`}
								</div>`)}
						<slot name="description"></slot>
						<slot name="fields"></slot>
						${when(this.image || this.video, () => html `<div class=${classMap({ 'discord-embed-media': true, 'discord-embed-media-video': Boolean(this.video) })}>
									${this.renderMedia()}
								</div>`)}
						${when(this.thumbnail, () => html `<img src=${ifDefined(this.thumbnail)} alt="" class="discord-embed-thumbnail" />`)}
						<slot name="footer"></slot>
					</div>
				</div>
			</div>`;
        }
        renderMedia() {
            if (this.video) {
                return html `
				<video
					controls
					muted
					preload="none"
					poster=${ifDefined(this.image)}
					src=${ifDefined(this.video)}
					height="225"
					width="400"
					class="discord-embed-video"
				>
					<img src=${ifDefined(this.image)} alt="Discord embed media" class="discord-embed-image" />
				</video>
			`;
            }
            if (this.image) {
                return html `<img src=${ifDefined(this.image)} alt="Discord embed media" class="discord-embed-image" />`;
            }
            return null;
        }
        parseTitle(title) {
            if (!title)
                return null;
            const el = [];
            let complete = '';
            for (const words of title.split('\n')) {
                for (const word of words.split(' ')) {
                    const emoji = getGlobalEmojiUrl(word) ?? this.embedEmojisMap[word] ?? {};
                    if (emoji.name) {
                        el.push(html `<discord-custom-emoji name=${emoji.name} url=${ifDefined(emoji.url)} embed-emoji></discord-custom-emoji>`);
                    }
                    else {
                        complete += `${word} `;
                    }
                    if (complete === ' ') {
                        el.push(html `<br />`);
                    }
                }
                el.push(complete);
                complete = '';
            }
            return el.map((wordOrHtmlTemplate) => {
                if (typeof wordOrHtmlTemplate === 'string') {
                    return html `<span>${wordOrHtmlTemplate}</span>`;
                }
                return wordOrHtmlTemplate;
            });
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordEmbed = _classThis;
})();
export { DiscordEmbed };
//# sourceMappingURL=DiscordEmbed.js.map