import { LitElement } from 'lit';
export declare class DiscordHeader extends LitElement {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The header level, this should be a number between 1 and 3 (inclusive).
     * If a number outside of this range is provided, an error is thrown.
     */
    accessor level: 1 | 2 | 3;
    ensureLevelIsNumber(): void;
    checkLevel(): void;
    protected render(): import("lit-html").TemplateResult<1> | undefined;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-header': DiscordHeader;
    }
}
//# sourceMappingURL=DiscordHeader.d.ts.map