var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { validateImageExtension } from '../../util.js';
let DiscordImageAttachment = (() => {
    let _classDecorators = [customElement('discord-image-attachment')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _url_decorators;
    let _url_initializers = [];
    let _url_extraInitializers = [];
    let _height_decorators;
    let _height_initializers = [];
    let _height_extraInitializers = [];
    let _width_decorators;
    let _width_initializers = [];
    let _width_extraInitializers = [];
    let _alt_decorators;
    let _alt_initializers = [];
    let _alt_extraInitializers = [];
    let _customImageElement_decorators;
    let _customImageElement_initializers = [];
    let _customImageElement_extraInitializers = [];
    var DiscordImageAttachment = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _url_decorators = [property({ reflect: true, attribute: 'url' })];
            _height_decorators = [property({ type: Number, reflect: true, attribute: 'height' })];
            _width_decorators = [property({ type: Number, reflect: true, attribute: 'width' })];
            _alt_decorators = [property({ reflect: true, attribute: 'alt' })];
            _customImageElement_decorators = [property({ type: Boolean, attribute: 'custom-image-element' })];
            __esDecorate(this, null, _url_decorators, { kind: "accessor", name: "url", static: false, private: false, access: { has: obj => "url" in obj, get: obj => obj.url, set: (obj, value) => { obj.url = value; } }, metadata: _metadata }, _url_initializers, _url_extraInitializers);
            __esDecorate(this, null, _height_decorators, { kind: "accessor", name: "height", static: false, private: false, access: { has: obj => "height" in obj, get: obj => obj.height, set: (obj, value) => { obj.height = value; } }, metadata: _metadata }, _height_initializers, _height_extraInitializers);
            __esDecorate(this, null, _width_decorators, { kind: "accessor", name: "width", static: false, private: false, access: { has: obj => "width" in obj, get: obj => obj.width, set: (obj, value) => { obj.width = value; } }, metadata: _metadata }, _width_initializers, _width_extraInitializers);
            __esDecorate(this, null, _alt_decorators, { kind: "accessor", name: "alt", static: false, private: false, access: { has: obj => "alt" in obj, get: obj => obj.alt, set: (obj, value) => { obj.alt = value; } }, metadata: _metadata }, _alt_initializers, _alt_extraInitializers);
            __esDecorate(this, null, _customImageElement_decorators, { kind: "accessor", name: "customImageElement", static: false, private: false, access: { has: obj => "customImageElement" in obj, get: obj => obj.customImageElement, set: (obj, value) => { obj.customImageElement = value; } }, metadata: _metadata }, _customImageElement_initializers, _customImageElement_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordImageAttachment = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			display: block;
			position: relative;
			-webkit-user-select: text;
			-moz-user-select: text;
			-ms-user-select: text;
			user-select: text;
			overflow: hidden;
			border-radius: 3px;
		}

		.discord-image-attachment {
			color: #dcddde;
			display: flex;
			font-size: 13px;
			line-height: 150%;
			margin-bottom: 8px;
			margin-top: 8px;
		}
	`;
        #url_accessor_storage = __runInitializers(this, _url_initializers, void 0);
        /**
         * The URL for the image attachment
         *
         * @remarks Should be a valid image URL, i.e. matching the regex `/\.(bmp|jpe?g|png|gif|webp|tiff)$/i`
         */
        get url() { return this.#url_accessor_storage; }
        set url(value) { this.#url_accessor_storage = value; }
        #height_accessor_storage = (__runInitializers(this, _url_extraInitializers), __runInitializers(this, _height_initializers, void 0));
        /**
         * The height of the image in pixels
         */
        get height() { return this.#height_accessor_storage; }
        set height(value) { this.#height_accessor_storage = value; }
        #width_accessor_storage = (__runInitializers(this, _height_extraInitializers), __runInitializers(this, _width_initializers, void 0));
        /**
         * The width of the image in pixels
         */
        get width() { return this.#width_accessor_storage; }
        set width(value) { this.#width_accessor_storage = value; }
        #alt_accessor_storage = (__runInitializers(this, _width_extraInitializers), __runInitializers(this, _alt_initializers, 'discord image attachment'));
        /**
         * The alt text to show in case the image was unable to load
         *
         * @defaultValue 'discord attachment'
         */
        get alt() { return this.#alt_accessor_storage; }
        set alt(value) { this.#alt_accessor_storage = value; }
        #customImageElement_accessor_storage = (__runInitializers(this, _alt_extraInitializers), __runInitializers(this, _customImageElement_initializers, false));
        /**
         * Indicates that you intend to use a custom image element,
         * useful if you want to use something like
         * {@link https://nextjs.org/docs/pages/api-reference/components/image | `next/image`}
         *
         * Once this property is set, use the child element (default slot) to insert
         * the code for the desired image component
         *
         * @remarks Setting this will disable the
         * {@link DiscordImageAttachment.url | `url`}, and {@link DiscordImageAttachment.alt | `alt`} properties.
         */
        get customImageElement() { return this.#customImageElement_accessor_storage; }
        set customImageElement(value) { this.#customImageElement_accessor_storage = value; }
        componentWillRender() {
            if (!this.customImageElement) {
                validateImageExtension(this.url);
            }
        }
        render() {
            return html `
			<div class="discord-image-attachment">
				<div class="discord-image-wrapper" style="${styleMap({ height: `${this.height}px`, width: `${this.width}px` })}">
					${when(this.customImageElement, () => html `<slot></slot>`, () => html `<img
								alt=${ifDefined(this.alt)}
								src=${ifDefined(this.url)}
								height=${ifDefined(this.height)}
								width=${ifDefined(this.width)}
							/>`)}
				</div>
			</div>
		`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _customImageElement_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordImageAttachment = _classThis;
})();
export { DiscordImageAttachment };
//# sourceMappingURL=DiscordImageAttachment.js.map