import { LitElement } from 'lit';
export declare class DiscordInputText extends LitElement {
    static readonly styles: import("lit").CSSResult;
    /**
     * The type of input text
     */
    accessor type: 'paragraph' | 'short';
    /**
     * if the input text is required
     */
    accessor required: boolean;
    /**
     * The label of input text
     */
    accessor label: string;
    /**
     * The place of input text
     */
    accessor placeholder: string;
    /**
     * The minimal length of input text
     */
    accessor minLength: number;
    /**
     * The maximal length of input text
     */
    accessor maxLength: number;
    /**
     * The theme of modal
     */
    accessor lightTheme: boolean;
    /**
     * The default value of modal
     */
    accessor defaultValue: string;
    protected accessor value: string;
    accessor hasWarning: boolean;
    protected accessor calculatedMaxLength: number | null;
    protected accessor calculatedCharactersCount: number;
    connectedCallback(): void;
    resetState(): void;
    render(): import("lit-html").TemplateResult<1>;
    private readonly validInputTextTypes;
    private checkNeededArgument;
    private checkType;
    /**
     * Check if the value is not null or undefined
     *
     * @param value - The value to check if it is not null or undefined
     * @returns If the value is not null or undefined
     */
    private valueIsNotNullOrUndefined;
    private handleInputChange;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-input-text': DiscordInputText;
    }
}
//# sourceMappingURL=DiscordInputText.d.ts.map