var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property, state } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { DiscordComponentsError } from '../../util.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordInputText = (() => {
    let _classDecorators = [customElement('discord-input-text')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _type_decorators;
    let _type_initializers = [];
    let _type_extraInitializers = [];
    let _required_decorators;
    let _required_initializers = [];
    let _required_extraInitializers = [];
    let _label_decorators;
    let _label_initializers = [];
    let _label_extraInitializers = [];
    let _placeholder_decorators;
    let _placeholder_initializers = [];
    let _placeholder_extraInitializers = [];
    let _minLength_decorators;
    let _minLength_initializers = [];
    let _minLength_extraInitializers = [];
    let _maxLength_decorators;
    let _maxLength_initializers = [];
    let _maxLength_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let _defaultValue_decorators;
    let _defaultValue_initializers = [];
    let _defaultValue_extraInitializers = [];
    let _value_decorators;
    let _value_initializers = [];
    let _value_extraInitializers = [];
    let _hasWarning_decorators;
    let _hasWarning_initializers = [];
    let _hasWarning_extraInitializers = [];
    let _calculatedMaxLength_decorators;
    let _calculatedMaxLength_initializers = [];
    let _calculatedMaxLength_extraInitializers = [];
    let _calculatedCharactersCount_decorators;
    let _calculatedCharactersCount_initializers = [];
    let _calculatedCharactersCount_extraInitializers = [];
    var DiscordInputText = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _type_decorators = [property({ reflect: true, attribute: 'type', type: String })];
            _required_decorators = [property({ reflect: true, attribute: 'required', type: Boolean })];
            _label_decorators = [property({ reflect: true, attribute: 'label', type: String })];
            _placeholder_decorators = [property({ reflect: true, attribute: 'placeholder', type: String })];
            _minLength_decorators = [property({ reflect: true, attribute: 'min-length', type: Number })];
            _maxLength_decorators = [property({ reflect: true, attribute: 'max-length', type: Number })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            _defaultValue_decorators = [property({ type: String, reflect: true, attribute: 'default-value' })];
            _value_decorators = [state()];
            _hasWarning_decorators = [state()];
            _calculatedMaxLength_decorators = [state()];
            _calculatedCharactersCount_decorators = [state()];
            __esDecorate(this, null, _type_decorators, { kind: "accessor", name: "type", static: false, private: false, access: { has: obj => "type" in obj, get: obj => obj.type, set: (obj, value) => { obj.type = value; } }, metadata: _metadata }, _type_initializers, _type_extraInitializers);
            __esDecorate(this, null, _required_decorators, { kind: "accessor", name: "required", static: false, private: false, access: { has: obj => "required" in obj, get: obj => obj.required, set: (obj, value) => { obj.required = value; } }, metadata: _metadata }, _required_initializers, _required_extraInitializers);
            __esDecorate(this, null, _label_decorators, { kind: "accessor", name: "label", static: false, private: false, access: { has: obj => "label" in obj, get: obj => obj.label, set: (obj, value) => { obj.label = value; } }, metadata: _metadata }, _label_initializers, _label_extraInitializers);
            __esDecorate(this, null, _placeholder_decorators, { kind: "accessor", name: "placeholder", static: false, private: false, access: { has: obj => "placeholder" in obj, get: obj => obj.placeholder, set: (obj, value) => { obj.placeholder = value; } }, metadata: _metadata }, _placeholder_initializers, _placeholder_extraInitializers);
            __esDecorate(this, null, _minLength_decorators, { kind: "accessor", name: "minLength", static: false, private: false, access: { has: obj => "minLength" in obj, get: obj => obj.minLength, set: (obj, value) => { obj.minLength = value; } }, metadata: _metadata }, _minLength_initializers, _minLength_extraInitializers);
            __esDecorate(this, null, _maxLength_decorators, { kind: "accessor", name: "maxLength", static: false, private: false, access: { has: obj => "maxLength" in obj, get: obj => obj.maxLength, set: (obj, value) => { obj.maxLength = value; } }, metadata: _metadata }, _maxLength_initializers, _maxLength_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, _defaultValue_decorators, { kind: "accessor", name: "defaultValue", static: false, private: false, access: { has: obj => "defaultValue" in obj, get: obj => obj.defaultValue, set: (obj, value) => { obj.defaultValue = value; } }, metadata: _metadata }, _defaultValue_initializers, _defaultValue_extraInitializers);
            __esDecorate(this, null, _value_decorators, { kind: "accessor", name: "value", static: false, private: false, access: { has: obj => "value" in obj, get: obj => obj.value, set: (obj, value) => { obj.value = value; } }, metadata: _metadata }, _value_initializers, _value_extraInitializers);
            __esDecorate(this, null, _hasWarning_decorators, { kind: "accessor", name: "hasWarning", static: false, private: false, access: { has: obj => "hasWarning" in obj, get: obj => obj.hasWarning, set: (obj, value) => { obj.hasWarning = value; } }, metadata: _metadata }, _hasWarning_initializers, _hasWarning_extraInitializers);
            __esDecorate(this, null, _calculatedMaxLength_decorators, { kind: "accessor", name: "calculatedMaxLength", static: false, private: false, access: { has: obj => "calculatedMaxLength" in obj, get: obj => obj.calculatedMaxLength, set: (obj, value) => { obj.calculatedMaxLength = value; } }, metadata: _metadata }, _calculatedMaxLength_initializers, _calculatedMaxLength_extraInitializers);
            __esDecorate(this, null, _calculatedCharactersCount_decorators, { kind: "accessor", name: "calculatedCharactersCount", static: false, private: false, access: { has: obj => "calculatedCharactersCount" in obj, get: obj => obj.calculatedCharactersCount, set: (obj, value) => { obj.calculatedCharactersCount = value; } }, metadata: _metadata }, _calculatedCharactersCount_initializers, _calculatedCharactersCount_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordInputText = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        static styles = css `
		.discord-input-text {
			width: 100%;
			margin-bottom: 1em;
		}

		.discord-label-input-text {
			margin-bottom: 8px;
			font-size: 12px;
			line-height: 1.3333333333333333;
			font-weight: 700;
			text-transform: uppercase;
			letter-spacing: 0.02em;
			color: color-mix(in oklab, hsl(215 calc(1 * 8.8%) 73.3% / 1) 100%, black 0%);
		}

		.discord-text-input-warning-length {
			display: flex;
			align-items: center;
			font-size: 12px;
			line-height: 1.3333333333333333;
			font-weight: 700;
			text-transform: normal !important;
			letter-spacing: 0.02em;
			color: #b0b5bc;
			gap: 3px;
		}

		.discord-text-input-warning-error-text {
			font-size: 12px;
			font-weight: 500;
			font-style: italic;
			text-transform: none;
		}

		.discord-text-input-warning-bottom-error-text {
			font-size: 12px;
			line-height: 1.3333333333333333;
			font-weight: 400;
		}

		.discord-text-input-required {
			padding-left: 4px;
			color: hsl(359 calc(1 * 87.3%) 59.8% / 1);
		}

		.discord-text-input-container {
			width: 100%;
			display: flex;
			flex-direction: column;
			position: relative;
		}

		.discord-text-input-paragraph {
			width: 100%;
			resize: none;
			box-sizing: border-box;
			height: 83px;
			padding: 8px 38.92px 8px 8px;
			border-radius: 3px;
			border: medium;
			background-color: #1e1f22;
			color: #b0b5bc;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;
		}

		.discord-text-input-short {
			width: 100%;
			resize: none;
			box-sizing: border-box;
			height: 40px;
			padding: 8px 38.92px 8px 8px;
			border-radius: 3px;
			border: medium;
			background-color: #1e1f22;
			color: #b0b5bc;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;
		}

		input,
		textarea,
		::placeholder {
			font-weight: 400;
			font-size: 16px;
			color: #b0b5bc;
			opacity: 0.8;
		}

		.discord-text-input-paragraph::-webkit-scrollbar {
			width: 8px;
			margin-right: 5px;
			background-color: transparent;
		}

		.discord-text-input-paragraph::-webkit-scrollbar-track {
			background-color: rgba(255, 255, 255, 0.2);
			margin-right: 1em auto;
			border-radius: 10px;
		}

		.discord-text-input-paragraph::-webkit-scrollbar-thumb {
			border-radius: 10px;
			background-color: rgba(0, 0, 0, 0.5);
			margin-right: 1em auto;
		}

		.discord-text-input-textarea-max-length {
			font-size: small;
			position: absolute;
			display: flex;
			color: #b0b5bc;
			right: 0;
			bottom: 0;
			padding-right: 16px;
		}

		:host .discord-text-input-warning-length * {
			color: color-mix(in oklab, hsl(358 calc(1 * 92.9%) 72.4% / 1) 100%, black 0%) !important;
		}

		:host([light-theme]) .discord-text-input-warning-length * {
			color: color-mix(in oklab, hsl(360 calc(1 * 60.2%) 39.4% / 1) 100%, black 0%) !important;
		}

		:host([light-theme]) .discord-text-input-short,
		:host([light-theme]) .discord-label-input-text {
			color: color-mix(in oklab, hsl(228 calc(1 * 6%) 32.5% / 1) 100%, black 0%);
		}

		:host([light-theme]) .discord-text-input-paragraph,
		:host([light-theme]) .discord-text-input-short {
			background-color: rgb(253, 253, 253);
			border: 1px solid #b0b5bc;
		}

		:host([light-theme]) input,
		:host([light-theme]) textarea,
		:host([light-theme]) ::placeholder {
			font-weight: 400;
			font-size: 16px;
			color: color-mix(in oklab, hsl(223 calc(1 * 6.7%) 20.6% / 1) 100%, black 0%);
			opacity: 0.8;
		}

		.discord-text-input-message-needed-input,
		.discord-text-input-message-needed-min-length {
			background-color: white;
			position: absolute;
			align-items: center;
			gap: 5px;
			left: 50%;
			transform: translateX(-50%);
			opacity: 0;
			display: none;
			transition: 0.5s;
			color: black;
			border-radius: 5px;
			text-align: center;
			font-family: system-ui;
			pointer-events: none;
			padding: 10px;
			min-width: 50%;
			border: black solid 1px;
			z-index: 25;
		}

		.discord-text-input-message-needed-input::after,
		.discord-text-input-message-needed-min-length::after {
			content: '';
			position: absolute;
			bottom: 100%; /* Positions the arrow above the div */
			left: 0;
			transform: translateX(50%);
			border-width: 10px !important; /* Arrow size */
			border-style: solid !important;
			border-color: transparent transparent white transparent !important; /* Arrow pointing up */
		}

		:host([light-theme]) .discord-text-input-message-needed-input::after,
		:host([light-theme]) .discord-text-input-message-needed-min-length::after {
			border-color: transparent transparent #bfbfbf transparent !important; /* Arrow pointing up */
		}

		.discord-text-input-message-needed-min-length::after {
			transform: translate(500%);
		}

		.discord-text-input-message-needed-min-length {
			left: 50% !important;
			width: max-content;
		}

		.icon {
			width: 25px;
			height: 25px;
			background-color: darkorange;
			border-radius: 5px;
			position: relative;
			display: flex;
			justify-content: center;
			align-items: center;
			color: white;
			font-weight: bold;
			font-size: 18px;
			line-height: 1;
			text-align: center;
		}

		.exclamation {
			display: flex;
			flex-direction: column;
			align-items: center;
			line-height: 1;
		}
	`;
        #type_accessor_storage = __runInitializers(this, _type_initializers, 'paragraph');
        /**
         * The type of input text
         */
        get type() { return this.#type_accessor_storage; }
        set type(value) { this.#type_accessor_storage = value; }
        #required_accessor_storage = (__runInitializers(this, _type_extraInitializers), __runInitializers(this, _required_initializers, false));
        /**
         * if the input text is required
         */
        get required() { return this.#required_accessor_storage; }
        set required(value) { this.#required_accessor_storage = value; }
        #label_accessor_storage = (__runInitializers(this, _required_extraInitializers), __runInitializers(this, _label_initializers, void 0));
        /**
         * The label of input text
         */
        get label() { return this.#label_accessor_storage; }
        set label(value) { this.#label_accessor_storage = value; }
        #placeholder_accessor_storage = (__runInitializers(this, _label_extraInitializers), __runInitializers(this, _placeholder_initializers, void 0));
        /**
         * The place of input text
         */
        get placeholder() { return this.#placeholder_accessor_storage; }
        set placeholder(value) { this.#placeholder_accessor_storage = value; }
        #minLength_accessor_storage = (__runInitializers(this, _placeholder_extraInitializers), __runInitializers(this, _minLength_initializers, 0));
        /**
         * The minimal length of input text
         */
        get minLength() { return this.#minLength_accessor_storage; }
        set minLength(value) { this.#minLength_accessor_storage = value; }
        #maxLength_accessor_storage = (__runInitializers(this, _minLength_extraInitializers), __runInitializers(this, _maxLength_initializers, 4_000));
        /**
         * The maximal length of input text
         */
        get maxLength() { return this.#maxLength_accessor_storage; }
        set maxLength(value) { this.#maxLength_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _maxLength_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        /**
         * The theme of modal
         */
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #defaultValue_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), __runInitializers(this, _defaultValue_initializers, ''));
        /**
         * The default value of modal
         */
        get defaultValue() { return this.#defaultValue_accessor_storage; }
        set defaultValue(value) { this.#defaultValue_accessor_storage = value; }
        #value_accessor_storage = (__runInitializers(this, _defaultValue_extraInitializers), __runInitializers(this, _value_initializers, ''));
        get value() { return this.#value_accessor_storage; }
        set value(value) { this.#value_accessor_storage = value; }
        #hasWarning_accessor_storage = (__runInitializers(this, _value_extraInitializers), __runInitializers(this, _hasWarning_initializers, false));
        get hasWarning() { return this.#hasWarning_accessor_storage; }
        set hasWarning(value) { this.#hasWarning_accessor_storage = value; }
        #calculatedMaxLength_accessor_storage = (__runInitializers(this, _hasWarning_extraInitializers), __runInitializers(this, _calculatedMaxLength_initializers, null));
        get calculatedMaxLength() { return this.#calculatedMaxLength_accessor_storage; }
        set calculatedMaxLength(value) { this.#calculatedMaxLength_accessor_storage = value; }
        #calculatedCharactersCount_accessor_storage = (__runInitializers(this, _calculatedMaxLength_extraInitializers), __runInitializers(this, _calculatedCharactersCount_initializers, 0));
        get calculatedCharactersCount() { return this.#calculatedCharactersCount_accessor_storage; }
        set calculatedCharactersCount(value) { this.#calculatedCharactersCount_accessor_storage = value; }
        connectedCallback() {
            super.connectedCallback();
            if (this.defaultValue) {
                this.value = this.defaultValue;
                this.calculatedCharactersCount = this.value.length;
            }
        }
        resetState() {
            this.hasWarning = false;
            this.calculatedMaxLength = null;
            this.calculatedCharactersCount = 0;
            if (this.defaultValue) {
                this.value = this.defaultValue;
            }
            else {
                this.value = '';
            }
        }
        render() {
            this.checkNeededArgument();
            this.checkType();
            return html `
			<div class="discord-input-text">
				<div class=${classMap({ 'discord-text-input-warning-length': this.hasWarning })}>
					<h2 class="discord-label-input-text">
						${this.label.slice(0, 45)}${when(this.required && !this.hasWarning, () => html `<span class="discord-text-input-required">*</span>`)}
					</h2>
					${when(this.hasWarning, () => html `<span class="discord-text-input-warning-length discord-text-input-warning-error-text">
								- Must be between ${this.minLength} and ${this.maxLength} in length.</span
							>`)}
				</div>
				<div class="discord-text-input-container">
					${when(this.type === 'paragraph', () => html `
							<div class="discord-text-input-container">
								<textarea
									@input=${(event) => this.handleInputChange(event)}
									.required=${this.required}
									.value=${this.value}
									class="discord-text-input-paragraph"
									type="text"
									minlength="${this.minLength}"
									maxlength="${this.maxLength}"
									placeholder="${ifDefined(this.placeholder)}"
									rows="3"
								></textarea>
								<div class="discord-text-input-textarea-max-length">
									<span
										>${when(this.valueIsNotNullOrUndefined(this.calculatedMaxLength), () => this.calculatedMaxLength, () => when(this.value, () => this.maxLength - this.value.length, () => this.maxLength))}</span
									>
								</div>
							</div>
						`)}
					${when(this.type === 'short', () => html `<input
								@input=${(event) => this.handleInputChange(event)}
								.required=${this.required}
								.value=${this.value}
								class="discord-text-input-short"
								type="text"
								minlength="${this.minLength}"
								maxlength="${this.maxLength}"
								placeholder="${ifDefined(this.placeholder)}"
								rows="3"
							/>`)}
				</div>
				${when(this.required, () => html `
						<div class="discord-text-input-message-needed-input">
							<div class="icon">
								<div class="exclamation">!</div>
							</div>
							<span>Please fill out this field.</span>
						</div>
					`)}
				${when(this.valueIsNotNullOrUndefined(this.minLength), () => html `
						<div class="discord-text-input-message-needed-min-length">
							<div class="icon">
								<div class="exclamation">!</div>
							</div>
							<span
								>Increase this text to ${this.minLength} characters or more. You are currently using ${this.calculatedCharactersCount}
								characters</span
							>
						</div>
					`)}
				<div class=${classMap({ 'discord-text-input-warning-length': this.hasWarning })}>
					<h2 class="discord-text-input-warning-length">
						${when(this.hasWarning && this.valueIsNotNullOrUndefined(this.minLength), () => html `<span class="discord-text-input-warning-bottom-error-text"
									>Must be ${this.minLength} characters or more in length.</span
								>`)}
					</h2>
				</div>
			</div>
		`;
        }
        validInputTextTypes = (__runInitializers(this, _calculatedCharactersCount_extraInitializers), new Set(['short', 'paragraph']));
        checkNeededArgument() {
            if (!this.label) {
                throw new DiscordComponentsError('Label is required to input text');
            }
            else if (!this.type) {
                throw new DiscordComponentsError('Type is required to input text');
            }
        }
        checkType() {
            if (typeof this.type !== 'string') {
                throw new TypeError('DiscordInputText `type` prop must be a string.');
            }
            else if (!this.validInputTextTypes.has(this.type)) {
                throw new RangeError("DiscordInputText `type` prop must be one of: 'short', 'paragraph'");
            }
        }
        /**
         * Check if the value is not null or undefined
         *
         * @param value - The value to check if it is not null or undefined
         * @returns If the value is not null or undefined
         */
        valueIsNotNullOrUndefined(value) {
            return value !== undefined && value !== null;
        }
        handleInputChange(event) {
            const inputedText = event?.target;
            this.value = inputedText instanceof HTMLTextAreaElement || inputedText instanceof HTMLInputElement ? inputedText.value : '';
            if (inputedText instanceof HTMLTextAreaElement || inputedText instanceof HTMLInputElement) {
                const newLengthValue = inputedText.value.length;
                if (newLengthValue === 0 && this.minLength === 0 && this.valueIsNotNullOrUndefined(this.maxLength) && this.required) {
                    this.hasWarning = true;
                }
                else {
                    this.hasWarning = newLengthValue < this.minLength;
                }
                this.calculatedMaxLength = this.maxLength - newLengthValue;
                this.calculatedCharactersCount = newLengthValue;
            }
            const messageNeeded = this.shadowRoot?.querySelector('div.discord-text-input-message-needed-input');
            const messageNeededMinLength = this.shadowRoot?.querySelector('div.discord-text-input-message-needed-min-length');
            if (inputedText.value.length >= this.minLength &&
                messageNeededMinLength instanceof HTMLDivElement &&
                messageNeededMinLength.style.display) {
                messageNeededMinLength.style.opacity = '0';
                globalThis.setTimeout(() => {
                    messageNeededMinLength.style.display = '';
                }, 1_000);
            }
            if (messageNeeded instanceof HTMLDivElement && messageNeeded.style.display) {
                messageNeeded.style.opacity = '0';
                globalThis.setTimeout(() => {
                    messageNeeded.style.display = '';
                }, 1_000);
            }
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordInputText = _classThis;
})();
export { DiscordInputText };
//# sourceMappingURL=DiscordInputText.js.map