var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { defaultDiscordAvatars } from '../../config.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import GuildBadge from '../svgs/GuildBadge.js';
import PartnerBadgeOverlay from '../svgs/PartnerBadgeOverlay.js';
import VerifiedBadgeOverlay from '../svgs/VerifiedBadgeOverlay.js';
let DiscordInvite = (() => {
    let _classDecorators = [customElement('discord-invite')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _icon_decorators;
    let _icon_initializers = [];
    let _icon_extraInitializers = [];
    let _name_decorators;
    let _name_initializers = [];
    let _name_extraInitializers = [];
    let _url_decorators;
    let _url_initializers = [];
    let _url_extraInitializers = [];
    let _online_decorators;
    let _online_initializers = [];
    let _online_extraInitializers = [];
    let _members_decorators;
    let _members_initializers = [];
    let _members_extraInitializers = [];
    let _verified_decorators;
    let _verified_initializers = [];
    let _verified_extraInitializers = [];
    let _partnered_decorators;
    let _partnered_initializers = [];
    let _partnered_extraInitializers = [];
    let _inviteTitle_decorators;
    let _inviteTitle_initializers = [];
    let _inviteTitle_extraInitializers = [];
    let _joinBtn_decorators;
    let _joinBtn_initializers = [];
    let _joinBtn_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordInvite = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _icon_decorators = [property()];
            _name_decorators = [property()];
            _url_decorators = [property()];
            _online_decorators = [property({ type: Number })];
            _members_decorators = [property({ type: Number })];
            _verified_decorators = [property({ type: Boolean })];
            _partnered_decorators = [property({ type: Boolean })];
            _inviteTitle_decorators = [property({ attribute: 'invite-title' })];
            _joinBtn_decorators = [property({ attribute: 'join-btn' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _icon_decorators, { kind: "accessor", name: "icon", static: false, private: false, access: { has: obj => "icon" in obj, get: obj => obj.icon, set: (obj, value) => { obj.icon = value; } }, metadata: _metadata }, _icon_initializers, _icon_extraInitializers);
            __esDecorate(this, null, _name_decorators, { kind: "accessor", name: "name", static: false, private: false, access: { has: obj => "name" in obj, get: obj => obj.name, set: (obj, value) => { obj.name = value; } }, metadata: _metadata }, _name_initializers, _name_extraInitializers);
            __esDecorate(this, null, _url_decorators, { kind: "accessor", name: "url", static: false, private: false, access: { has: obj => "url" in obj, get: obj => obj.url, set: (obj, value) => { obj.url = value; } }, metadata: _metadata }, _url_initializers, _url_extraInitializers);
            __esDecorate(this, null, _online_decorators, { kind: "accessor", name: "online", static: false, private: false, access: { has: obj => "online" in obj, get: obj => obj.online, set: (obj, value) => { obj.online = value; } }, metadata: _metadata }, _online_initializers, _online_extraInitializers);
            __esDecorate(this, null, _members_decorators, { kind: "accessor", name: "members", static: false, private: false, access: { has: obj => "members" in obj, get: obj => obj.members, set: (obj, value) => { obj.members = value; } }, metadata: _metadata }, _members_initializers, _members_extraInitializers);
            __esDecorate(this, null, _verified_decorators, { kind: "accessor", name: "verified", static: false, private: false, access: { has: obj => "verified" in obj, get: obj => obj.verified, set: (obj, value) => { obj.verified = value; } }, metadata: _metadata }, _verified_initializers, _verified_extraInitializers);
            __esDecorate(this, null, _partnered_decorators, { kind: "accessor", name: "partnered", static: false, private: false, access: { has: obj => "partnered" in obj, get: obj => obj.partnered, set: (obj, value) => { obj.partnered = value; } }, metadata: _metadata }, _partnered_initializers, _partnered_extraInitializers);
            __esDecorate(this, null, _inviteTitle_decorators, { kind: "accessor", name: "inviteTitle", static: false, private: false, access: { has: obj => "inviteTitle" in obj, get: obj => obj.inviteTitle, set: (obj, value) => { obj.inviteTitle = value; } }, metadata: _metadata }, _inviteTitle_initializers, _inviteTitle_extraInitializers);
            __esDecorate(this, null, _joinBtn_decorators, { kind: "accessor", name: "joinBtn", static: false, private: false, access: { has: obj => "joinBtn" in obj, get: obj => obj.joinBtn, set: (obj, value) => { obj.joinBtn = value; } }, metadata: _metadata }, _joinBtn_initializers, _joinBtn_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordInvite = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			background-color: #2f3136;
			border-radius: 4px;
			padding: 16px;
			max-width: 432px;
			min-width: 160px;
			width: 100%;
			box-sizing: border-box;
			display: flex;
			flex-direction: column;
		}

		:host([light-theme]) {
			background-color: #f2f3f5;
		}

		:host .discord-invite-header {
			font-weight: 700;
			font-size: 12px;
			line-height: 16px;
			margin-bottom: 12px;
			white-space: nowrap;
			text-overflow: ellipsis;
			overflow: hidden;
			text-transform: uppercase;
			color: #b9bbbe;
		}

		:host([light-theme]) .discord-invite-header {
			color: #4f5660;
		}

		:host .discord-invite-root {
			display: flex;
			flex-flow: row wrap;
			gap: 16px;
		}

		:host .discord-invite-icon {
			background-color: #36393f;
			border-radius: 15px;
			margin-right: 16px;
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			width: 50px;
			height: 50px;
		}

		:host([light-theme]) .discord-invite-icon {
			background-color: #fff;
		}

		:host .discord-invite-info {
			font-family: 'gg sans', 'Noto Sans', WhitneyMedium, Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;
			display: flex;
			flex: 1000 0 auto;
			align-items: center;
			max-width: 100%;
			display: flex;
		}

		.discord-invite-info-text-ellipsis {
			overflow: hidden;
			text-overflow: ellipsis;
		}

		:host .discord-invite-title {
			white-space: nowrap;
			text-overflow: ellipsis;
			overflow: hidden;
			margin-bottom: 2px;
			color: white;
			font-size: 16px;
			line-height: 20px;
			font-weight: 700;
			display: flex;
			flex-direction: row;
		}

		:host([light-theme]) .discord-invite-title {
			color: #060607;
		}

		:host .discord-invite-name {
			flex: 1 1 auto;
			overflow: hidden;
			text-overflow: ellipsis;
			white-space: nowrap;
		}

		:host .discord-invite-counts {
			display: flex;
			align-items: center;
			flex-wrap: wrap;
			font-size: 14px;
			font-weight: 600;
			text-overflow: ellipsis;
			overflow: hidden;
			color: #b9bbbe;
			line-height: 16px;
		}

		:host .discord-invite-counts-info {
			text-overflow: ellipsis;
			overflow: hidden;
			display: flex;
			align-items: center;
		}

		:host .discord-invite-status {
			display: block;
			margin-right: 4px;
			width: 8px;
			height: 8px;
			border-radius: 50%;
			background-color: #747f8d;
		}

		:host .discord-invite-status-online {
			background-color: #3ba55d;
		}

		:host .discord-invite-count {
			-webkit-box-flex: 0;
			-ms-flex: 0 1 auto;
			flex: 0 1 auto;
			margin-right: 8px;
			color: #b9bbbe;
			white-space: nowrap;
			text-overflow: ellipsis;
			overflow: hidden;
		}

		:host .discord-invite-join {
			display: flex;
			justify-content: center;
			align-items: center;
			height: 40px;
			padding: 0 20px;
			align-self: center;
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			line-height: 20px;
			border-radius: 3px;
			font-size: 14px;
			font-weight: 600;
			color: white !important;
			background-color: #3ba55d;
			-webkit-transition: background-color 0.17s ease;
			transition: background-color 0.17s ease;
			text-decoration: none;
			box-sizing: border-box;
			flex: 1 0 auto;
		}

		:host .discord-invite-join:hover {
			background-color: #2d7d46;
		}

		:host .discord-invite-badge {
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			margin-right: 8px;
			width: 16px;
			height: 16px;
			align-self: center;
			position: relative;
		}

		:host .discord-invite-badge-verified {
			color: #3ba55d;
		}

		:host .discord-invite-badge-partnered {
			color: #5865f2;
		}

		:host .discord-invite-badge-container {
			position: absolute;
			top: -0.05px;
			left: 0.05px;
			right: 0;
			bottom: 0;
			display: flex;
			align-items: center;
			justify-content: center;
			pointer-events: none;
			color: white;
		}

		:host([light-theme]) .discord-invite-counts,
		:host([light-theme]) .discord-invite-count {
			color: #4f5660;
		}
	`;
        #icon_accessor_storage = __runInitializers(this, _icon_initializers, defaultDiscordAvatars.blue);
        /**
         * The server icon to display for the invite.
         */
        get icon() { return this.#icon_accessor_storage; }
        set icon(value) { this.#icon_accessor_storage = value; }
        #name_accessor_storage = (__runInitializers(this, _icon_extraInitializers), __runInitializers(this, _name_initializers, 'Discord Server'));
        /**
         * The server's name.
         *
         * @defaultValue 'Discord Server'
         */
        get name() { return this.#name_accessor_storage; }
        set name(value) { this.#name_accessor_storage = value; }
        #url_accessor_storage = (__runInitializers(this, _name_extraInitializers), __runInitializers(this, _url_initializers, void 0));
        /**
         * The URL to open when you click on the join button.
         */
        get url() { return this.#url_accessor_storage; }
        set url(value) { this.#url_accessor_storage = value; }
        #online_accessor_storage = (__runInitializers(this, _url_extraInitializers), __runInitializers(this, _online_initializers, 0));
        /**
         * The number of members online on the server.
         *
         * @defaultValue 0
         */
        get online() { return this.#online_accessor_storage; }
        set online(value) { this.#online_accessor_storage = value; }
        #members_accessor_storage = (__runInitializers(this, _online_extraInitializers), __runInitializers(this, _members_initializers, 0));
        /**
         * The number of members on the server.
         *
         * @defaultValue 0
         */
        get members() { return this.#members_accessor_storage; }
        set members(value) { this.#members_accessor_storage = value; }
        #verified_accessor_storage = (__runInitializers(this, _members_extraInitializers), __runInitializers(this, _verified_initializers, false));
        /**
         * Whether the server is verified.
         * Only works if `partnered` is `false` or `undefined`.
         */
        get verified() { return this.#verified_accessor_storage; }
        set verified(value) { this.#verified_accessor_storage = value; }
        #partnered_accessor_storage = (__runInitializers(this, _verified_extraInitializers), __runInitializers(this, _partnered_initializers, false));
        /**
         * Whether the server is partnered.
         * Only works if `verified` is `false` or `undefined`.
         */
        get partnered() { return this.#partnered_accessor_storage; }
        set partnered(value) { this.#partnered_accessor_storage = value; }
        #inviteTitle_accessor_storage = (__runInitializers(this, _partnered_extraInitializers), __runInitializers(this, _inviteTitle_initializers, "You've been invited to join a server"));
        /**
         * Invitation embed title.
         *
         * @defaultValue "You've been invited to join a server"
         */
        get inviteTitle() { return this.#inviteTitle_accessor_storage; }
        set inviteTitle(value) { this.#inviteTitle_accessor_storage = value; }
        #joinBtn_accessor_storage = (__runInitializers(this, _inviteTitle_extraInitializers), __runInitializers(this, _joinBtn_initializers, 'Join'));
        /**
         * The join button.
         *
         * @defaultValue 'Join'
         */
        get joinBtn() { return this.#joinBtn_accessor_storage; }
        set joinBtn(value) { this.#joinBtn_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _joinBtn_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        render() {
            return html `<div class="discord-invite-header">${this.inviteTitle}</div>
			<div class="discord-invite-root">
				<div class="discord-invite-info">
					<img class="discord-invite-icon" src=${ifDefined(this.icon)} alt=${ifDefined(this.name)} />
					<div class="discord-invite-info-text-ellipsis">
						<div class="discord-invite-title">
							${when((this.verified && !this.partnered) || (!this.verified && this.partnered), () => html `<div class="discord-invite-badge">
										${GuildBadge({
                'aria-label': this.partnered ? 'Discord Partner' : 'Verified',
                class: `discord-invite-badge-${this.partnered ? 'partnered' : 'verified'}`
            })}
										<div class="discord-invite-badge-container">
											${this.partnered ? PartnerBadgeOverlay() : VerifiedBadgeOverlay()}
										</div>
									</div>`)}
							<span class="discord-invite-name">${this.name}</span>
						</div>
						<div class="discord-invite-counts">
							<div class="discord-invite-counts-info">
								<i class="discord-invite-status discord-invite-status-online"></i>
								<span class="discord-invite-count">${this.online.toLocaleString()} Online</span>
							</div>
							<div class="discord-invite-counts-info">
								<i class="discord-invite-status"></i>
								<span class="discord-invite-count">${this.members.toLocaleString()} Members</span>
							</div>
						</div>
					</div>
				</div>
				<a class="discord-invite-join" href=${ifDefined(this.url)} target="_blank" rel="noopener noreferrer">${this.joinBtn}</a>
			</div>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordInvite = _classThis;
})();
export { DiscordInvite };
//# sourceMappingURL=DiscordInvite.js.map