import { LitElement } from 'lit';
import type { LightTheme } from '../../types.js';
export declare class DiscordLink extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    accessor lightTheme: boolean;
    /**
     * The URL to link
     *
     * @example
     * ```ts
     * 'https://example.com/example.txt'
     * ```
     */
    accessor href: string;
    /**
     * The `<a>` tag {@link https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#rel | `rel`}
     */
    accessor rel: string;
    /**
     * The `<a>` tag {@link https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#target | `target`}
     */
    accessor target: '_blank' | '_parent' | '_self' | '_top';
    /**
     * The `<a>` tag {@link https://developer.mozilla.org/en-US/docs/Web/HTML/Element/a#type | `type`}
     */
    accessor type: string;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-link': DiscordLink;
    }
}
//# sourceMappingURL=DiscordLink.d.ts.map