import { LitElement } from 'lit';
import type { LightTheme } from '../../types.js';
export declare class DiscordMention extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * Whether this entire message block should be highlighted (to emulate the "logged in user" being pinged).
     */
    accessor highlight: boolean;
    /**
     * The type of mention this should be. This will prepend the proper prefix character.
     * Valid values:
     * - `'user'`
     * - `'channel'`
     * - `'role'`
     * - `'voice'`
     * - `'locked'`
     * - `'thread'`
     * - `'forum'`
     * - `'slash'`
     * - `'server-guide'`
     * - `'channels-and-roles'`
     * - `'customize-community'`
     */
    accessor type: 'channel' | 'channels-and-roles' | 'customize-community' | 'forum' | 'locked' | 'role' | 'server-guide' | 'slash' | 'thread' | 'user' | 'voice';
    accessor color: string;
    setHoverColor: () => void;
    resetHoverColor: () => void;
    accessor lightTheme: boolean;
    connectedCallback(): void;
    disconnectedCallback(): void;
    protected willUpdate(): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-mention': DiscordMention;
    }
}
//# sourceMappingURL=DiscordMention.d.ts.map