var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { choose } from 'lit/directives/choose.js';
import { hexToRgba } from '../../hex-to-rgba.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import ChannelForum from '../svgs/ChannelForum.js';
import ChannelIcon from '../svgs/ChannelIcon.js';
import ChannelThread from '../svgs/ChannelThread.js';
import ChannelsAndRoles from '../svgs/ChannelsAndRoles.js';
import CustomizeCommunity from '../svgs/CustomizeCommunity.js';
import LockedVoiceChannel from '../svgs/LockedVoiceChannel.js';
import ServerGuide from '../svgs/ServerGuide.js';
import VoiceChannel from '../svgs/VoiceChannel.js';
let DiscordMention = (() => {
    let _classDecorators = [customElement('discord-mention')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _highlight_decorators;
    let _highlight_initializers = [];
    let _highlight_extraInitializers = [];
    let _type_decorators;
    let _type_initializers = [];
    let _type_extraInitializers = [];
    let _color_decorators;
    let _color_initializers = [];
    let _color_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordMention = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _highlight_decorators = [property({ type: Boolean, reflect: true })];
            _type_decorators = [property({ reflect: true })];
            _color_decorators = [property({ reflect: true })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme, subscribe: true }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _highlight_decorators, { kind: "accessor", name: "highlight", static: false, private: false, access: { has: obj => "highlight" in obj, get: obj => obj.highlight, set: (obj, value) => { obj.highlight = value; } }, metadata: _metadata }, _highlight_initializers, _highlight_extraInitializers);
            __esDecorate(this, null, _type_decorators, { kind: "accessor", name: "type", static: false, private: false, access: { has: obj => "type" in obj, get: obj => obj.type, set: (obj, value) => { obj.type = value; } }, metadata: _metadata }, _type_initializers, _type_extraInitializers);
            __esDecorate(this, null, _color_decorators, { kind: "accessor", name: "color", static: false, private: false, access: { has: obj => "color" in obj, get: obj => obj.color, set: (obj, value) => { obj.color = value; } }, metadata: _metadata }, _color_initializers, _color_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordMention = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			color: #e3e7f8;
			background-color: hsla(235, 85.6%, 64.7%, 0.3);
			font-weight: 500;
			padding: 0 2px;
			border-radius: 3px;
			unicode-bidi: -moz-plaintext;
			unicode-bidi: plaintext;
			-webkit-transition:
				background-color 50ms ease-out,
				color 50ms ease-out;
			transition:
				background-color 50ms ease-out,
				color 50ms ease-out;
			cursor: pointer;
		}

		:host([type='role']) {
			background-color: rgba(#e3e7f8, 0.1);
		}

		:host([type='channel']) {
			position: relative;
		}

		:host([type='voice']),
		:host([type='locked']),
		:host([type='thread']),
		:host([type='forum']) {
			position: relative;
		}

		:host(:hover) {
			color: #fff;
			background-color: hsl(235, 85.6%, 64.7%);
		}

		:host([highlight][type='user']:hover) {
			text-decoration: underline;
			text-underline-offset: 1px;
		}

		:host([light-theme]) {
			color: #5865f2;
			background-color: hsla(235, 85.6%, 64.7%, 0.15);
		}

		:host([light-theme]:hover) {
			color: #ffffff;
			background-color: hsl(235, 85.6%, 64.7%);
		}

		.discord-mention-icon {
			width: 1rem;
			height: 1rem;
			margin-right: 4px;
			vertical-align: middle;
			margin-bottom: 0.2rem;
		}

		.no-wrap {
			white-space: nowrap;
		}
	`;
        #highlight_accessor_storage = __runInitializers(this, _highlight_initializers, false);
        /**
         * Whether this entire message block should be highlighted (to emulate the "logged in user" being pinged).
         */
        get highlight() { return this.#highlight_accessor_storage; }
        set highlight(value) { this.#highlight_accessor_storage = value; }
        #type_accessor_storage = (__runInitializers(this, _highlight_extraInitializers), __runInitializers(this, _type_initializers, 'user'));
        /**
         * The type of mention this should be. This will prepend the proper prefix character.
         * Valid values:
         * - `'user'`
         * - `'channel'`
         * - `'role'`
         * - `'voice'`
         * - `'locked'`
         * - `'thread'`
         * - `'forum'`
         * - `'slash'`
         * - `'server-guide'`
         * - `'channels-and-roles'`
         * - `'customize-community'`
         */
        get type() { return this.#type_accessor_storage; }
        set type(value) { this.#type_accessor_storage = value; }
        #color_accessor_storage = (__runInitializers(this, _type_extraInitializers), __runInitializers(this, _color_initializers, void 0));
        get color() { return this.#color_accessor_storage; }
        set color(value) { this.#color_accessor_storage = value; }
        setHoverColor = (__runInitializers(this, _color_extraInitializers), () => {
            if (this.color) {
                this.style.backgroundColor = hexToRgba(this.color, 0.3);
            }
        });
        resetHoverColor = () => {
            if (this.color) {
                this.style.backgroundColor = hexToRgba(this.color, 0.1);
            }
        };
        #lightTheme_accessor_storage = __runInitializers(this, _lightTheme_initializers, false);
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        connectedCallback() {
            super.connectedCallback();
            if (this.color && this.type === 'role') {
                this.addEventListener('mouseover', this.setHoverColor);
                this.addEventListener('mouseout', this.resetHoverColor);
            }
        }
        disconnectedCallback() {
            this.removeEventListener('mouseover', this.setHoverColor);
            this.removeEventListener('mouseout', this.resetHoverColor);
            super.disconnectedCallback();
        }
        willUpdate() {
            if (this.color) {
                this.style.color = this.color;
                if (this.type === 'role')
                    this.style.backgroundColor = hexToRgba(this.color, 0.1);
            }
        }
        render() {
            return html `<span class="no-wrap"
				>${choose(this.type, [
                ['channel', () => ChannelIcon()],
                ['user', () => html `@`],
                ['role', () => html `@`],
                ['voice', () => VoiceChannel()],
                ['locked', () => LockedVoiceChannel()],
                ['thread', () => ChannelThread()],
                ['forum', () => ChannelForum()],
                ['server-guide', () => ServerGuide()],
                ['channels-and-roles', () => ChannelsAndRoles()],
                ['customize-community', () => CustomizeCommunity()],
                ['slash', () => html `/`]
            ])}</span
			><slot></slot>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordMention = _classThis;
})();
export { DiscordMention };
//# sourceMappingURL=DiscordMention.js.map