var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { avatars, profiles } from '../../config.js';
import { handleTimestamp } from '../../util.js';
import '../discord-author-info/DiscordAuthorInfo.js';
import { messagesCompactMode, messagesLightTheme, messagesNoBackground } from '../discord-messages/DiscordMessages.js';
import Ephemeral from '../svgs/Ephemeral.js';
let DiscordMessage = (() => {
    let _classDecorators = [customElement('discord-message')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _profile_decorators;
    let _profile_initializers = [];
    let _profile_extraInitializers = [];
    let _author_decorators;
    let _author_initializers = [];
    let _author_extraInitializers = [];
    let _avatar_decorators;
    let _avatar_initializers = [];
    let _avatar_extraInitializers = [];
    let _bot_decorators;
    let _bot_initializers = [];
    let _bot_extraInitializers = [];
    let _server_decorators;
    let _server_initializers = [];
    let _server_extraInitializers = [];
    let _officialApp_decorators;
    let _officialApp_initializers = [];
    let _officialApp_extraInitializers = [];
    let _verified_decorators;
    let _verified_initializers = [];
    let _verified_extraInitializers = [];
    let _op_decorators;
    let _op_initializers = [];
    let _op_extraInitializers = [];
    let _edited_decorators;
    let _edited_initializers = [];
    let _edited_extraInitializers = [];
    let _roleColor_decorators;
    let _roleColor_initializers = [];
    let _roleColor_extraInitializers = [];
    let _roleIcon_decorators;
    let _roleIcon_initializers = [];
    let _roleIcon_extraInitializers = [];
    let _roleName_decorators;
    let _roleName_initializers = [];
    let _roleName_extraInitializers = [];
    let _clanIcon_decorators;
    let _clanIcon_initializers = [];
    let _clanIcon_extraInitializers = [];
    let _clanTag_decorators;
    let _clanTag_initializers = [];
    let _clanTag_extraInitializers = [];
    let _highlight_decorators;
    let _highlight_initializers = [];
    let _highlight_extraInitializers = [];
    let _ephemeral_decorators;
    let _ephemeral_initializers = [];
    let _ephemeral_extraInitializers = [];
    let _timestamp_decorators;
    let _timestamp_initializers = [];
    let _timestamp_extraInitializers = [];
    let _twentyFour_decorators;
    let _twentyFour_initializers = [];
    let _twentyFour_extraInitializers = [];
    let _messageBodyOnly_decorators;
    let _messageBodyOnly_initializers = [];
    let _messageBodyOnly_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _noBackground_decorators;
    let _noBackground_initializers = [];
    let _noBackground_extraInitializers = [];
    let _hasThread_decorators;
    let _hasThread_initializers = [];
    let _hasThread_extraInitializers = [];
    let _dismissMessageClicked_decorators;
    let _dismissMessageClicked_initializers = [];
    let _dismissMessageClicked_extraInitializers = [];
    var DiscordMessage = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _profile_decorators = [property()];
            _author_decorators = [property()];
            _avatar_decorators = [property()];
            _bot_decorators = [property({ type: Boolean })];
            _server_decorators = [property({ type: Boolean })];
            _officialApp_decorators = [property({ type: Boolean, attribute: 'official-app' })];
            _verified_decorators = [property({ type: Boolean })];
            _op_decorators = [property({ type: Boolean })];
            _edited_decorators = [property({ type: Boolean })];
            _roleColor_decorators = [property({ attribute: 'role-color' })];
            _roleIcon_decorators = [property({ attribute: 'role-icon' })];
            _roleName_decorators = [property({ attribute: 'role-name' })];
            _clanIcon_decorators = [property({ attribute: 'clan-icon' })];
            _clanTag_decorators = [property({ attribute: 'clan-tag' })];
            _highlight_decorators = [property({ type: Boolean, reflect: true })];
            _ephemeral_decorators = [property({ type: Boolean, reflect: true })];
            _timestamp_decorators = [property({
                    type: String,
                    converter: (value) => handleTimestamp(value, false, false),
                    attribute: true
                })];
            _twentyFour_decorators = [property({ type: Boolean, attribute: 'twenty-four' })];
            _messageBodyOnly_decorators = [property({ type: Boolean, attribute: 'message-body-only' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            _compactMode_decorators = [consume({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            _noBackground_decorators = [consume({ context: messagesNoBackground }), property({ type: Boolean, reflect: true, attribute: 'no-background' })];
            _hasThread_decorators = [property({ type: Boolean, reflect: true, attribute: 'has-thread' })];
            _dismissMessageClicked_decorators = [property({ reflect: false, attribute: 'dismiss-message-clicked' })];
            __esDecorate(this, null, _profile_decorators, { kind: "accessor", name: "profile", static: false, private: false, access: { has: obj => "profile" in obj, get: obj => obj.profile, set: (obj, value) => { obj.profile = value; } }, metadata: _metadata }, _profile_initializers, _profile_extraInitializers);
            __esDecorate(this, null, _author_decorators, { kind: "accessor", name: "author", static: false, private: false, access: { has: obj => "author" in obj, get: obj => obj.author, set: (obj, value) => { obj.author = value; } }, metadata: _metadata }, _author_initializers, _author_extraInitializers);
            __esDecorate(this, null, _avatar_decorators, { kind: "accessor", name: "avatar", static: false, private: false, access: { has: obj => "avatar" in obj, get: obj => obj.avatar, set: (obj, value) => { obj.avatar = value; } }, metadata: _metadata }, _avatar_initializers, _avatar_extraInitializers);
            __esDecorate(this, null, _bot_decorators, { kind: "accessor", name: "bot", static: false, private: false, access: { has: obj => "bot" in obj, get: obj => obj.bot, set: (obj, value) => { obj.bot = value; } }, metadata: _metadata }, _bot_initializers, _bot_extraInitializers);
            __esDecorate(this, null, _server_decorators, { kind: "accessor", name: "server", static: false, private: false, access: { has: obj => "server" in obj, get: obj => obj.server, set: (obj, value) => { obj.server = value; } }, metadata: _metadata }, _server_initializers, _server_extraInitializers);
            __esDecorate(this, null, _officialApp_decorators, { kind: "accessor", name: "officialApp", static: false, private: false, access: { has: obj => "officialApp" in obj, get: obj => obj.officialApp, set: (obj, value) => { obj.officialApp = value; } }, metadata: _metadata }, _officialApp_initializers, _officialApp_extraInitializers);
            __esDecorate(this, null, _verified_decorators, { kind: "accessor", name: "verified", static: false, private: false, access: { has: obj => "verified" in obj, get: obj => obj.verified, set: (obj, value) => { obj.verified = value; } }, metadata: _metadata }, _verified_initializers, _verified_extraInitializers);
            __esDecorate(this, null, _op_decorators, { kind: "accessor", name: "op", static: false, private: false, access: { has: obj => "op" in obj, get: obj => obj.op, set: (obj, value) => { obj.op = value; } }, metadata: _metadata }, _op_initializers, _op_extraInitializers);
            __esDecorate(this, null, _edited_decorators, { kind: "accessor", name: "edited", static: false, private: false, access: { has: obj => "edited" in obj, get: obj => obj.edited, set: (obj, value) => { obj.edited = value; } }, metadata: _metadata }, _edited_initializers, _edited_extraInitializers);
            __esDecorate(this, null, _roleColor_decorators, { kind: "accessor", name: "roleColor", static: false, private: false, access: { has: obj => "roleColor" in obj, get: obj => obj.roleColor, set: (obj, value) => { obj.roleColor = value; } }, metadata: _metadata }, _roleColor_initializers, _roleColor_extraInitializers);
            __esDecorate(this, null, _roleIcon_decorators, { kind: "accessor", name: "roleIcon", static: false, private: false, access: { has: obj => "roleIcon" in obj, get: obj => obj.roleIcon, set: (obj, value) => { obj.roleIcon = value; } }, metadata: _metadata }, _roleIcon_initializers, _roleIcon_extraInitializers);
            __esDecorate(this, null, _roleName_decorators, { kind: "accessor", name: "roleName", static: false, private: false, access: { has: obj => "roleName" in obj, get: obj => obj.roleName, set: (obj, value) => { obj.roleName = value; } }, metadata: _metadata }, _roleName_initializers, _roleName_extraInitializers);
            __esDecorate(this, null, _clanIcon_decorators, { kind: "accessor", name: "clanIcon", static: false, private: false, access: { has: obj => "clanIcon" in obj, get: obj => obj.clanIcon, set: (obj, value) => { obj.clanIcon = value; } }, metadata: _metadata }, _clanIcon_initializers, _clanIcon_extraInitializers);
            __esDecorate(this, null, _clanTag_decorators, { kind: "accessor", name: "clanTag", static: false, private: false, access: { has: obj => "clanTag" in obj, get: obj => obj.clanTag, set: (obj, value) => { obj.clanTag = value; } }, metadata: _metadata }, _clanTag_initializers, _clanTag_extraInitializers);
            __esDecorate(this, null, _highlight_decorators, { kind: "accessor", name: "highlight", static: false, private: false, access: { has: obj => "highlight" in obj, get: obj => obj.highlight, set: (obj, value) => { obj.highlight = value; } }, metadata: _metadata }, _highlight_initializers, _highlight_extraInitializers);
            __esDecorate(this, null, _ephemeral_decorators, { kind: "accessor", name: "ephemeral", static: false, private: false, access: { has: obj => "ephemeral" in obj, get: obj => obj.ephemeral, set: (obj, value) => { obj.ephemeral = value; } }, metadata: _metadata }, _ephemeral_initializers, _ephemeral_extraInitializers);
            __esDecorate(this, null, _timestamp_decorators, { kind: "accessor", name: "timestamp", static: false, private: false, access: { has: obj => "timestamp" in obj, get: obj => obj.timestamp, set: (obj, value) => { obj.timestamp = value; } }, metadata: _metadata }, _timestamp_initializers, _timestamp_extraInitializers);
            __esDecorate(this, null, _twentyFour_decorators, { kind: "accessor", name: "twentyFour", static: false, private: false, access: { has: obj => "twentyFour" in obj, get: obj => obj.twentyFour, set: (obj, value) => { obj.twentyFour = value; } }, metadata: _metadata }, _twentyFour_initializers, _twentyFour_extraInitializers);
            __esDecorate(this, null, _messageBodyOnly_decorators, { kind: "accessor", name: "messageBodyOnly", static: false, private: false, access: { has: obj => "messageBodyOnly" in obj, get: obj => obj.messageBodyOnly, set: (obj, value) => { obj.messageBodyOnly = value; } }, metadata: _metadata }, _messageBodyOnly_initializers, _messageBodyOnly_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _noBackground_decorators, { kind: "accessor", name: "noBackground", static: false, private: false, access: { has: obj => "noBackground" in obj, get: obj => obj.noBackground, set: (obj, value) => { obj.noBackground = value; } }, metadata: _metadata }, _noBackground_initializers, _noBackground_extraInitializers);
            __esDecorate(this, null, _hasThread_decorators, { kind: "accessor", name: "hasThread", static: false, private: false, access: { has: obj => "hasThread" in obj, get: obj => obj.hasThread, set: (obj, value) => { obj.hasThread = value; } }, metadata: _metadata }, _hasThread_initializers, _hasThread_extraInitializers);
            __esDecorate(this, null, _dismissMessageClicked_decorators, { kind: "accessor", name: "dismissMessageClicked", static: false, private: false, access: { has: obj => "dismissMessageClicked" in obj, get: obj => obj.dismissMessageClicked, set: (obj, value) => { obj.dismissMessageClicked = value; } }, metadata: _metadata }, _dismissMessageClicked_initializers, _dismissMessageClicked_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordMessage = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			color: #dcddde;
			display: flex;
			flex-direction: column;
			font-size: 0.9em;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;

			position: relative;
			word-wrap: break-word;
			-webkit-user-select: text;
			-moz-user-select: text;
			-ms-user-select: text;
			user-select: text;
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			min-height: 1.375rem;
			padding-left: 1em;
			padding-right: 48px;
			margin-top: inherit;
			margin-bottom: inherit;
			line-height: 16px;
		}

		.discord-message-inner {
			display: flex;
			position: relative;
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
		}

		.discord-message-inner-center {
			align-items: center;
		}

		:host([message-body-only]) {
			margin-top: 0px !important;
			padding-top: 0.125rem !important;
			padding-bottom: 0.0625rem !important;
		}

		:host([highlight]),
		:host([ephemeral]) {
			padding-right: 5px;
			position: relative;
		}

		:host([highlight])::before,
		:host([ephemeral])::before {
			content: '';
			position: absolute;
			display: block;
			top: 0;
			left: 0;
			bottom: 0;
			pointer-events: none;
			width: 2px;
		}

		:host([highlight]) {
			background-color: rgba(250, 166, 26, 0.1);
		}

		:host([highlight][light-theme]) {
			background-color: rgba(250, 166, 26, 0.1);
		}

		:host([highlight])::before {
			background-color: #faa61a;
		}

		:host([light-theme][highlight])::before {
			background-color: #af7615;
		}

		:host([ephemeral]) {
			background-color: rgba(88, 101, 242, 0.05);
		}

		:host([ephemeral]:hover) {
			background-color: rgba(88, 101, 242, 0.1);
		}

		:host([ephemeral])::before {
			background-color: #5865f2;
		}

		:host([light-theme]) {
			color: #2e3338;
			border-color: #eceeef;
		}

		.discord-author-avatar {
			margin-right: 16px;
			margin-top: 5px;
			min-width: 40px;
			z-index: 1;
			display: flex;
		}

		.discord-author-avatar img {
			width: 40px;
			height: 40px;
			border-radius: 50%;
			cursor: pointer;
		}

		.discord-message-timestamp {
			color: #72767d;
			font-size: 12px;
			margin-left: 3px;
		}

		.discord-message-body-only-indent {
			width: 56px;
		}

		:host(:hover) .discord-message-timestamp-hover::before {
			content: attr(datetime);
		}

		:host([light-theme]) .discord-message-timestamp {
			color: #747f8d;
		}

		.discord-message-edited {
			color: #72767d;
			font-size: 10px;
		}

		:host([light-theme]) .discord-message-edited {
			color: #99aab5;
		}

		.discord-message-content {
			width: 100%;
			line-height: 160%;
			font-weight: normal;
			padding-top: 2px;
		}

		.discord-message-body {
			font-size: 1rem;
			font-weight: 400;
			word-break: break-word;
			position: relative;
		}

		:host([light-theme]) .discord-message-timestamp,
		:host([compact-mode]) .discord-message:hover .discord-message-timestamp {
			color: #99aab5;
		}

		:host([light-theme][compact-mode]).discord-message-timestamp {
			color: #d1d9de;
		}

		:host([compact-mode]) .discord-message-timestamp {
			display: inline-block;
			width: 3.1rem;
			text-align: right;
			font-size: 0.6875rem;
			line-height: 1.375rem;
			margin-right: 0.375rem;
			margin-left: 0;
			text-indent: 0;
		}

		:host([compact-mode]) .discord-message-body {
			line-height: 1.375rem;
			padding-left: 10px;
			margin-left: -6px;
		}

		:host([compact-mode]) .discord-message-compact-indent {
			padding-left: 10px;
		}

		:host .discord-message-markup {
			font-size: 1rem;
			line-height: 1.375rem;
			word-wrap: break-word;
			user-select: text;
			font-weight: 400;
			display: inline;
		}

		:host(:hover) {
			background-color: hsl(0 calc(1 * 0%) 0.8%/0.03);
		}

		:host([highlight]:hover) {
			background-color: hsl(40 calc(1 * 86.4%) 56.9%/0.08);
		}

		:host([has-thread]):after {
			width: 2rem;
			left: 2.2rem;
			top: 4.8rem;
			border-left: 2px solid #4f545c !important;
			border-bottom: 2px solid #4f545c !important;
			border-bottom-left-radius: 8px !important;
			bottom: 29px;
			content: '';
			position: absolute;
		}

		:host([light-theme][has-Thread]):after {
			border-color: #747f8d !important;
		}

		.discord-message-ephemeral {
			margin-top: 4px;
			font-size: 12px;
			font-weight: 400;
			color: #72767d;
		}

		:host([light-theme]) .discord-message-ephemeral {
			color: #747f8d;
		}

		.discord-message-ephemeral .discord-message-ephemeral-link {
			color: #00aff4;
			font-weight: 500;
			cursor: pointer;
		}

		.discord-message-ephemeral .discord-message-ephemeral-link:hover {
			text-decoration: underline;
		}

		.discord-message-ephemeral .discord-message-ephemeral-icon {
			margin-right: 4px;
			vertical-align: text-bottom;
		}
	`;
        #profile_accessor_storage = __runInitializers(this, _profile_initializers, undefined);
        /**
         * The id of the profile data to use.
         */
        get profile() { return this.#profile_accessor_storage; }
        set profile(value) { this.#profile_accessor_storage = value; }
        #author_accessor_storage = (__runInitializers(this, _profile_extraInitializers), __runInitializers(this, _author_initializers, 'User'));
        /**
         * The message author's username.
         *
         * @defaultValue 'User'
         */
        get author() { return this.#author_accessor_storage; }
        set author(value) { this.#author_accessor_storage = value; }
        #avatar_accessor_storage = (__runInitializers(this, _author_extraInitializers), __runInitializers(this, _avatar_initializers, undefined));
        /**
         * The message author's avatar. Can be an avatar shortcut, relative path, or external link.
         */
        get avatar() { return this.#avatar_accessor_storage; }
        set avatar(value) { this.#avatar_accessor_storage = value; }
        #bot_accessor_storage = (__runInitializers(this, _avatar_extraInitializers), __runInitializers(this, _bot_initializers, false));
        /**
         * Whether the message author is a bot or not.
         * Only works if `server` and `officialApp` is `false` or `undefined`.
         */
        get bot() { return this.#bot_accessor_storage; }
        set bot(value) { this.#bot_accessor_storage = value; }
        #server_accessor_storage = (__runInitializers(this, _bot_extraInitializers), __runInitializers(this, _server_initializers, false));
        /**
         * Whether the message author is a server crosspost webhook or not.
         * Only works if `bot` and `officialApp` is `false` or `undefined`.
         */
        get server() { return this.#server_accessor_storage; }
        set server(value) { this.#server_accessor_storage = value; }
        #officialApp_accessor_storage = (__runInitializers(this, _server_extraInitializers), __runInitializers(this, _officialApp_initializers, false));
        /**
         * Whether the message author is official app.
         * Only works if `bot` and `server` is `falns`
         */
        get officialApp() { return this.#officialApp_accessor_storage; }
        set officialApp(value) { this.#officialApp_accessor_storage = value; }
        #verified_accessor_storage = (__runInitializers(this, _officialApp_extraInitializers), __runInitializers(this, _verified_initializers, false));
        /**
         * Whether the bot is verified or not.
         * Only works if `bot` is `true`
         */
        get verified() { return this.#verified_accessor_storage; }
        set verified(value) { this.#verified_accessor_storage = value; }
        #op_accessor_storage = (__runInitializers(this, _verified_extraInitializers), __runInitializers(this, _op_initializers, false));
        /**
         * Whether the author is the original poster.
         */
        get op() { return this.#op_accessor_storage; }
        set op(value) { this.#op_accessor_storage = value; }
        #edited_accessor_storage = (__runInitializers(this, _op_extraInitializers), __runInitializers(this, _edited_initializers, false));
        /**
         * Whether the message has been edited or not.
         */
        get edited() { return this.#edited_accessor_storage; }
        set edited(value) { this.#edited_accessor_storage = value; }
        #roleColor_accessor_storage = (__runInitializers(this, _edited_extraInitializers), __runInitializers(this, _roleColor_initializers, undefined));
        /**
         * The message author's primary role color. Can be any [CSS color value](https://www.w3schools.com/cssref/css_colors_legal.asp).
         */
        get roleColor() { return this.#roleColor_accessor_storage; }
        set roleColor(value) { this.#roleColor_accessor_storage = value; }
        #roleIcon_accessor_storage = (__runInitializers(this, _roleColor_extraInitializers), __runInitializers(this, _roleIcon_initializers, undefined));
        /**
         * The message author's role icon URL.
         */
        get roleIcon() { return this.#roleIcon_accessor_storage; }
        set roleIcon(value) { this.#roleIcon_accessor_storage = value; }
        #roleName_accessor_storage = (__runInitializers(this, _roleIcon_extraInitializers), __runInitializers(this, _roleName_initializers, undefined));
        /**
         * The name of the role to use as alternative image text.
         */
        get roleName() { return this.#roleName_accessor_storage; }
        set roleName(value) { this.#roleName_accessor_storage = value; }
        #clanIcon_accessor_storage = (__runInitializers(this, _roleName_extraInitializers), __runInitializers(this, _clanIcon_initializers, undefined));
        /**
         * The clan's tag icon URL.
         */
        get clanIcon() { return this.#clanIcon_accessor_storage; }
        set clanIcon(value) { this.#clanIcon_accessor_storage = value; }
        #clanTag_accessor_storage = (__runInitializers(this, _clanIcon_extraInitializers), __runInitializers(this, _clanTag_initializers, undefined));
        /**
         * The name of the clan you are part of
         */
        get clanTag() { return this.#clanTag_accessor_storage; }
        set clanTag(value) { this.#clanTag_accessor_storage = value; }
        #highlight_accessor_storage = (__runInitializers(this, _clanTag_extraInitializers), __runInitializers(this, _highlight_initializers, false));
        /**
         * Whether to highlight this message.
         */
        get highlight() { return this.#highlight_accessor_storage; }
        set highlight(value) { this.#highlight_accessor_storage = value; }
        #ephemeral_accessor_storage = (__runInitializers(this, _highlight_extraInitializers), __runInitializers(this, _ephemeral_initializers, false));
        /**
         * Whether to make this message ephemeral.
         */
        get ephemeral() { return this.#ephemeral_accessor_storage; }
        set ephemeral(value) { this.#ephemeral_accessor_storage = value; }
        #timestamp_accessor_storage = (__runInitializers(this, _ephemeral_extraInitializers), __runInitializers(this, _timestamp_initializers, new Date()));
        /**
         * The timestamp to use for the message date.
         *
         * if {@link DiscordMessage.messageBodyOnly} is `true`, this will be shown in the gutter before the message on hover.
         */
        get timestamp() { return this.#timestamp_accessor_storage; }
        set timestamp(value) { this.#timestamp_accessor_storage = value; }
        #twentyFour_accessor_storage = (__runInitializers(this, _timestamp_extraInitializers), __runInitializers(this, _twentyFour_initializers, false));
        /**
         * Whether to use 24-hour format for the timestamp.
         */
        get twentyFour() { return this.#twentyFour_accessor_storage; }
        set twentyFour(value) { this.#twentyFour_accessor_storage = value; }
        #messageBodyOnly_accessor_storage = (__runInitializers(this, _twentyFour_extraInitializers), __runInitializers(this, _messageBodyOnly_initializers, false));
        get messageBodyOnly() { return this.#messageBodyOnly_accessor_storage; }
        set messageBodyOnly(value) { this.#messageBodyOnly_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _messageBodyOnly_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #noBackground_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _noBackground_initializers, false));
        get noBackground() { return this.#noBackground_accessor_storage; }
        set noBackground(value) { this.#noBackground_accessor_storage = value; }
        #hasThread_accessor_storage = (__runInitializers(this, _noBackground_extraInitializers), __runInitializers(this, _hasThread_initializers, false));
        get hasThread() { return this.#hasThread_accessor_storage; }
        set hasThread(value) { this.#hasThread_accessor_storage = value; }
        #dismissMessageClicked_accessor_storage = (__runInitializers(this, _hasThread_extraInitializers), __runInitializers(this, _dismissMessageClicked_initializers, () => { }));
        get dismissMessageClicked() { return this.#dismissMessageClicked_accessor_storage; }
        set dismissMessageClicked(value) { this.#dismissMessageClicked_accessor_storage = value; }
        willUpdate() {
            this.hasThread = Array.from(this.children).some((child) => child.tagName.toLowerCase() === 'discord-thread');
            this.highlight =
                this.highlight ||
                    Array.from(this.children).some((child) => child.tagName.toLowerCase() === 'discord-mention' &&
                        child.hasAttribute('highlight') &&
                        (child.type === 'user' || child.type === 'role'));
        }
        handleSpaceToDismissMessage(event) {
            if (event.code === 'Space') {
                event.preventDefault();
                event.stopPropagation();
                this.dismissMessageClicked?.();
            }
        }
        render() {
            const defaultData = {
                author: this.author,
                bot: this.bot,
                officialApp: this.officialApp,
                verified: this.verified,
                server: this.server,
                op: this.op,
                roleColor: this.roleColor,
                roleIcon: this.roleIcon,
                clanIcon: this.clanIcon,
                clanTag: this.clanTag,
                roleName: this.roleName
            };
            const profileData = (this.profile !== undefined && Reflect.get(profiles, this.profile)) || {};
            const profile = { ...defaultData, ...profileData, avatar: this.resolveAvatar(profileData.avatar ?? this.avatar) };
            const computedTimestamp = handleTimestamp(this.timestamp, this.compactMode, this.twentyFour) ?? undefined;
            return html `
			<slot name="reply"></slot>
			<div
				class=${classMap({
                'discord-message-inner': true,
                'discord-message-inner-center': this.messageBodyOnly
            })}
			>
				${when(this.compactMode && !this.messageBodyOnly, () => html `<time datetime="${ifDefined(computedTimestamp)}" class="discord-message-timestamp">${computedTimestamp}</time>`, () => null)}
				${when(this.messageBodyOnly, () => html `<time
							datetime="${ifDefined(computedTimestamp)}"
							class=${classMap({
                'discord-message-timestamp': true,
                'discord-message-timestamp-hover': true,
                'discord-message-body-only-indent': !this.compactMode
            })}
						></time>`, () => null)}
				${when(this.compactMode || this.messageBodyOnly, () => null, () => html `<div class="discord-author-avatar">
							<img src="${ifDefined(profile.avatar)}" alt="${ifDefined(profile.author)}" />
						</div>`)}

				<div class="discord-message-content">
					${when(this.compactMode || this.messageBodyOnly, () => null, () => html `
							<discord-author-info
								author=${profile.author ?? ''}
								?bot=${profile.bot ?? false}
								?server=${profile.server ?? false}
								?official-app=${profile.officialApp ?? false}
								?verified=${profile.verified ?? false}
								?op=${profile.op ?? false}
								role-color=${profile.roleColor ?? ''}
								role-icon=${profile.roleIcon ?? ''}
								role-name=${profile.roleName ?? ''}
								clan-icon=${profile.clanIcon ?? ''}
								clan-tag=${profile.clanTag ?? ''}
							></discord-author-info
							><time datetime="${ifDefined(computedTimestamp)}" class="discord-message-timestamp">${computedTimestamp}</time>
						`)}
					<div class="discord-message-body">
						${when(this.compactMode, () => html `<discord-author-info
									author=${profile.author ?? ''}
									?bot=${profile.bot ?? false}
									?server=${profile.server ?? false}
									?official-app=${profile.officialApp ?? false}
									?verified=${profile.verified ?? false}
									?op=${profile.op ?? false}
									role-color=${profile.roleColor ?? ''}
									role-icon=${profile.roleIcon ?? ''}
									role-name=${profile.roleName ?? ''}
									clan-icon=${profile.clanIcon ?? ''}
									clan-tag=${profile.clanTag ?? ''}
								></discord-author-info>`, () => null)}<span class="discord-message-markup"><slot></slot></span>
						${when(this.edited, () => html `<span class="discord-message-edited">(edited)</span>`, () => null)}
					</div>
					<div class="discord-message-compact-indent">
						<slot name="attachments"></slot>
						<slot name="embeds"></slot>
						<slot name="components"></slot>
						<slot name="reactions"></slot>
						<slot name="thread"></slot>
						${when(this.ephemeral, () => html `
								<div class="discord-message-ephemeral">
									${Ephemeral()} Only you can see this •
									<span
										role="button"
										class="discord-message-ephemeral-link"
										@click=${this.dismissMessageClicked}
										@keydown=${this.handleSpaceToDismissMessage}
										>Dismiss message</span
									>
								</div>
							`, () => null)}
					</div>
				</div>
			</div>
		`;
        }
        resolveAvatar(avatar) {
            return avatar === undefined ? avatars.default : (avatars[avatar] ?? avatar ?? avatars.default);
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _dismissMessageClicked_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordMessage = _classThis;
})();
export { DiscordMessage };
//# sourceMappingURL=DiscordMessage.js.map