import { LitElement } from 'lit';
import type { LightTheme } from '../../types.js';
export declare const messagesLightTheme: {
    __context__: boolean;
};
export declare const messagesCompactMode: {
    __context__: boolean;
};
export declare const messagesNoBackground: {
    __context__: boolean;
};
export declare class DiscordMessages extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * Whether to use light theme or not.
     */
    accessor lightTheme: boolean;
    /**
     * Whether to exclude the background or not.
     */
    accessor noBackground: boolean;
    /**
     * Whether to use compact mode or not.
     */
    accessor compactMode: boolean;
    /**
     * The type of channel this should be, this will be displayed above the message and only applies if {@link DiscordMessages.channelName} is set.
     * Valid values are: `text`, `forum`, `locked`, `thread`, and `voice`.
     */
    accessor channelType: 'forum' | 'locked' | 'text' | 'thread' | 'voice';
    /**
     * The name of the channel, this will be displayed above the message and only applies if {@link DiscordMessages.channelType} is set.
     */
    accessor channelName: string;
    connectedCallback(): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-messages': DiscordMessages;
    }
}
//# sourceMappingURL=DiscordMessages.d.ts.map