var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { createContext, provide } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { when } from 'lit/directives/when.js';
import { defaultBackground, defaultMode, defaultTheme } from '../../config.js';
import ChannelForum from '../svgs/ChannelForum.js';
import ChannelIcon from '../svgs/ChannelIcon.js';
import ChannelThread from '../svgs/ChannelThread.js';
import LockedVoiceChannel from '../svgs/LockedVoiceChannel.js';
import VoiceChannel from '../svgs/VoiceChannel.js';
export const messagesLightTheme = createContext('light-theme');
export const messagesCompactMode = createContext('compact-mode');
export const messagesNoBackground = createContext('no-background');
let DiscordMessages = (() => {
    let _classDecorators = [customElement('discord-messages')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let _noBackground_decorators;
    let _noBackground_initializers = [];
    let _noBackground_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _channelType_decorators;
    let _channelType_initializers = [];
    let _channelType_extraInitializers = [];
    let _channelName_decorators;
    let _channelName_initializers = [];
    let _channelName_extraInitializers = [];
    var DiscordMessages = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _lightTheme_decorators = [provide({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            _noBackground_decorators = [provide({ context: messagesNoBackground }), property({ type: Boolean, reflect: true, attribute: 'no-background' })];
            _compactMode_decorators = [provide({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            _channelType_decorators = [property({ reflect: true, attribute: 'channel-type' })];
            _channelName_decorators = [property({ reflect: true, attribute: 'channel-name' })];
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, _noBackground_decorators, { kind: "accessor", name: "noBackground", static: false, private: false, access: { has: obj => "noBackground" in obj, get: obj => obj.noBackground, set: (obj, value) => { obj.noBackground = value; } }, metadata: _metadata }, _noBackground_initializers, _noBackground_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _channelType_decorators, { kind: "accessor", name: "channelType", static: false, private: false, access: { has: obj => "channelType" in obj, get: obj => obj.channelType, set: (obj, value) => { obj.channelType = value; } }, metadata: _metadata }, _channelType_initializers, _channelType_extraInitializers);
            __esDecorate(this, null, _channelName_decorators, { kind: "accessor", name: "channelName", static: false, private: false, access: { has: obj => "channelName" in obj, get: obj => obj.channelName, set: (obj, value) => { obj.channelName = value; } }, metadata: _metadata }, _channelName_initializers, _channelName_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordMessages = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			color: #fff;
			background-color: #36393e;
			display: block;
			font-size: 16px;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;
			line-height: 170%;
			border: 1px solid rgba(255, 255, 255, 0.05);
		}

		:host([light-theme]) {
			color: #747f8d;
			background-color: #fff;
			border-color: #dedede;
		}

		:host([no-background]) {
			background-color: unset;
		}

		::slotted(*) {
			padding-top: 0.125rem;
			padding-bottom: 0.125rem;
		}

		::slotted(*:first-child) {
			margin-top: 0.5rem;
		}

		::slotted(*:not(:first-child)) {
			margin-top: 1.0625rem;
		}

		:host([compact-mode]) ::slotted(*:not(:first-child)) {
			margin-top: unset;
		}

		::slotted(*:last-child) {
			margin-bottom: 0.5rem;
			border-bottom-width: 0;
		}

		:host .discord-channel-header {
			display: flex;
			align-items: center;
			padding: 0.5rem 1rem;
			box-shadow:
				0 2px 0 0 rgba(0, 0, 0, 0.05),
				0 1.5px 0 0 rgba(0, 0, 0, 0.05),
				0 1px 0 0 rgba(0, 0, 0, 0.16);
		}

		:host .discord-channel-icon {
			height: 24px;
			width: auto;
			margin: 0 8px;
			position: relative;
			flex: 0 0 auto;
			color: #80848e;
		}

		:host([light-theme]) .discord-channel-icon {
			color: #6d6f78;
		}

		:host .discord-channel-name {
			margin: 0 8px 0 0;
			flex: 0 0 auto;
			min-width: auto;
		}
	`;
        #lightTheme_accessor_storage = __runInitializers(this, _lightTheme_initializers, false);
        /**
         * Whether to use light theme or not.
         */
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #noBackground_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), __runInitializers(this, _noBackground_initializers, false));
        /**
         * Whether to exclude the background or not.
         */
        get noBackground() { return this.#noBackground_accessor_storage; }
        set noBackground(value) { this.#noBackground_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _noBackground_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to use compact mode or not.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #channelType_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _channelType_initializers, void 0));
        /**
         * The type of channel this should be, this will be displayed above the message and only applies if {@link DiscordMessages.channelName} is set.
         * Valid values are: `text`, `forum`, `locked`, `thread`, and `voice`.
         */
        get channelType() { return this.#channelType_accessor_storage; }
        set channelType(value) { this.#channelType_accessor_storage = value; }
        #channelName_accessor_storage = (__runInitializers(this, _channelType_extraInitializers), __runInitializers(this, _channelName_initializers, void 0));
        /**
         * The name of the channel, this will be displayed above the message and only applies if {@link DiscordMessages.channelType} is set.
         */
        get channelName() { return this.#channelName_accessor_storage; }
        set channelName(value) { this.#channelName_accessor_storage = value; }
        connectedCallback() {
            super.connectedCallback();
            if (this.lightTheme || (defaultTheme === 'light' && this.lightTheme)) {
                this.lightTheme = true;
            }
            if (this.compactMode || (defaultMode === 'compact' && this.compactMode)) {
                this.compactMode = true;
            }
            if (this.noBackground || (defaultBackground === 'none' && this.noBackground)) {
                this.noBackground = true;
            }
        }
        render() {
            let channelIcon;
            switch (this.channelType) {
                case 'text':
                    channelIcon = html `${ChannelIcon()}`;
                    break;
                case 'voice':
                    channelIcon = html `${VoiceChannel()}`;
                    break;
                case 'locked':
                    channelIcon = html `${LockedVoiceChannel()}`;
                    break;
                case 'thread':
                    channelIcon = html `${ChannelThread()}`;
                    break;
                case 'forum':
                    channelIcon = html `${ChannelForum()}`;
                    break;
            }
            return html `
			${when(this.channelType && this.channelName, () => html `<div class="discord-channel-header">
						<div class="discord-channel-icon">${channelIcon}</div>
						<div class="discord-channel-name">${this.channelName}</div>
					</div>`)}
			<slot></slot>
		`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _channelName_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordMessages = _classThis;
})();
export { DiscordMessages };
//# sourceMappingURL=DiscordMessages.js.map