import { LitElement } from 'lit';
import { type Ref } from 'lit/directives/ref.js';
import type { LightTheme } from '../../types.js';
export declare class DiscordModal extends LitElement implements LightTheme {
    static readonly styles: import("lit").CSSResult;
    /**
     * The id of the profile data to use.
     */
    accessor profile: string | undefined;
    /**
     * The message author's username.
     *
     * @defaultValue 'User'
     */
    accessor author: string | undefined;
    /**
     * The modal's author's avatar. Can be an avatar shortcut, relative path, or external link.
     */
    accessor avatar: string | undefined;
    /**
     * The `id` property of the `dialog` component. This is used to open the modal from the button and should match with `modal-id` on the button.
     */
    accessor modalId: string;
    /**
     * The title of the modal, displayed at the top
     */
    accessor modalTitle: string;
    accessor submitForm: (...args: unknown[]) => void;
    accessor closeForm: (...args: unknown[]) => void;
    accessor lightTheme: boolean;
    accessor originalBodyOverflow: string;
    protected dialogRef: Ref<HTMLDialogElement>;
    protected handleClickCloseIcon(): void;
    protected handleFormSubmit(event: SubmitEvent): void;
    protected onCloseDialog(): void;
    protected render(): import("lit-html").TemplateResult<1>;
    private resolveAvatar;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-modal': DiscordModal;
    }
}
//# sourceMappingURL=DiscordModal.d.ts.map