import { LitElement } from 'lit';
export declare class DiscordOrderedList extends LitElement {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The starting number for the ordered list.
     *
     * You can set this to start the list at a specific number
     *
     * @defaultValue 1
     */
    accessor start: number;
    private accessor startLength;
    checkChildren(): void;
    /**
     * Checks how many children of `<discord-list-item>` this component has and updates
     * the {@link DiscordOrderedList.startLength | startLength} state.
     */
    protected willUpdate(): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-ordered-list': DiscordOrderedList;
    }
}
//# sourceMappingURL=DiscordOrderedList.d.ts.map