var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { css, html, LitElement } from 'lit';
import { customElement, property, state } from 'lit/decorators.js';
import { DiscordComponentsError } from '../../util.js';
let DiscordOrderedList = (() => {
    let _classDecorators = [customElement('discord-ordered-list')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _start_decorators;
    let _start_initializers = [];
    let _start_extraInitializers = [];
    let _startLength_decorators;
    let _startLength_initializers = [];
    let _startLength_extraInitializers = [];
    var DiscordOrderedList = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _start_decorators = [property({ type: Number, reflect: true })];
            _startLength_decorators = [state()];
            __esDecorate(this, null, _start_decorators, { kind: "accessor", name: "start", static: false, private: false, access: { has: obj => "start" in obj, get: obj => obj.start, set: (obj, value) => { obj.start = value; } }, metadata: _metadata }, _start_initializers, _start_extraInitializers);
            __esDecorate(this, null, _startLength_decorators, { kind: "accessor", name: "startLength", static: false, private: false, access: { has: obj => "startLength" in obj, get: obj => obj.startLength, set: (obj, value) => { obj.startLength = value; } }, metadata: _metadata }, _startLength_initializers, _startLength_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordOrderedList = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host > ol {
			list-style-image: initial;
			list-style-type: decimal;
			list-style-position: outside;
			margin-bottom: 0px;
			margin-top: 4px;
			margin-right: 0px;
			margin-left: calc(0.4em + 0.6em * var(--totalCharacters));
			padding: 0px;
		}
	`;
        #start_accessor_storage = __runInitializers(this, _start_initializers, 1);
        /**
         * The starting number for the ordered list.
         *
         * You can set this to start the list at a specific number
         *
         * @defaultValue 1
         */
        get start() { return this.#start_accessor_storage; }
        set start(value) { this.#start_accessor_storage = value; }
        #startLength_accessor_storage = (__runInitializers(this, _start_extraInitializers), __runInitializers(this, _startLength_initializers, 1));
        get startLength() { return this.#startLength_accessor_storage; }
        set startLength(value) { this.#startLength_accessor_storage = value; }
        checkChildren() {
            const allChildrenAreListItems = Array.from(this.children).every((child) => {
                const tagNameLowerCase = child.tagName.toLowerCase();
                return (tagNameLowerCase === 'discord-list-item' ||
                    tagNameLowerCase === 'discord-unordered-list' ||
                    tagNameLowerCase === 'discord-ordered-list');
            });
            if (!allChildrenAreListItems) {
                throw new DiscordComponentsError('All direct children inside of a <discord-ordered-list> components must be one of <discord-unordered-list>, <discord-ordered-list>, or <discord-list-item>.');
            }
        }
        /**
         * Checks how many children of `<discord-list-item>` this component has and updates
         * the {@link DiscordOrderedList.startLength | startLength} state.
         */
        willUpdate() {
            const amountOfListItems = Array.from(this.children).filter((child) => {
                return child.tagName.toLowerCase() === 'discord-list-item';
            }).length;
            const totalCount = this.start + amountOfListItems;
            this.startLength = totalCount.toString().length;
        }
        render() {
            this.checkChildren();
            // We disable the eslint rule here because users should use the <discord-list-item> component inside of this component.
            // eslint-disable-next-line lit-a11y/list
            return html `<ol start=${this.start} style="--totalCharacters:${this.startLength}">
			<slot></slot>
		</ol>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _startLength_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordOrderedList = _classThis;
})();
export { DiscordOrderedList };
//# sourceMappingURL=DiscordOrderedList.js.map