var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, eventOptions, property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { when } from 'lit/directives/when.js';
import { DiscordComponentsError } from '../../util.js';
import { messagesCompactMode, messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import { multipleAnswersPoll, pollEnded, pollVoted, showResults } from '../discord-poll/DiscordPoll.js';
import VerifiedTick from '../svgs/VerifiedTick.js';
let DiscordPollAnswer = (() => {
    let _classDecorators = [customElement('discord-poll-answer')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _instanceExtraInitializers = [];
    let _emoji_decorators;
    let _emoji_initializers = [];
    let _emoji_extraInitializers = [];
    let _answer_decorators;
    let _answer_initializers = [];
    let _answer_extraInitializers = [];
    let _votes_decorators;
    let _votes_initializers = [];
    let _votes_extraInitializers = [];
    let _selected_decorators;
    let _selected_initializers = [];
    let _selected_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _multipleAnswers_decorators;
    let _multipleAnswers_initializers = [];
    let _multipleAnswers_extraInitializers = [];
    let _pollEnded_decorators;
    let _pollEnded_initializers = [];
    let _pollEnded_extraInitializers = [];
    let _pollVoted_decorators;
    let _pollVoted_initializers = [];
    let _pollVoted_extraInitializers = [];
    let _showResult_decorators;
    let _showResult_initializers = [];
    let _showResult_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let __onClick_decorators;
    var DiscordPollAnswer = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _emoji_decorators = [property({ type: String, attribute: 'emoji', reflect: true })];
            _answer_decorators = [property({ type: String, attribute: 'answer', reflect: true })];
            _votes_decorators = [property({ type: Number, attribute: 'votes', reflect: true })];
            _selected_decorators = [property({ type: Boolean, attribute: 'selected', reflect: true })];
            _compactMode_decorators = [consume({ context: messagesCompactMode })];
            _multipleAnswers_decorators = [consume({ context: multipleAnswersPoll })];
            _pollEnded_decorators = [consume({ context: pollEnded })];
            _pollVoted_decorators = [consume({ context: pollVoted })];
            _showResult_decorators = [consume({ context: showResults })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __onClick_decorators = [eventOptions({ once: false, capture: true, passive: true })];
            __esDecorate(this, null, _emoji_decorators, { kind: "accessor", name: "emoji", static: false, private: false, access: { has: obj => "emoji" in obj, get: obj => obj.emoji, set: (obj, value) => { obj.emoji = value; } }, metadata: _metadata }, _emoji_initializers, _emoji_extraInitializers);
            __esDecorate(this, null, _answer_decorators, { kind: "accessor", name: "answer", static: false, private: false, access: { has: obj => "answer" in obj, get: obj => obj.answer, set: (obj, value) => { obj.answer = value; } }, metadata: _metadata }, _answer_initializers, _answer_extraInitializers);
            __esDecorate(this, null, _votes_decorators, { kind: "accessor", name: "votes", static: false, private: false, access: { has: obj => "votes" in obj, get: obj => obj.votes, set: (obj, value) => { obj.votes = value; } }, metadata: _metadata }, _votes_initializers, _votes_extraInitializers);
            __esDecorate(this, null, _selected_decorators, { kind: "accessor", name: "selected", static: false, private: false, access: { has: obj => "selected" in obj, get: obj => obj.selected, set: (obj, value) => { obj.selected = value; } }, metadata: _metadata }, _selected_initializers, _selected_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _multipleAnswers_decorators, { kind: "accessor", name: "multipleAnswers", static: false, private: false, access: { has: obj => "multipleAnswers" in obj, get: obj => obj.multipleAnswers, set: (obj, value) => { obj.multipleAnswers = value; } }, metadata: _metadata }, _multipleAnswers_initializers, _multipleAnswers_extraInitializers);
            __esDecorate(this, null, _pollEnded_decorators, { kind: "accessor", name: "pollEnded", static: false, private: false, access: { has: obj => "pollEnded" in obj, get: obj => obj.pollEnded, set: (obj, value) => { obj.pollEnded = value; } }, metadata: _metadata }, _pollEnded_initializers, _pollEnded_extraInitializers);
            __esDecorate(this, null, _pollVoted_decorators, { kind: "accessor", name: "pollVoted", static: false, private: false, access: { has: obj => "pollVoted" in obj, get: obj => obj.pollVoted, set: (obj, value) => { obj.pollVoted = value; } }, metadata: _metadata }, _pollVoted_initializers, _pollVoted_extraInitializers);
            __esDecorate(this, null, _showResult_decorators, { kind: "accessor", name: "showResult", static: false, private: false, access: { has: obj => "showResult" in obj, get: obj => obj.showResult, set: (obj, value) => { obj.showResult = value; } }, metadata: _metadata }, _showResult_initializers, _showResult_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, __onClick_decorators, { kind: "method", name: "_onClick", static: false, private: false, access: { has: obj => "_onClick" in obj, get: obj => obj._onClick }, metadata: _metadata }, null, _instanceExtraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordPollAnswer = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		.discord-answer-container {
			display: flex;
			cursor: pointer;
		}

		.discord-answer-emoji {
			width: 24px;
			height: 24px;
			margin-right: 2px;
			border-radius: 3px;
		}

		.discord-checkbox-div-multiple-answer {
			flex-shrink: 0;
			width: 20px;
			height: 20px;
			box-sizing: border-box;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 3px;
			background-color: transparent;
			border: 2px solid color-mix(in oklab, hsl(210 calc(1 * 9.1%) 87.1% / 1) 100%, black 0%);
		}

		.discord-checkbox-div-multiple-answer-selected {
			width: 20px;
			height: 20px;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 3px;
			background-color: hsl(235 calc(1 * 85.6%) 64.7% / 1);
		}

		.discord-checkbox-div-answer-selected-ended-winner {
			width: 24px;
			height: 24px;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 99px;
			background-color: seagreen;
		}

		.discord-checkbox-div-answer-selected-ended-no-winner {
			width: 24px;
			height: 24px;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 99px;
			background-color: white;
			color: black !important;
		}

		.discord-checkbox-div-answer-selected-voted {
			width: 24px;
			height: 24px;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 99px;
			background-color: hsl(235 calc(1 * 85.6%) 64.7% / 1);
		}

		.discord-checkbox-div-answer {
			flex-shrink: 0;
			width: 20px;
			height: 20px;
			box-sizing: border-box;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 99px;
			background-color: transparent;
			border: 2px solid color-mix(in oklab, hsl(210 calc(1 * 9.1%) 87.1% / 1) 100%, black 0%);
		}

		.discord-checkbox-div-answer-selected {
			margin: 2px;
			width: 10px;
			height: 10px;
			box-sizing: border-box;
			display: flex;
			align-items: center;
			justify-content: center;
			border-radius: 99px;
			border: 2px solid transparent;
			background-color: color-mix(in oklab, hsl(235 calc(1 * 86.1%) 77.5% / 1) 100%, black 0%);
		}

		.discord-answer-hidden {
			display: none;
		}

		.discord-answer-flex {
			display: flex;
			align-items: center;
			gap: 8px;
		}

		.discord-answer-selected {
			outline: 1px solid color-mix(in oklab, hsl(235 calc(1 * 86.1%) 77.5% / 1) 100%, black 0%) !important;
		}

		.discord-answer-selected-ended {
			outline: 1px solid hsl(145 calc(1 * 65%) 39.2% / 1) !important;
		}

		.discord-answer {
			position: relative;
			display: flex;
			align-items: center;
			justify-content: space-between;
			width: 100%;
			min-height: 50px;
			padding: 8px 16px;
			box-sizing: border-box;
			background-color: color-mix(in oklab, hsl(228 calc(1 * 6%) 32.5% / 0.3) 100%, hsl(0 0% 0% / 0.3) 0%);
			border-radius: 8px;
			color: color-mix(in oklab, hsl(210 calc(1 * 9.1%) 87.1% / 1) 100%, black 0%);
			word-break: break-word;
			overflow: hidden;
			outline: 1px solid transparent;
			z-index: 1;
			transition:
				background-color 170ms ease,
				outline-color 170ms ease;
		}

		:host([light-theme]) .discord-answer {
			background-color: color-mix(in oklab, hsl(223 calc(1 * 5.8%) 52.9% / 0.08) 100%, hsl(0 0% 0% / 0.08) 0%) !important;
		}

		:host([light-theme]) .discord-background-color-default {
			background-color: color-mix(in oklab, hsl(223 calc(1 * 5.8%) 52.9% / 0.2) 100%, hsl(0 0% 0% / 0.2) 0%) !important;
		}

		:host([light-theme]) .discord-awnswer-title,
		:host([light-theme]) .discord-quantity-votes,
		:host([light-theme]) .discord-percentage-votes {
			color: color-mix(in oklab, hsl(223 calc(1 * 6.7%) 20.6% / 1) 100%, black 0%) !important;
		}

		:host([light-theme]) .discord-checkbox-div-answer,
		:host([light-theme]) .discord-checkbox-div-multiple-answer {
			border-color: color-mix(in oklab, hsl(223 calc(1 * 6.7%) 20.6% / 1) 100%, black 0%) !important;
		}

		:host([light-theme]) .discord-checkbox-div-answer-selected-ended-no-winner {
			background-color: color-mix(in oklab, hsl(223 calc(1 * 6.7%) 20.6% / 1) 100%, black 0%);
			color: white !important;
		}

		.discord-answer-no-margin {
			margin: 0;
		}

		.discord-quantity-votes:hover {
			cursor: pointer;
			text-decoration: underline;
		}

		.discord-answer-backdround-color {
			content: '';
			position: absolute;
			height: 100%;
			left: 0;
			z-index: -1;
		}

		.discord-background-color-winner {
			background-color: color-mix(in oklab, hsl(145 calc(1 * 65%) 39.2% / 0.2) 100%, hsl(0 0% 0% / 0.2) 0%);
		}

		.discord-background-color-default {
			background-color: color-mix(in oklab, hsl(228 calc(1 * 6%) 32.5% / 0.48) 100%, hsl(0 0% 0% / 0.48) 0%);
		}

		.discord-background-color-selected {
			background-color: color-mix(in oklab, hsl(235 calc(1 * 85.6%) 64.7% / 0.2) 100%, hsl(0 0% 0% / 0.2) 0%);
		}
	`;
        #emoji_accessor_storage = (__runInitializers(this, _instanceExtraInitializers), __runInitializers(this, _emoji_initializers, void 0));
        get emoji() { return this.#emoji_accessor_storage; }
        set emoji(value) { this.#emoji_accessor_storage = value; }
        #answer_accessor_storage = (__runInitializers(this, _emoji_extraInitializers), __runInitializers(this, _answer_initializers, void 0));
        get answer() { return this.#answer_accessor_storage; }
        set answer(value) { this.#answer_accessor_storage = value; }
        #votes_accessor_storage = (__runInitializers(this, _answer_extraInitializers), __runInitializers(this, _votes_initializers, 0));
        get votes() { return this.#votes_accessor_storage; }
        set votes(value) { this.#votes_accessor_storage = value; }
        #selected_accessor_storage = (__runInitializers(this, _votes_extraInitializers), __runInitializers(this, _selected_initializers, false));
        get selected() { return this.#selected_accessor_storage; }
        set selected(value) { this.#selected_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _selected_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to use compact mode or not.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #multipleAnswers_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _multipleAnswers_initializers, false));
        get multipleAnswers() { return this.#multipleAnswers_accessor_storage; }
        set multipleAnswers(value) { this.#multipleAnswers_accessor_storage = value; }
        #pollEnded_accessor_storage = (__runInitializers(this, _multipleAnswers_extraInitializers), __runInitializers(this, _pollEnded_initializers, false));
        get pollEnded() { return this.#pollEnded_accessor_storage; }
        set pollEnded(value) { this.#pollEnded_accessor_storage = value; }
        #pollVoted_accessor_storage = (__runInitializers(this, _pollEnded_extraInitializers), __runInitializers(this, _pollVoted_initializers, false));
        get pollVoted() { return this.#pollVoted_accessor_storage; }
        set pollVoted(value) { this.#pollVoted_accessor_storage = value; }
        #showResult_accessor_storage = (__runInitializers(this, _pollVoted_extraInitializers), __runInitializers(this, _showResult_initializers, false));
        get showResult() { return this.#showResult_accessor_storage; }
        set showResult(value) { this.#showResult_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _showResult_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        /**
         * Whether to use ligth theme or not.
         */
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #totalVotesPoll_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), 0);
        get totalVotesPoll() { return this.#totalVotesPoll_accessor_storage; }
        set totalVotesPoll(value) { this.#totalVotesPoll_accessor_storage = value; }
        #percentageVoted_accessor_storage;
        get percentageVoted() { return this.#percentageVoted_accessor_storage; }
        set percentageVoted(value) { this.#percentageVoted_accessor_storage = value; }
        #arrayAnswers_accessor_storage = [];
        get arrayAnswers() { return this.#arrayAnswers_accessor_storage; }
        set arrayAnswers(value) { this.#arrayAnswers_accessor_storage = value; }
        #winners_accessor_storage = [];
        get winners() { return this.#winners_accessor_storage; }
        set winners(value) { this.#winners_accessor_storage = value; }
        connectedCallback() {
            super.connectedCallback();
            const answer = this.parentElement?.getElementsByTagName('discord-poll-answer');
            // Get the number total of votes
            if (answer) {
                for (let index = 0; index < answer?.length; index++) {
                    const resolvedNumber = answer[index].attributes.getNamedItem('votes')
                        ? Number(answer[index].attributes.getNamedItem('votes')?.nodeValue)
                        : 0;
                    this.arrayAnswers.push({ answer: answer[index].attributes.getNamedItem('answer')?.nodeValue, value: resolvedNumber });
                    this.arrayAnswers = this.arrayAnswers.toSorted((a, b) => b.value - a.value);
                    this.totalVotesPoll += resolvedNumber;
                }
            }
            for (let index = 0; index < this.arrayAnswers?.length; index++) {
                if (!this.winners.includes(this.arrayAnswers[index].answer)) {
                    this.winners.push(this.arrayAnswers[index].answer);
                }
                if (this.arrayAnswers[index + 1]) {
                    if (this.arrayAnswers[index].value === this.arrayAnswers[index + 1].value) {
                        if (!this.winners.includes(this.arrayAnswers[index + 1].answer)) {
                            this.winners.push(this.arrayAnswers[index + 1].answer);
                        }
                    }
                    else {
                        break;
                    }
                }
            }
            // Chek if is single vote and is has more one selected
            if (this.parentElement?.getAttribute('multiple-answers') !== '') {
                let selectedCount = 0;
                if (answer) {
                    for (const element of answer)
                        if (element.selected)
                            selectedCount++;
                }
                if (selectedCount > 1) {
                    throw new DiscordComponentsError('<discord-poll> single vote was selected more than 1 answer');
                }
            }
            this.percentageVoted = (this.votes / this.totalVotesPoll) * 100;
        }
        render() {
            this.percentageVoted =
                this.percentageVoted.toPrecision(3).split('.')[1] === '0'
                    ? Number(this.percentageVoted.toPrecision(3).split('.')[0])
                    : Number(this.percentageVoted.toPrecision(3));
            return html `
			<label>
				<div class="${classMap({ 'discord-answer-container': !this.pollVoted && !this.pollEnded && !this.showResult })}">
					<div
						class="${classMap({
                'discord-answer': true,
                'discord-answer-selected': this.selected && !this.pollEnded && !this.showResult,
                'discord-answer-selected-ended': this.pollEnded && this.winners.includes(this.answer)
            })}"
					>
						<div
							class=${classMap({
                'discord-answer-backdround-color': true,
                'discord-background-color-selected': !this.pollEnded && this.selected && this.pollVoted,
                'discord-background-color-winner': this.pollEnded && this.winners.includes(this.answer),
                'discord-background-color-default': (this.pollEnded && !this.winners.includes(this.answer)) ||
                    (!this.pollEnded && !this.selected && this.pollVoted) ||
                    this.showResult
            })}
							style="width:${this.percentageVoted}%;"
						></div>
						<div class="discord-answer-flex">
							${when(this.emoji, () => html `<img class="discord-answer-emoji" src="${this.emoji}" alt="emoji" />`)}
							<div class="discord-awnswer-title">${this.answer}</div>
						</div>
						<div class="discord-answer-flex">
							${when(this.pollVoted || this.pollEnded || this.showResult, () => html `<h5 class="discord-answer-no-margin discord-quantity-votes">
										${this.votes} ${this.votes > 1 || this.votes === 0 ? 'votes' : 'vote'}
									</h5>`)}
							${when(this.pollVoted || this.pollEnded || this.showResult, () => html `<h4 class="discord-answer-no-margin discord-percentage-votes">${this.percentageVoted}%</h4>`)}
							${when(this.selected && !this.showResult, () => when(this.multipleAnswers, () => when(this.pollEnded, () => when(this.winners.includes(this.answer), () => html `<div class="discord-checkbox-div-answer-selected-ended-winner">
																${VerifiedTick({ style: 'width:24px;height:24px;' })}
															</div>`, () => html `<div class="discord-checkbox-div-answer-selected-ended-no-winner">
																${VerifiedTick({ style: 'width:24px;height:24px;' })}
															</div>`), () => when(!this.pollVoted, () => html `<div class="discord-checkbox-div-multiple-answer-selected">
																${VerifiedTick({ style: 'width:24px;height:24px;' })}
															</div>`, () => html `<div class="discord-checkbox-div-answer-selected-voted">
																${VerifiedTick({ style: 'width:24px;height:24px;' })}
															</div>`)), () => when(this.pollEnded, () => html `<div class="discord-checkbox-div-answer-selected-ended-winner">
														${VerifiedTick({ style: 'width:24px;height:24px;' })}
													</div>`, () => when(!this.pollVoted, () => html `
															<div class="discord-checkbox-div-answer">
																<div class="discord-checkbox-div-answer-selected"></div>
															</div>
														`, () => html `<div class="discord-checkbox-div-answer-selected-voted">
																${VerifiedTick({ style: 'width:24px;height:24px;' })}
															</div>`))), () => when(!this.pollEnded && !this.pollVoted && !this.showResult, () => html `<div
												class="${classMap({
                'discord-checkbox-div-multiple-answer': this.multipleAnswers,
                'discord-checkbox-div-answer': !this.multipleAnswers
            })}"
											></div>`))}
						</div>
					</div>
					<span class="discord-answer-hidden"><input type="checkbox" @click=${() => this._onClick()} /></span>
				</div>
			</label>
		`;
        }
        _onClick() {
            if (this.pollEnded || this.pollVoted)
                return;
            const answer = this.parentElement;
            const buttonVote = answer?.shadowRoot?.querySelector('button.discord-poll-button-vote');
            const pollAnswers = answer?.getElementsByTagName('discord-poll-answer');
            if (this.selected) {
                this.selected = false;
                if (buttonVote) {
                    if (answer?.getAttribute('multiple-answers') === '') {
                        let selecteds = 0;
                        if (pollAnswers) {
                            for (const pollAnswer of pollAnswers) {
                                if (pollAnswer.selected)
                                    selecteds++;
                            }
                        }
                        if (selecteds > 0) {
                            buttonVote.className = 'discord-poll-button-vote';
                            return;
                        }
                    }
                    buttonVote.className = 'discord-poll-button-vote discord-poll-button-vote-disabled';
                }
                return;
            }
            if (answer?.getAttribute('multiple-answers') !== '' && pollAnswers) {
                for (const pollAnswer of pollAnswers) {
                    pollAnswer.selected = false;
                }
            }
            if (buttonVote)
                buttonVote.className = 'discord-poll-button-vote';
            this.selected = true;
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordPollAnswer = _classThis;
})();
export { DiscordPollAnswer };
//# sourceMappingURL=DiscordPollAnswer.js.map