var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume, createContext, provide } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { classMap } from 'lit/directives/class-map.js';
import { when } from 'lit/directives/when.js';
import { messagesCompactMode, messagesLightTheme } from '../discord-messages/DiscordMessages.js';
export const multipleAnswersPoll = createContext('multiple-answers');
export const pollEnded = createContext('ended');
export const pollVoted = createContext('voted');
export const showResults = createContext('show-votes');
let DiscordPoll = (() => {
    let _classDecorators = [customElement('discord-poll')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _question_decorators;
    let _question_initializers = [];
    let _question_extraInitializers = [];
    let _timeEnd_decorators;
    let _timeEnd_initializers = [];
    let _timeEnd_extraInitializers = [];
    let _pollEnded_decorators;
    let _pollEnded_initializers = [];
    let _pollEnded_extraInitializers = [];
    let _multipleAnswers_decorators;
    let _multipleAnswers_initializers = [];
    let _multipleAnswers_extraInitializers = [];
    let _pollVoted_decorators;
    let _pollVoted_initializers = [];
    let _pollVoted_extraInitializers = [];
    let _showResults_decorators;
    let _showResults_initializers = [];
    let _showResults_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordPoll = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _question_decorators = [property({ type: String, attribute: 'question', reflect: true })];
            _timeEnd_decorators = [property({ type: String, attribute: 'time-end', reflect: true })];
            _pollEnded_decorators = [provide({ context: pollEnded }), property({ type: Boolean, attribute: 'ended', reflect: true })];
            _multipleAnswers_decorators = [provide({ context: multipleAnswersPoll }), property({ type: Boolean, reflect: true, attribute: 'multiple-answers' })];
            _pollVoted_decorators = [provide({ context: pollVoted }), property({ type: Boolean, reflect: true, attribute: 'voted' })];
            _showResults_decorators = [provide({ context: showResults }), property({ type: Boolean, reflect: true, attribute: 'show-results' })];
            _compactMode_decorators = [consume({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _question_decorators, { kind: "accessor", name: "question", static: false, private: false, access: { has: obj => "question" in obj, get: obj => obj.question, set: (obj, value) => { obj.question = value; } }, metadata: _metadata }, _question_initializers, _question_extraInitializers);
            __esDecorate(this, null, _timeEnd_decorators, { kind: "accessor", name: "timeEnd", static: false, private: false, access: { has: obj => "timeEnd" in obj, get: obj => obj.timeEnd, set: (obj, value) => { obj.timeEnd = value; } }, metadata: _metadata }, _timeEnd_initializers, _timeEnd_extraInitializers);
            __esDecorate(this, null, _pollEnded_decorators, { kind: "accessor", name: "pollEnded", static: false, private: false, access: { has: obj => "pollEnded" in obj, get: obj => obj.pollEnded, set: (obj, value) => { obj.pollEnded = value; } }, metadata: _metadata }, _pollEnded_initializers, _pollEnded_extraInitializers);
            __esDecorate(this, null, _multipleAnswers_decorators, { kind: "accessor", name: "multipleAnswers", static: false, private: false, access: { has: obj => "multipleAnswers" in obj, get: obj => obj.multipleAnswers, set: (obj, value) => { obj.multipleAnswers = value; } }, metadata: _metadata }, _multipleAnswers_initializers, _multipleAnswers_extraInitializers);
            __esDecorate(this, null, _pollVoted_decorators, { kind: "accessor", name: "pollVoted", static: false, private: false, access: { has: obj => "pollVoted" in obj, get: obj => obj.pollVoted, set: (obj, value) => { obj.pollVoted = value; } }, metadata: _metadata }, _pollVoted_initializers, _pollVoted_extraInitializers);
            __esDecorate(this, null, _showResults_decorators, { kind: "accessor", name: "showResults", static: false, private: false, access: { has: obj => "showResults" in obj, get: obj => obj.showResults, set: (obj, value) => { obj.showResults = value; } }, metadata: _metadata }, _showResults_initializers, _showResults_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordPoll = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			display: flex;
			flex-direction: column;
			background-color: color-mix(in oklab, hsl(220 calc(1 * 6.5%) 18% / 1) 100%, black 0%);
			border-radius: 8px;
			padding: 16px;
			width: 100%;
			max-width: 472px;
			min-width: 302px;
			box-sizing: border-box;
			position: relative;
			overflow: hidden;
		}

		:host([light-theme]) {
			border: 1px solid color-mix(in oklab, hsl(0 calc(1 * 0%) 0% / 0.08) 100%, hsl(0 0% 0% / 0.08) 0%);
			background-color: color-mix(in oklab, hsl(0 calc(1 * 0%) 100% / 1) 100%, black 0%) !important;
		}

		:host([light-theme]) * {
			color: black;
		}

		.discord-poll-question {
			color: color-mix(in oklab, hsl(210 calc(1 * 9.1%) 87.1% / 1) 100%, black 0%);
			margin: 0;
			font-size: 1rem;
			word-break: break-word;
			line-height: 1.25;
			font-weight: 500;
		}

		.discord-poll-select {
			font-size: 0.875rem;
			grid-area: prompt;
			color: color-mix(in oklab, hsl(214 calc(1 * 8.1%) 61.2% / 1) 100%, black 0%) !important;
		}

		.discord-poll-answers {
			display: grid;
			grid-template-columns: 1fr;
			grid-auto-rows: 1fr;
			grid-gap: 8px;
			gap: 8px;
			margin: 8px 0 16px;
		}

		.discord-poll-footer {
			display: flex;
			align-items: center;
			justify-content: space-between;
		}

		.discord-poll-footer-votes-time {
			display: flex;
			align-items: center;
			color: color-mix(in oklab, hsl(214 calc(1 * 8.1%) 61.2% / 1) 100%, black 0%);
			font-size: 0.875rem;
			line-height: 1.2857142857142858;
			font-weight: 400;
		}

		.discord-poll-footer-time::before {
			content: '∙';
			margin: 0px 0.5rem;
			font-weight: 800;
		}

		.discord-poll-footer-time {
			display: flex;
			align-items: center;
		}

		.discord-poll-footer-hover:hover {
			color: #fff;
			text-decoration: underline;
			cursor: pointer;
		}

		:host([light-theme]) .discord-poll-footer-hover:hover {
			color: black;
			text-decoration: underline;
			cursor: pointer;
		}

		:host([light-theme]) .discord-poll-color-show-results {
			color: black !important;
		}

		.discord-poll-color-show-results {
			color: #fff !important;
			font-size: 0.875rem;
			font-weight: 600;
		}

		.discord-poll-result-vote {
			display: flex;
			align-items: center;
			gap: 15px;
		}

		:host .discord-poll-button-vote {
			cursor: pointer;
			background-color: hsl(235 calc(1 * 85.6%) 64.7% / 1) !important;
			color: hsl(0 calc(1 * 0%) 100% / 1) !important;
			padding: 9px 16px;
			border: none;
			border-radius: 3px;
			font-weight: 600;
		}

		:host .discord-poll-button-remove-vote {
			cursor: pointer;
			background-color: color-mix(in oklab, hsl(228 calc(1 * 6.7%) 14.7% / 1) 100%, black 0%) !important;
			color: color-mix(in oklab, hsl(210 calc(1 * 9.1%) 87.1% / 1) 100%, black 0%) !important;
			padding: 9px 16px;
			border: none;
			border-radius: 3px;
			font-weight: 600;
		}

		:host([light-theme]) button * {
			color: white !important;
		}

		:host .discord-poll-button-vote-disabled {
			cursor: no-drop;
			opacity: 0.5;
		}
	`;
        #question_accessor_storage = __runInitializers(this, _question_initializers, void 0);
        get question() { return this.#question_accessor_storage; }
        set question(value) { this.#question_accessor_storage = value; }
        #timeEnd_accessor_storage = (__runInitializers(this, _question_extraInitializers), __runInitializers(this, _timeEnd_initializers, '24h'));
        get timeEnd() { return this.#timeEnd_accessor_storage; }
        set timeEnd(value) { this.#timeEnd_accessor_storage = value; }
        #pollEnded_accessor_storage = (__runInitializers(this, _timeEnd_extraInitializers), __runInitializers(this, _pollEnded_initializers, false));
        get pollEnded() { return this.#pollEnded_accessor_storage; }
        set pollEnded(value) { this.#pollEnded_accessor_storage = value; }
        #multipleAnswers_accessor_storage = (__runInitializers(this, _pollEnded_extraInitializers), __runInitializers(this, _multipleAnswers_initializers, false));
        get multipleAnswers() { return this.#multipleAnswers_accessor_storage; }
        set multipleAnswers(value) { this.#multipleAnswers_accessor_storage = value; }
        #pollVoted_accessor_storage = (__runInitializers(this, _multipleAnswers_extraInitializers), __runInitializers(this, _pollVoted_initializers, false));
        get pollVoted() { return this.#pollVoted_accessor_storage; }
        set pollVoted(value) { this.#pollVoted_accessor_storage = value; }
        #showResults_accessor_storage = (__runInitializers(this, _pollVoted_extraInitializers), __runInitializers(this, _showResults_initializers, false));
        get showResults() { return this.#showResults_accessor_storage; }
        set showResults(value) { this.#showResults_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _showResults_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to use compact mode or not.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _compactMode_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        /**
         * Whether to use light theme or not.
         */
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #selected_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), false);
        get selected() { return this.#selected_accessor_storage; }
        set selected(value) { this.#selected_accessor_storage = value; }
        #totVotes_accessor_storage = 0;
        get totVotes() { return this.#totVotes_accessor_storage; }
        set totVotes(value) { this.#totVotes_accessor_storage = value; }
        connectedCallback() {
            super.connectedCallback();
            const answers = this.parentElement?.querySelectorAll('discord-poll-answer');
            if (answers) {
                for (let index = 0; index < answers?.length; index++) {
                    if (answers[index].attributes.getNamedItem('selected')) {
                        this.selected = true;
                    }
                    this.totVotes += answers[index].attributes.getNamedItem('votes')?.nodeValue
                        ? Number(answers[index].attributes.getNamedItem('votes')?.nodeValue)
                        : 0;
                }
            }
        }
        render() {
            const textPoll = this.multipleAnswers ? 'Select one or more answers' : 'Select one answer';
            return html `<div>
			<h4 class="discord-poll-question">${this.question}</h4>
			<div class="discord-poll-select">${textPoll}</div>
			<div class="discord-poll-answers">
				<slot></slot>
			</div>
			<div class="discord-poll-footer">
				<div class="discord-poll-footer-votes-time">
					<span class="discord-poll-footer-hover">${this.totVotes} votes</span>
					<div class="discord-poll-footer-time">${this.pollEnded ? 'Poll closed' : `${this.timeEnd} left`}</div>
				</div>
				${when(!this.pollEnded && !this.pollVoted && !this.showResults, () => html `<div class="discord-poll-result-vote">
							<div class="discord-poll-footer-hover discord-poll-color-show-results">Show results</div>
							<button
								type="button"
								class="${classMap({ 'discord-poll-button-vote': true, 'discord-poll-button-vote-disabled': !this.selected })}"
							>
								<div>Vote</div>
							</button>
						</div>`)}
				${when((!this.pollEnded && this.pollVoted) || this.showResults, () => html `
						<button type="button" class="discord-poll-button-remove-vote">
							<div>${!this.pollEnded && this.pollVoted ? 'Remove vote' : 'Go back to vote'}</div>
						</button>
					`)}
			</div>
		</div> `;
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordPoll = _classThis;
})();
export { DiscordPoll };
//# sourceMappingURL=DiscordPoll.js.map