var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordReaction = (() => {
    let _classDecorators = [customElement('discord-reaction')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _emoji_decorators;
    let _emoji_initializers = [];
    let _emoji_extraInitializers = [];
    let _name_decorators;
    let _name_initializers = [];
    let _name_extraInitializers = [];
    let _count_decorators;
    let _count_initializers = [];
    let _count_extraInitializers = [];
    let _reacted_decorators;
    let _reacted_initializers = [];
    let _reacted_extraInitializers = [];
    let _interactive_decorators;
    let _interactive_initializers = [];
    let _interactive_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordReaction = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _emoji_decorators = [property()];
            _name_decorators = [property()];
            _count_decorators = [property({ type: Number })];
            _reacted_decorators = [property({ type: Boolean, reflect: true })];
            _interactive_decorators = [property({ type: Boolean })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _emoji_decorators, { kind: "accessor", name: "emoji", static: false, private: false, access: { has: obj => "emoji" in obj, get: obj => obj.emoji, set: (obj, value) => { obj.emoji = value; } }, metadata: _metadata }, _emoji_initializers, _emoji_extraInitializers);
            __esDecorate(this, null, _name_decorators, { kind: "accessor", name: "name", static: false, private: false, access: { has: obj => "name" in obj, get: obj => obj.name, set: (obj, value) => { obj.name = value; } }, metadata: _metadata }, _name_initializers, _name_extraInitializers);
            __esDecorate(this, null, _count_decorators, { kind: "accessor", name: "count", static: false, private: false, access: { has: obj => "count" in obj, get: obj => obj.count, set: (obj, value) => { obj.count = value; } }, metadata: _metadata }, _count_initializers, _count_extraInitializers);
            __esDecorate(this, null, _reacted_decorators, { kind: "accessor", name: "reacted", static: false, private: false, access: { has: obj => "reacted" in obj, get: obj => obj.reacted, set: (obj, value) => { obj.reacted = value; } }, metadata: _metadata }, _reacted_initializers, _reacted_extraInitializers);
            __esDecorate(this, null, _interactive_decorators, { kind: "accessor", name: "interactive", static: false, private: false, access: { has: obj => "interactive" in obj, get: obj => obj.interactive, set: (obj, value) => { obj.interactive = value; } }, metadata: _metadata }, _interactive_initializers, _interactive_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordReaction = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host > *:first-child {
			border-radius: 0.5rem;
			cursor: pointer;
			flex-shrink: 0;
			margin-right: 0.25rem;
			margin-bottom: 0.25rem;
			user-select: none;
			transition: none 0.1s ease;
			transition-property: background-color, border-color;
			background-color: #2f3136;
			border: 1px solid transparent;
		}

		:host([light-theme]) > *:first-child {
			background-color: #f2f3f5;
		}

		:host > *:first-child:hover {
			background-color: #36393f;
			border-color: #fff2;
		}

		:host([light-theme]:not([reacted])) > *:first-child:hover {
			background-color: white;
			border-color: #0003;
		}

		:host([reacted]) > *:first-child {
			background-color: rgba(88, 101, 242, 0.15);
			border-color: #5865f2;
		}

		:host([light-theme][reacted]) > *:first-child {
			background-color: #e7e9fd;
		}

		:host .discord-reaction-inner {
			display: flex;
			align-items: center;
			padding: 0.125rem 0.375rem;
		}

		:host img {
			width: 1rem;
			height: 1rem;
			margin: 0.125rem 0;
			min-width: auto;
			min-height: auto;
			object-fit: contain;
			vertical-align: bottom;
		}

		:host .discord-reaction-count {
			font-size: 0.875rem;
			font-weight: 500;
			margin-left: 0.375rem;
			text-align: center;
			color: #b9bbbe;
		}

		:host([light-theme]) .discord-reaction-count {
			color: #4f5660;
		}

		:host([reacted]) .discord-reaction-count {
			color: #dee0fc;
		}

		:host([light-theme][reacted]) .discord-reaction-count {
			color: #5865f2;
		}
	`;
        #emoji_accessor_storage = __runInitializers(this, _emoji_initializers, void 0);
        /**
         * The reaction emoji image URL.
         */
        get emoji() { return this.#emoji_accessor_storage; }
        set emoji(value) { this.#emoji_accessor_storage = value; }
        #name_accessor_storage = (__runInitializers(this, _emoji_extraInitializers), __runInitializers(this, _name_initializers, ':emoji:'));
        /**
         * The name of the emoji to use as alternative image text.
         *
         * @defaultValue ':emoji'
         */
        get name() { return this.#name_accessor_storage; }
        set name(value) { this.#name_accessor_storage = value; }
        #count_accessor_storage = (__runInitializers(this, _name_extraInitializers), __runInitializers(this, _count_initializers, 1));
        /**
         * The number of people who reacted.
         *
         * @defaultValue 1
         */
        get count() { return this.#count_accessor_storage; }
        set count(value) { this.#count_accessor_storage = value; }
        #reacted_accessor_storage = (__runInitializers(this, _count_extraInitializers), __runInitializers(this, _reacted_initializers, false));
        /**
         * Whether the reaction should show as reacted by the user.
         *
         * @defaultValue false
         */
        get reacted() { return this.#reacted_accessor_storage; }
        set reacted(value) { this.#reacted_accessor_storage = value; }
        #interactive_accessor_storage = (__runInitializers(this, _reacted_extraInitializers), __runInitializers(this, _interactive_initializers, false));
        /**
         * Whether the reaction should be reactive.
         *
         * @remarks When the reaction is interactive left clicking it will add 1 to the counter.
         * Whereas when holding the Shift key and left clicking it will decrease the counter.
         * The counter cannot go below 1.
         * @defaultValue false
         */
        get interactive() { return this.#interactive_accessor_storage; }
        set interactive(value) { this.#interactive_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _interactive_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        render() {
            return html `<div class="discord-reaction-inner" @click=${this.handleReactionClick} @keydown=${this.handleReactionClick}>
			${when(this.emoji?.includes('http') || this.emoji?.startsWith('/') || this.emoji?.startsWith('./'), () => html `<img src=${ifDefined(this.emoji)} alt=${ifDefined(this.name)} draggable="false" />`, () => html `<span>${this.emoji}</span>`)}
			<span class="discord-reaction-count">${this.count}</span>
		</div>`;
        }
        handleReactionClick = (__runInitializers(this, _lightTheme_extraInitializers), (event) => {
            if (this.interactive) {
                if (event.shiftKey) {
                    this.count--;
                }
                else {
                    this.count++;
                }
                if (this.count <= 0) {
                    this.count = 1;
                }
            }
        });
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordReaction = _classThis;
})();
export { DiscordReaction };
//# sourceMappingURL=DiscordReaction.js.map