var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { avatars, profiles } from '../../config.js';
import { getClanIcon } from '../../util.js';
import { messagesCompactMode, messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import AttachmentReply from '../svgs/AttachmentReply.js';
import CommandReply from '../svgs/CommandReply.js';
import ReplyIcon from '../svgs/ReplyIcon.js';
import VerifiedTick from '../svgs/VerifiedTick.js';
let DiscordReply = (() => {
    let _classDecorators = [customElement('discord-reply')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _profile_decorators;
    let _profile_initializers = [];
    let _profile_extraInitializers = [];
    let _author_decorators;
    let _author_initializers = [];
    let _author_extraInitializers = [];
    let _avatar_decorators;
    let _avatar_initializers = [];
    let _avatar_extraInitializers = [];
    let _bot_decorators;
    let _bot_initializers = [];
    let _bot_extraInitializers = [];
    let _server_decorators;
    let _server_initializers = [];
    let _server_extraInitializers = [];
    let _officialApp_decorators;
    let _officialApp_initializers = [];
    let _officialApp_extraInitializers = [];
    let _op_decorators;
    let _op_initializers = [];
    let _op_extraInitializers = [];
    let _verified_decorators;
    let _verified_initializers = [];
    let _verified_extraInitializers = [];
    let _edited_decorators;
    let _edited_initializers = [];
    let _edited_extraInitializers = [];
    let _roleColor_decorators;
    let _roleColor_initializers = [];
    let _roleColor_extraInitializers = [];
    let _command_decorators;
    let _command_initializers = [];
    let _command_extraInitializers = [];
    let _attachment_decorators;
    let _attachment_initializers = [];
    let _attachment_extraInitializers = [];
    let _mentions_decorators;
    let _mentions_initializers = [];
    let _mentions_extraInitializers = [];
    let _clanIcon_decorators;
    let _clanIcon_initializers = [];
    let _clanIcon_extraInitializers = [];
    let _clanTag_decorators;
    let _clanTag_initializers = [];
    let _clanTag_extraInitializers = [];
    let _deleted_decorators;
    let _deleted_initializers = [];
    let _deleted_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    let _compactMode_decorators;
    let _compactMode_initializers = [];
    let _compactMode_extraInitializers = [];
    var DiscordReply = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _profile_decorators = [property()];
            _author_decorators = [property()];
            _avatar_decorators = [property()];
            _bot_decorators = [property({ type: Boolean })];
            _server_decorators = [property({ type: Boolean })];
            _officialApp_decorators = [property({ type: Boolean, attribute: 'official-app' })];
            _op_decorators = [property({ type: Boolean })];
            _verified_decorators = [property({ type: Boolean })];
            _edited_decorators = [property({ type: Boolean })];
            _roleColor_decorators = [property({ attribute: 'role-color' })];
            _command_decorators = [property({ type: Boolean })];
            _attachment_decorators = [property({ type: Boolean })];
            _mentions_decorators = [property({ type: Boolean })];
            _clanIcon_decorators = [property({ attribute: 'clan-icon' })];
            _clanTag_decorators = [property({ attribute: 'clan-tag' })];
            _deleted_decorators = [property({ type: Boolean, reflect: true })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            _compactMode_decorators = [consume({ context: messagesCompactMode }), property({ type: Boolean, reflect: true, attribute: 'compact-mode' })];
            __esDecorate(this, null, _profile_decorators, { kind: "accessor", name: "profile", static: false, private: false, access: { has: obj => "profile" in obj, get: obj => obj.profile, set: (obj, value) => { obj.profile = value; } }, metadata: _metadata }, _profile_initializers, _profile_extraInitializers);
            __esDecorate(this, null, _author_decorators, { kind: "accessor", name: "author", static: false, private: false, access: { has: obj => "author" in obj, get: obj => obj.author, set: (obj, value) => { obj.author = value; } }, metadata: _metadata }, _author_initializers, _author_extraInitializers);
            __esDecorate(this, null, _avatar_decorators, { kind: "accessor", name: "avatar", static: false, private: false, access: { has: obj => "avatar" in obj, get: obj => obj.avatar, set: (obj, value) => { obj.avatar = value; } }, metadata: _metadata }, _avatar_initializers, _avatar_extraInitializers);
            __esDecorate(this, null, _bot_decorators, { kind: "accessor", name: "bot", static: false, private: false, access: { has: obj => "bot" in obj, get: obj => obj.bot, set: (obj, value) => { obj.bot = value; } }, metadata: _metadata }, _bot_initializers, _bot_extraInitializers);
            __esDecorate(this, null, _server_decorators, { kind: "accessor", name: "server", static: false, private: false, access: { has: obj => "server" in obj, get: obj => obj.server, set: (obj, value) => { obj.server = value; } }, metadata: _metadata }, _server_initializers, _server_extraInitializers);
            __esDecorate(this, null, _officialApp_decorators, { kind: "accessor", name: "officialApp", static: false, private: false, access: { has: obj => "officialApp" in obj, get: obj => obj.officialApp, set: (obj, value) => { obj.officialApp = value; } }, metadata: _metadata }, _officialApp_initializers, _officialApp_extraInitializers);
            __esDecorate(this, null, _op_decorators, { kind: "accessor", name: "op", static: false, private: false, access: { has: obj => "op" in obj, get: obj => obj.op, set: (obj, value) => { obj.op = value; } }, metadata: _metadata }, _op_initializers, _op_extraInitializers);
            __esDecorate(this, null, _verified_decorators, { kind: "accessor", name: "verified", static: false, private: false, access: { has: obj => "verified" in obj, get: obj => obj.verified, set: (obj, value) => { obj.verified = value; } }, metadata: _metadata }, _verified_initializers, _verified_extraInitializers);
            __esDecorate(this, null, _edited_decorators, { kind: "accessor", name: "edited", static: false, private: false, access: { has: obj => "edited" in obj, get: obj => obj.edited, set: (obj, value) => { obj.edited = value; } }, metadata: _metadata }, _edited_initializers, _edited_extraInitializers);
            __esDecorate(this, null, _roleColor_decorators, { kind: "accessor", name: "roleColor", static: false, private: false, access: { has: obj => "roleColor" in obj, get: obj => obj.roleColor, set: (obj, value) => { obj.roleColor = value; } }, metadata: _metadata }, _roleColor_initializers, _roleColor_extraInitializers);
            __esDecorate(this, null, _command_decorators, { kind: "accessor", name: "command", static: false, private: false, access: { has: obj => "command" in obj, get: obj => obj.command, set: (obj, value) => { obj.command = value; } }, metadata: _metadata }, _command_initializers, _command_extraInitializers);
            __esDecorate(this, null, _attachment_decorators, { kind: "accessor", name: "attachment", static: false, private: false, access: { has: obj => "attachment" in obj, get: obj => obj.attachment, set: (obj, value) => { obj.attachment = value; } }, metadata: _metadata }, _attachment_initializers, _attachment_extraInitializers);
            __esDecorate(this, null, _mentions_decorators, { kind: "accessor", name: "mentions", static: false, private: false, access: { has: obj => "mentions" in obj, get: obj => obj.mentions, set: (obj, value) => { obj.mentions = value; } }, metadata: _metadata }, _mentions_initializers, _mentions_extraInitializers);
            __esDecorate(this, null, _clanIcon_decorators, { kind: "accessor", name: "clanIcon", static: false, private: false, access: { has: obj => "clanIcon" in obj, get: obj => obj.clanIcon, set: (obj, value) => { obj.clanIcon = value; } }, metadata: _metadata }, _clanIcon_initializers, _clanIcon_extraInitializers);
            __esDecorate(this, null, _clanTag_decorators, { kind: "accessor", name: "clanTag", static: false, private: false, access: { has: obj => "clanTag" in obj, get: obj => obj.clanTag, set: (obj, value) => { obj.clanTag = value; } }, metadata: _metadata }, _clanTag_initializers, _clanTag_extraInitializers);
            __esDecorate(this, null, _deleted_decorators, { kind: "accessor", name: "deleted", static: false, private: false, access: { has: obj => "deleted" in obj, get: obj => obj.deleted, set: (obj, value) => { obj.deleted = value; } }, metadata: _metadata }, _deleted_initializers, _deleted_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(this, null, _compactMode_decorators, { kind: "accessor", name: "compactMode", static: false, private: false, access: { has: obj => "compactMode" in obj, get: obj => obj.compactMode, set: (obj, value) => { obj.compactMode = value; } }, metadata: _metadata }, _compactMode_initializers, _compactMode_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordReply = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			color: #b9bbbe;
			display: flex;
			font-size: 0.875rem;
			font-family: 'gg sans', 'Noto Sans', Whitney, 'Helvetica Neue', Helvetica, Roboto, Arial, sans-serif;

			padding-top: 2px;
			margin-left: 56px;
			margin-bottom: 4px;
			align-items: center;
			line-height: 1.125rem;
			position: relative;
			white-space: pre;
			user-select: none;
		}

		:host([light-theme]) {
			color: #4f5660;
		}

		:host([compact-mode]),
		:host([deleted]) {
			margin-left: 62px;
			margin-bottom: 0;
		}

		:host:before {
			content: '';
			display: block;
			position: absolute;
			top: 50%;
			right: 100%;
			bottom: 0;
			left: -36px;
			margin-right: 4px;
			margin-top: -1px;
			margin-left: -1px;
			margin-bottom: -2px;
			border-left: 2px solid #4f545c !important;
			border-bottom: 0 solid #4f545c !important;
			border-right: 0 solid #4f545c !important;
			border-top: 2px solid #4f545c !important;
			border-top-left-radius: 6px;
		}

		:host([light-theme]):before {
			border-color: #747f8d !important;
		}

		.discord-replied-message-avatar,
		.discord-reply-badge {
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			width: 16px;
			height: 16px;
			border-radius: 50%;
			user-select: none;
			margin-right: 0.25rem;
		}

		.discord-reply-badge {
			display: flex;
			align-items: center;
			justify-content: center;
			color: #b9bbbe;
			background: #202225;
		}

		:host([light-theme]) .discord-reply-badge {
			color: #4f5660;
			background: #e3e5e8;
		}

		:host .discord-clan-tag {
			background-color: oklab(0.431937 0.00109309 -0.0132537 / 0.8);
			color: #fff;
			font-size: 12px;
			font-weight: 500;
			margin-right: 0.25rem;
			border-radius: 4px;
			line-height: 100%;
			text-transform: uppercase;
			justify-content: space-between;
			display: inline-flex;
			align-items: center;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			height: 1.2rem;
			opacity: 0.55;
			transition: background-color 100ms ease-in-out;
			cursor: pointer;
		}

		:host .discord-clan-tag:hover {
			background-color: oklab(0.431937 0.00109309 -0.0132537 / 0.5);
		}

		:host([light-theme]) .discord-clan-tag {
			opacity: 0.65;
			background-color: hsl(0 calc(1 * 0%) 0.8%/0.09);
			color: #000;
		}

		:host([light-theme]) .discord-clan-tag:hover {
			background-color: hsl(0 calc(1 * 0%) 0.8%/0.03);
		}

		:host .discord-clan-tag svg,
		:host .discord-clan-tag img {
			display: inline-flex;
			align-items: center;
			margin-right: 0.25rem;
			right: 0.25rem;
		}

		:host .discord-clan-tag span {
			display: inline-flex;
			align-items: center;
			user-select: none;
			-webkit-user-select: none;
			line-height: 1rem !important;
		}

		.discord-application-tag {
			background-color: hsl(235, 85.6%, 64.7%);
			color: #fff;
			font-size: 0.625rem;
			margin-right: 0.25rem;
			line-height: 100%;
			text-transform: uppercase;

			/* Use flex layout to ensure both verified icon and "BOT" text are aligned to center */
			display: flex;
			align-items: center;

			/* Styling taken through Inspect Element on Discord client for Windows */
			height: 0.9375rem;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			border-radius: 0.1875rem;
		}

		:host([compact-mode]) .discord-application-tag {
			margin-right: 0.25rem;
		}

		.discord-application-tag .discord-application-tag-verified {
			width: 0.9375rem;
			height: 0.9375rem;
			margin-left: -0.1rem;
		}

		.discord-application-tag.discord-application-tag-op {
			background-color: #c9cdfb;
			color: #4752c4;
			border-radius: 0.4rem;
		}

		.discord-replied-message-username {
			flex-shrink: 0;
			font-size: inherit;
			line-height: inherit;
			margin-right: 0.25rem;
			opacity: 0.64;
			font-weight: 500;
			color: #fff;
		}

		.discord-replied-message-username:hover {
			text-decoration: underline;
			cursor: pointer;
		}

		.discord-replied-message-content {
			color: inherit;
			font-size: inherit;
			line-height: inherit;
			white-space: pre;
			text-overflow: ellipsis;
			user-select: none;
			cursor: pointer;
		}

		.discord-replied-deleted-message-content {
			color: inherit;
			font-size: inherit;
			line-height: inherit;
			white-space: pre;
			text-overflow: ellipsis;
		}

		.discord-message-edited {
			color: #72767d;
			font-size: 10px;
		}

		:host([light-theme]) .discord-message-edited {
			color: #99aab5;
		}

		.discord-replied-message-content:hover {
			color: #fff;
		}

		:host([light-theme]) .discord-replied-message-content:hover {
			color: #000;
		}

		:host .discord-replied-message-content .discord-message-edited {
			margin-left: 0.25rem;
		}

		.discord-replied-message-content-icon {
			-webkit-box-flex: 0;
			-ms-flex: 0 0 auto;
			flex: 0 0 auto;
			width: 20px;
			height: 20px;
			margin-left: 4px;
		}
	`;
        #profile_accessor_storage = __runInitializers(this, _profile_initializers, void 0);
        /**
         * The id of the profile data to use.
         */
        get profile() { return this.#profile_accessor_storage; }
        set profile(value) { this.#profile_accessor_storage = value; }
        #author_accessor_storage = (__runInitializers(this, _profile_extraInitializers), __runInitializers(this, _author_initializers, 'User'));
        /**
         * The message author's username.
         *
         * @defaultValue 'User'
         */
        get author() { return this.#author_accessor_storage; }
        set author(value) { this.#author_accessor_storage = value; }
        #avatar_accessor_storage = (__runInitializers(this, _author_extraInitializers), __runInitializers(this, _avatar_initializers, void 0));
        /**
         * The message author's avatar. Can be an avatar shortcut, relative path, or external link.
         */
        get avatar() { return this.#avatar_accessor_storage; }
        set avatar(value) { this.#avatar_accessor_storage = value; }
        #bot_accessor_storage = (__runInitializers(this, _avatar_extraInitializers), __runInitializers(this, _bot_initializers, false));
        /**
         * Whether the message author is a bot or not.
         * Only works if `server` and `officialApp` is `false` or `undefined`.
         */
        get bot() { return this.#bot_accessor_storage; }
        set bot(value) { this.#bot_accessor_storage = value; }
        #server_accessor_storage = (__runInitializers(this, _bot_extraInitializers), __runInitializers(this, _server_initializers, false));
        /**
         * Whether the message author is a server crosspost webhook or not.
         * Only works if `bot` and `officialApp` is `false` or `undefined`.
         */
        get server() { return this.#server_accessor_storage; }
        set server(value) { this.#server_accessor_storage = value; }
        #officialApp_accessor_storage = (__runInitializers(this, _server_extraInitializers), __runInitializers(this, _officialApp_initializers, false));
        /**
         * Whether the message author is a server crosspost webhook or not.
         * Only works if `bot` and `server` is `false` or `undefined`.
         */
        get officialApp() { return this.#officialApp_accessor_storage; }
        set officialApp(value) { this.#officialApp_accessor_storage = value; }
        #op_accessor_storage = (__runInitializers(this, _officialApp_extraInitializers), __runInitializers(this, _op_initializers, false));
        /**
         * Whether the author is the original poster.
         */
        get op() { return this.#op_accessor_storage; }
        set op(value) { this.#op_accessor_storage = value; }
        #verified_accessor_storage = (__runInitializers(this, _op_extraInitializers), __runInitializers(this, _verified_initializers, false));
        /**
         * Whether the bot is verified or not.
         * Only works if `bot` is `true`
         */
        get verified() { return this.#verified_accessor_storage; }
        set verified(value) { this.#verified_accessor_storage = value; }
        #edited_accessor_storage = (__runInitializers(this, _verified_extraInitializers), __runInitializers(this, _edited_initializers, false));
        /**
         * Whether the message has been edited or not.
         */
        get edited() { return this.#edited_accessor_storage; }
        set edited(value) { this.#edited_accessor_storage = value; }
        #roleColor_accessor_storage = (__runInitializers(this, _edited_extraInitializers), __runInitializers(this, _roleColor_initializers, void 0));
        /**
         * The message author's primary role color. Can be any [CSS color value](https://www.w3schools.com/cssref/css_colors_legal.asp).
         */
        get roleColor() { return this.#roleColor_accessor_storage; }
        set roleColor(value) { this.#roleColor_accessor_storage = value; }
        #command_accessor_storage = (__runInitializers(this, _roleColor_extraInitializers), __runInitializers(this, _command_initializers, false));
        /**
         * Whether the referenced message is from a response of a slash command.
         */
        get command() { return this.#command_accessor_storage; }
        set command(value) { this.#command_accessor_storage = value; }
        #attachment_accessor_storage = (__runInitializers(this, _command_extraInitializers), __runInitializers(this, _attachment_initializers, false));
        /**
         * Whether the referenced message contains attachments.
         */
        get attachment() { return this.#attachment_accessor_storage; }
        set attachment(value) { this.#attachment_accessor_storage = value; }
        #mentions_accessor_storage = (__runInitializers(this, _attachment_extraInitializers), __runInitializers(this, _mentions_initializers, false));
        /**
         * Whether this reply pings the original message sender, prepending an "\@" on the author's username.
         */
        get mentions() { return this.#mentions_accessor_storage; }
        set mentions(value) { this.#mentions_accessor_storage = value; }
        #clanIcon_accessor_storage = (__runInitializers(this, _mentions_extraInitializers), __runInitializers(this, _clanIcon_initializers, void 0));
        /**
         * The clan icon of the author, which comes from the enabled clan tag
         */
        get clanIcon() { return this.#clanIcon_accessor_storage; }
        set clanIcon(value) { this.#clanIcon_accessor_storage = value; }
        #clanTag_accessor_storage = (__runInitializers(this, _clanIcon_extraInitializers), __runInitializers(this, _clanTag_initializers, void 0));
        /**
         * The clan name of the author, which comes from the enabled clan tag
         */
        get clanTag() { return this.#clanTag_accessor_storage; }
        set clanTag(value) { this.#clanTag_accessor_storage = value; }
        #deleted_accessor_storage = (__runInitializers(this, _clanTag_extraInitializers), __runInitializers(this, _deleted_initializers, false));
        /**
         * Whether this reply is a deleted message.
         * When set to true, any content inside the tags is ignored as no `slot` is rendered.
         * The message will always be `"Original message was deleted"`.
         * Furthermore, the following properties are ignored:
         *
         * - {@link DiscordReply.profile | profile}
         * - {@link DiscordReply.author | author}
         * - {@link DiscordReply.avatar | avatar}
         * - {@link DiscordReply.bot | bot}
         * - {@link DiscordReply.server | server}
         * - {@link DiscordReply.op | op}
         * - {@link DiscordReply.verified | verified}
         * - {@link DiscordReply.edited | edited}
         * - {@link DiscordReply.roleColor | roleColor}
         * - {@link DiscordReply.command | command}
         * - {@link DiscordReply.attachment | attachment}
         * - {@link DiscordReply.mentions | mentions}
         * - {@link DiscordReply.clanIcon | clanIcon}
         * - {@link DiscordReply.clanTag | clanTag}
         */
        get deleted() { return this.#deleted_accessor_storage; }
        set deleted(value) { this.#deleted_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _deleted_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        #compactMode_accessor_storage = (__runInitializers(this, _lightTheme_extraInitializers), __runInitializers(this, _compactMode_initializers, false));
        /**
         * Whether to use compact mode or not.
         */
        get compactMode() { return this.#compactMode_accessor_storage; }
        set compactMode(value) { this.#compactMode_accessor_storage = value; }
        resolveAvatar(avatar) {
            return avatars[avatar] ?? avatar ?? avatars.default;
        }
        render() {
            const defaultData = {
                author: this.author,
                bot: this.bot,
                verified: this.verified,
                officialApp: this.officialApp,
                op: this.op,
                server: this.server,
                roleColor: this.roleColor,
                clanIcon: this.clanIcon,
                clanTag: this.clanTag
            };
            const profileData = Reflect.get(profiles, this.profile) ?? {};
            const profile = { ...defaultData, ...profileData, avatar: this.resolveAvatar(profileData.avatar ?? this.avatar) };
            const clanIcon = getClanIcon(profile.clanIcon);
            const slicedClanTag = profile.clanTag?.slice(0, 4);
            const profileTag = html `
			${when(profile.bot && !profile.server && !profile.officialApp, () => html `<span class="discord-application-tag">${profile.verified ? VerifiedTick() : ''}App</span>`)}
			${when(profile.server && !profile.bot && !profile.officialApp, () => html `<span class="discord-application-tag">Server</span>`)}
			${when(profile.officialApp && !profile.server && !profile.bot, () => html `<span class="discord-application-tag">${VerifiedTick()}OFFICIAL</span>`)}
		`;
            return html `${when(this.compactMode || this.deleted, () => html `<div class="discord-reply-badge">${ReplyIcon()}</div>`, () => html `<img class="discord-replied-message-avatar" src="${ifDefined(profile.avatar)}" alt="${ifDefined(profile.author)}" />`)}
		${when(this.deleted, () => html `<div class="discord-replied-deleted-message-content"><em>Original message was deleted</em></div>`, () => html `${profileTag}
					<span class="discord-replied-message-username" style=${styleMap({ color: profile.roleColor })}
						>${when(this.mentions, () => '@')}${profile.author}</span
					>
					${when(profile.clanIcon && profile.clanTag && profile.clanTag?.length > 0, () => html `<span class="discord-clan-tag">
								${clanIcon === 'string'
                ? html `<img
											srcset=${ifDefined(clanIcon)}
											alt=${ifDefined(slicedClanTag)}
											width="12"
											height="12"
											draggable="false"
										/>`
                : clanIcon}
								<span>${slicedClanTag}</span>
							</span>`)}
					<!-- display: inline -->
					<div class="discord-replied-message-content"
						><slot></slot>${when(this.edited, () => html `<span class="discord-message-edited">(edited)</span>`)}</div
					>
					${when(this.command, () => CommandReply({ class: 'discord-replied-message-content-icon' }), () => when(this.attachment, () => AttachmentReply({ class: 'discord-replied-message-content-icon' })))}`)}`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _compactMode_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordReply = _classThis;
})();
export { DiscordReply };
//# sourceMappingURL=DiscordReply.js.map