import { LitElement } from 'lit';
import type { LightTheme } from '../../types.js';
export declare class DiscordStringSelectMenuOption extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The emoji URL to use in the SelectMenu.
     */
    accessor emoji: string;
    /**
     * The name of the emoji used in the SelectMenu.
     */
    accessor emojiName: string;
    /**
     * The label of the option
     */
    accessor label: string;
    /**
     * The description of the option
     */
    accessor description: string;
    accessor selectOption: (...args: unknown[]) => void;
    checkLabelIsProvided(): void;
    accessor lightTheme: boolean;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-string-select-menu-option': DiscordStringSelectMenuOption;
    }
}
//# sourceMappingURL=DiscordStringSelectMenuOption.d.ts.map