var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { when } from 'lit/directives/when.js';
import { DiscordComponentsError } from '../../util.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
let DiscordStringSelectMenuOption = (() => {
    let _classDecorators = [customElement('discord-string-select-menu-option')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _emoji_decorators;
    let _emoji_initializers = [];
    let _emoji_extraInitializers = [];
    let _emojiName_decorators;
    let _emojiName_initializers = [];
    let _emojiName_extraInitializers = [];
    let _label_decorators;
    let _label_initializers = [];
    let _label_extraInitializers = [];
    let _description_decorators;
    let _description_initializers = [];
    let _description_extraInitializers = [];
    let _selectOption_decorators;
    let _selectOption_initializers = [];
    let _selectOption_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordStringSelectMenuOption = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _emoji_decorators = [property({ reflect: true, attribute: 'emoji' })];
            _emojiName_decorators = [property({ reflect: true, attribute: 'emoji-name' })];
            _label_decorators = [property({ attribute: 'label' })];
            _description_decorators = [property({ attribute: 'description' })];
            _selectOption_decorators = [property({ reflect: false, noAccessor: true, attribute: false })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _emoji_decorators, { kind: "accessor", name: "emoji", static: false, private: false, access: { has: obj => "emoji" in obj, get: obj => obj.emoji, set: (obj, value) => { obj.emoji = value; } }, metadata: _metadata }, _emoji_initializers, _emoji_extraInitializers);
            __esDecorate(this, null, _emojiName_decorators, { kind: "accessor", name: "emojiName", static: false, private: false, access: { has: obj => "emojiName" in obj, get: obj => obj.emojiName, set: (obj, value) => { obj.emojiName = value; } }, metadata: _metadata }, _emojiName_initializers, _emojiName_extraInitializers);
            __esDecorate(this, null, _label_decorators, { kind: "accessor", name: "label", static: false, private: false, access: { has: obj => "label" in obj, get: obj => obj.label, set: (obj, value) => { obj.label = value; } }, metadata: _metadata }, _label_initializers, _label_extraInitializers);
            __esDecorate(this, null, _description_decorators, { kind: "accessor", name: "description", static: false, private: false, access: { has: obj => "description" in obj, get: obj => obj.description, set: (obj, value) => { obj.description = value; } }, metadata: _metadata }, _description_initializers, _description_extraInitializers);
            __esDecorate(this, null, _selectOption_decorators, { kind: "accessor", name: "selectOption", static: false, private: false, access: { has: obj => "selectOption" in obj, get: obj => obj.selectOption, set: (obj, value) => { obj.selectOption = value; } }, metadata: _metadata }, _selectOption_initializers, _selectOption_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordStringSelectMenuOption = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		label {
			display: flex;
			align-items: center;
			max-width: 400px;
			padding: 8px 8px 8px 12px;
			gap: 10px;
			font-size: small;
			cursor: pointer;
		}

		label:hover {
			background-color: rgba(255, 255, 255, 0.1);
		}

		:host([light-theme]) {
			background-color: #f2f3f5 !important;
			border-color: #d9d9d9 !important;
			color: #2e3338;
		}

		:host([light-theme]) label:hover {
			background-color: rgba(204, 204, 204, 2) !important;
		}

		.discord-string-select-menu-option-emoji {
			margin-right: 4px;
			object-fit: contain;
			width: 1.375em;
			height: 1.375em;
			vertical-align: bottom;
		}

		.discord-string-select-menu-option-ellipsis-text {
			overflow: hidden;
			text-overflow: ellipsis;
			white-space: nowrap;
		}

		.discord-string-select-menu-option-hidden {
			display: none;
		}
	`;
        #emoji_accessor_storage = __runInitializers(this, _emoji_initializers, void 0);
        /**
         * The emoji URL to use in the SelectMenu.
         */
        get emoji() { return this.#emoji_accessor_storage; }
        set emoji(value) { this.#emoji_accessor_storage = value; }
        #emojiName_accessor_storage = (__runInitializers(this, _emoji_extraInitializers), __runInitializers(this, _emojiName_initializers, 'emoji'));
        /**
         * The name of the emoji used in the SelectMenu.
         */
        get emojiName() { return this.#emojiName_accessor_storage; }
        set emojiName(value) { this.#emojiName_accessor_storage = value; }
        #label_accessor_storage = (__runInitializers(this, _emojiName_extraInitializers), __runInitializers(this, _label_initializers, void 0));
        /**
         * The label of the option
         */
        get label() { return this.#label_accessor_storage; }
        set label(value) { this.#label_accessor_storage = value; }
        #description_accessor_storage = (__runInitializers(this, _label_extraInitializers), __runInitializers(this, _description_initializers, void 0));
        /**
         * The description of the option
         */
        get description() { return this.#description_accessor_storage; }
        set description(value) { this.#description_accessor_storage = value; }
        #selectOption_accessor_storage = (__runInitializers(this, _description_extraInitializers), __runInitializers(this, _selectOption_initializers, void 0));
        get selectOption() { return this.#selectOption_accessor_storage; }
        set selectOption(value) { this.#selectOption_accessor_storage = value; }
        checkLabelIsProvided() {
            if (!this.label) {
                throw new DiscordComponentsError('The label of option is required');
            }
        }
        #lightTheme_accessor_storage = (__runInitializers(this, _selectOption_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        render() {
            this.checkLabelIsProvided();
            return html `
			<label>
				${when(this.emoji, () => when(this.emoji?.includes('http') || this.emoji?.startsWith('/') || this.emoji?.startsWith('./'), () => html `<img
								src=${this.emoji}
								alt=${ifDefined(this.emojiName)}
								draggable="true"
								class="discord-string-select-menu-option-emoji"
							/>`, () => html `<span class="discord-string-select-menu-option-emoji">${this.emoji}</span>`))}
				<div class="discord-string-select-menu-option-ellipsis-text">
					<div class="discord-string-select-menu-option-ellipsis-text">
						<strong>${this.label}</strong>
					</div>
					${when(this.description, () => html `<span>${this.description}</span>`)}
				</div>
				<span class="discord-string-select-menu-option-hidden"><input type="checkbox" @click=${() => this.selectOption?.()} /></span>
			</label>
		`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordStringSelectMenuOption = _classThis;
})();
export { DiscordStringSelectMenuOption };
//# sourceMappingURL=DiscordStringSelectMenuOption.js.map