import { LitElement } from 'lit';
import type { DiscordTimestamp, LightTheme } from '../../types.js';
export declare class DiscordSystemMessage extends LitElement implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * The timestamp to use for the message date.
     */
    accessor timestamp: DiscordTimestamp;
    /**
     * The type of system message this is, this will change the icon shown.
     * Valid values: `join`, `leave`, `call`, `missed-call`, `boost`, `edit`, `thread`, `pin`, `alert`, `upgrade` and `error`.
     */
    accessor type: 'alert' | 'boost' | 'call' | 'edit' | 'error' | 'join' | 'leave' | 'missed-call' | 'pin' | 'thread' | 'upgrade';
    /**
     * Whether this message is to show channel name changes, used to match Discord's style.
     */
    accessor channelName: boolean;
    accessor hasThread: boolean;
    accessor lightTheme: boolean;
    checkType(): void;
    protected willUpdate(): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-system-message': DiscordSystemMessage;
    }
}
//# sourceMappingURL=DiscordSystemMessage.d.ts.map