var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { consume } from '@lit/context';
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { ifDefined } from 'lit/directives/if-defined.js';
import { styleMap } from 'lit/directives/style-map.js';
import { when } from 'lit/directives/when.js';
import { avatars, profiles } from '../../config.js';
import { messagesLightTheme } from '../discord-messages/DiscordMessages.js';
import VerifiedTick from '../svgs/VerifiedTick.js';
let DiscordThreadMessage = (() => {
    let _classDecorators = [customElement('discord-thread-message')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _profile_decorators;
    let _profile_initializers = [];
    let _profile_extraInitializers = [];
    let _author_decorators;
    let _author_initializers = [];
    let _author_extraInitializers = [];
    let _avatar_decorators;
    let _avatar_initializers = [];
    let _avatar_extraInitializers = [];
    let _bot_decorators;
    let _bot_initializers = [];
    let _bot_extraInitializers = [];
    let _server_decorators;
    let _server_initializers = [];
    let _server_extraInitializers = [];
    let _verified_decorators;
    let _verified_initializers = [];
    let _verified_extraInitializers = [];
    let _edited_decorators;
    let _edited_initializers = [];
    let _edited_extraInitializers = [];
    let _roleColor_decorators;
    let _roleColor_initializers = [];
    let _roleColor_extraInitializers = [];
    let _relativeTimestamp_decorators;
    let _relativeTimestamp_initializers = [];
    let _relativeTimestamp_extraInitializers = [];
    let _lightTheme_decorators;
    let _lightTheme_initializers = [];
    let _lightTheme_extraInitializers = [];
    var DiscordThreadMessage = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _profile_decorators = [property()];
            _author_decorators = [property()];
            _avatar_decorators = [property()];
            _bot_decorators = [property({ type: Boolean })];
            _server_decorators = [property({ type: Boolean })];
            _verified_decorators = [property({ type: Boolean })];
            _edited_decorators = [property({ type: Boolean })];
            _roleColor_decorators = [property({ attribute: 'role-color' })];
            _relativeTimestamp_decorators = [property({ attribute: 'relative-timestamp' })];
            _lightTheme_decorators = [consume({ context: messagesLightTheme }), property({ type: Boolean, reflect: true, attribute: 'light-theme' })];
            __esDecorate(this, null, _profile_decorators, { kind: "accessor", name: "profile", static: false, private: false, access: { has: obj => "profile" in obj, get: obj => obj.profile, set: (obj, value) => { obj.profile = value; } }, metadata: _metadata }, _profile_initializers, _profile_extraInitializers);
            __esDecorate(this, null, _author_decorators, { kind: "accessor", name: "author", static: false, private: false, access: { has: obj => "author" in obj, get: obj => obj.author, set: (obj, value) => { obj.author = value; } }, metadata: _metadata }, _author_initializers, _author_extraInitializers);
            __esDecorate(this, null, _avatar_decorators, { kind: "accessor", name: "avatar", static: false, private: false, access: { has: obj => "avatar" in obj, get: obj => obj.avatar, set: (obj, value) => { obj.avatar = value; } }, metadata: _metadata }, _avatar_initializers, _avatar_extraInitializers);
            __esDecorate(this, null, _bot_decorators, { kind: "accessor", name: "bot", static: false, private: false, access: { has: obj => "bot" in obj, get: obj => obj.bot, set: (obj, value) => { obj.bot = value; } }, metadata: _metadata }, _bot_initializers, _bot_extraInitializers);
            __esDecorate(this, null, _server_decorators, { kind: "accessor", name: "server", static: false, private: false, access: { has: obj => "server" in obj, get: obj => obj.server, set: (obj, value) => { obj.server = value; } }, metadata: _metadata }, _server_initializers, _server_extraInitializers);
            __esDecorate(this, null, _verified_decorators, { kind: "accessor", name: "verified", static: false, private: false, access: { has: obj => "verified" in obj, get: obj => obj.verified, set: (obj, value) => { obj.verified = value; } }, metadata: _metadata }, _verified_initializers, _verified_extraInitializers);
            __esDecorate(this, null, _edited_decorators, { kind: "accessor", name: "edited", static: false, private: false, access: { has: obj => "edited" in obj, get: obj => obj.edited, set: (obj, value) => { obj.edited = value; } }, metadata: _metadata }, _edited_initializers, _edited_extraInitializers);
            __esDecorate(this, null, _roleColor_decorators, { kind: "accessor", name: "roleColor", static: false, private: false, access: { has: obj => "roleColor" in obj, get: obj => obj.roleColor, set: (obj, value) => { obj.roleColor = value; } }, metadata: _metadata }, _roleColor_initializers, _roleColor_extraInitializers);
            __esDecorate(this, null, _relativeTimestamp_decorators, { kind: "accessor", name: "relativeTimestamp", static: false, private: false, access: { has: obj => "relativeTimestamp" in obj, get: obj => obj.relativeTimestamp, set: (obj, value) => { obj.relativeTimestamp = value; } }, metadata: _metadata }, _relativeTimestamp_initializers, _relativeTimestamp_extraInitializers);
            __esDecorate(this, null, _lightTheme_decorators, { kind: "accessor", name: "lightTheme", static: false, private: false, access: { has: obj => "lightTheme" in obj, get: obj => obj.lightTheme, set: (obj, value) => { obj.lightTheme = value; } }, metadata: _metadata }, _lightTheme_initializers, _lightTheme_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordThreadMessage = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host {
			height: 18px;
			min-width: 0;
			display: flex;
			align-items: center;
			font-size: 0.875rem;
			line-height: 1.125rem;
		}

		:host .discord-thread-message-avatar {
			margin-right: 8px;
			flex: 0 0 auto;
			width: 16px;
			height: 16px;
			border-radius: 50%;
			user-select: none;
		}

		:host .discord-thread-message-username {
			flex-shrink: 0;
			font-size: inherit;
			line-height: inherit;
			margin-right: 0.25rem;
			opacity: 0.64;
			color: white;
			display: inline;
			vertical-align: baseline;
			position: relative;
			overflow: hidden;
		}

		:host([light-theme]) .discord-thread-message-username {
			color: #060607;
		}

		:host .discord-application-tag {
			background-color: #5865f2;
			color: #fff;
			font-size: 0.65em;
			margin-right: 5px;
			border-radius: 3px;
			line-height: 100%;
			text-transform: uppercase;
			display: flex;
			align-items: center;
			height: 0.9375rem;
			padding: 0 0.275rem;
			margin-top: 0.075em;
			border-radius: 0.1875rem;
		}

		:host .discord-application-tag-verified {
			display: inline-block;
			width: 0.9375rem;
			height: 0.9375rem;
			margin-left: -0.25rem;
		}

		:host .discord-thread-message-content {
			display: flex;
			align-items: baseline;
		}

		:host .discord-message-edited {
			color: #72767d;
			font-size: 10px;
			margin-left: 5px;
		}

		:host .discord-thread-message-timestamp {
			color: #72767d;
			flex-shrink: 0;
			margin-left: 8px;
			font-size: 0.875rem;
			line-height: 1.125rem;
		}

		:host([light-theme]) .discord-thread-message-timestamp,
		:host([light-theme]) .discord-message-edited {
			color: #747f8d;
		}
	`;
        #profile_accessor_storage = __runInitializers(this, _profile_initializers, void 0);
        /**
         * The id of the profile data to use.
         */
        get profile() { return this.#profile_accessor_storage; }
        set profile(value) { this.#profile_accessor_storage = value; }
        #author_accessor_storage = (__runInitializers(this, _profile_extraInitializers), __runInitializers(this, _author_initializers, 'User'));
        /**
         * The message author's username.
         *
         * @defaultValue 'User'
         */
        get author() { return this.#author_accessor_storage; }
        set author(value) { this.#author_accessor_storage = value; }
        #avatar_accessor_storage = (__runInitializers(this, _author_extraInitializers), __runInitializers(this, _avatar_initializers, void 0));
        /**
         * The message author's avatar. Can be an avatar shortcut, relative path, or external link.
         */
        get avatar() { return this.#avatar_accessor_storage; }
        set avatar(value) { this.#avatar_accessor_storage = value; }
        #bot_accessor_storage = (__runInitializers(this, _avatar_extraInitializers), __runInitializers(this, _bot_initializers, false));
        /**
         * Whether the message author is a bot or not.
         * Only works if `server` is `false` or `undefined`.
         */
        get bot() { return this.#bot_accessor_storage; }
        set bot(value) { this.#bot_accessor_storage = value; }
        #server_accessor_storage = (__runInitializers(this, _bot_extraInitializers), __runInitializers(this, _server_initializers, false));
        /**
         * Whether the message author is a server crosspost webhook or not.
         * Only works if `bot` is `false` or `undefined`.
         */
        get server() { return this.#server_accessor_storage; }
        set server(value) { this.#server_accessor_storage = value; }
        #verified_accessor_storage = (__runInitializers(this, _server_extraInitializers), __runInitializers(this, _verified_initializers, false));
        /**
         * Whether the bot is verified or not.
         * Only works if `bot` is `true`
         */
        get verified() { return this.#verified_accessor_storage; }
        set verified(value) { this.#verified_accessor_storage = value; }
        #edited_accessor_storage = (__runInitializers(this, _verified_extraInitializers), __runInitializers(this, _edited_initializers, false));
        /**
         * Whether the message has been edited or not.
         */
        get edited() { return this.#edited_accessor_storage; }
        set edited(value) { this.#edited_accessor_storage = value; }
        #roleColor_accessor_storage = (__runInitializers(this, _edited_extraInitializers), __runInitializers(this, _roleColor_initializers, void 0));
        /**
         * The message author's primary role color. Can be any [CSS color value](https://www.w3schools.com/cssref/css_colors_legal.asp).
         */
        get roleColor() { return this.#roleColor_accessor_storage; }
        set roleColor(value) { this.#roleColor_accessor_storage = value; }
        #relativeTimestamp_accessor_storage = (__runInitializers(this, _roleColor_extraInitializers), __runInitializers(this, _relativeTimestamp_initializers, '1m ago'));
        /**
         * The relative timestamp of the message.
         */
        get relativeTimestamp() { return this.#relativeTimestamp_accessor_storage; }
        set relativeTimestamp(value) { this.#relativeTimestamp_accessor_storage = value; }
        #lightTheme_accessor_storage = (__runInitializers(this, _relativeTimestamp_extraInitializers), __runInitializers(this, _lightTheme_initializers, false));
        get lightTheme() { return this.#lightTheme_accessor_storage; }
        set lightTheme(value) { this.#lightTheme_accessor_storage = value; }
        resolveAvatar(avatar) {
            return avatars[avatar] ?? avatar ?? avatars.default;
        }
        render() {
            const defaultData = { author: this.author, bot: this.bot, verified: this.verified, server: this.server, roleColor: this.roleColor };
            const profileData = Reflect.get(profiles, this.profile) ?? {};
            const profile = { ...defaultData, ...profileData, avatar: this.resolveAvatar(profileData.avatar ?? this.avatar) };
            return html `<img src=${ifDefined(profile.avatar)} class="discord-thread-message-avatar" alt=${ifDefined(profile.author)} />
			${when(profile.bot && !profile.server, () => html `<span class="discord-application-tag"> ${profile.verified ? VerifiedTick() : null} App </span>`)}
			${when(profile.server && !profile.bot, () => html `<span class="discord-application-tag">Server</span>`)}
			<span class="discord-thread-message-username" style=${styleMap({ color: profile.roleColor })}> ${profile.author} </span>
			<div class="discord-thread-message-content">
				<slot></slot>
				${when(this.edited, () => html `<span class="discord-message-edited">(edited)</span>`)}
			</div>
			<span class="discord-thread-message-timestamp">${this.relativeTimestamp}</span>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _lightTheme_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordThreadMessage = _classThis;
})();
export { DiscordThreadMessage };
//# sourceMappingURL=DiscordThreadMessage.js.map