import { LitElement } from 'lit';
export declare class DiscordUnorderedList extends LitElement {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult;
    /**
     * Whether this is a nested list or not, this will change the style of the list-style.
     *
     * The library will try to guess this automatically based on the component tree, but
     * you can also set this manually.
     *
     * @defaultValue false
     */
    accessor nested: boolean;
    checkChildren(): void;
    /**
     * Sets {@link DiscordUnorderedList.nested | nested} to true if the parent is either
     * `<discord-unordered-list>` or `<discord-ordered-list>`.
     */
    protected willUpdate(): void;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-unordered-list': DiscordUnorderedList;
    }
}
//# sourceMappingURL=DiscordUnorderedList.d.ts.map