var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
import { css, html, LitElement } from 'lit';
import { customElement, property } from 'lit/decorators.js';
import { DiscordComponentsError } from '../../util.js';
let DiscordUnorderedList = (() => {
    let _classDecorators = [customElement('discord-unordered-list')];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    let _classSuper = LitElement;
    let _nested_decorators;
    let _nested_initializers = [];
    let _nested_extraInitializers = [];
    var DiscordUnorderedList = class extends _classSuper {
        static { _classThis = this; }
        static {
            const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
            _nested_decorators = [property({ type: Boolean, reflect: true })];
            __esDecorate(this, null, _nested_decorators, { kind: "accessor", name: "nested", static: false, private: false, access: { has: obj => "nested" in obj, get: obj => obj.nested, set: (obj, value) => { obj.nested = value; } }, metadata: _metadata }, _nested_initializers, _nested_extraInitializers);
            __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
            DiscordUnorderedList = _classThis = _classDescriptor.value;
            if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        }
        /**
         * @internal
         */
        static styles = css `
		:host > ul {
			list-style-image: initial;
			list-style: disc;
			list-style-position: outside;
			margin: 4px 0 0 16px;
			padding: 0px;
		}

		:host([nested]) > ul {
			list-style: circle;
		}
	`;
        #nested_accessor_storage = __runInitializers(this, _nested_initializers, false);
        /**
         * Whether this is a nested list or not, this will change the style of the list-style.
         *
         * The library will try to guess this automatically based on the component tree, but
         * you can also set this manually.
         *
         * @defaultValue false
         */
        get nested() { return this.#nested_accessor_storage; }
        set nested(value) { this.#nested_accessor_storage = value; }
        checkChildren() {
            const allChildrenAreListItems = Array.from(this.children).every((child) => {
                const tagNameLowerCase = child.tagName.toLowerCase();
                return (tagNameLowerCase === 'discord-list-item' ||
                    tagNameLowerCase === 'discord-unordered-list' ||
                    tagNameLowerCase === 'discord-ordered-list');
            });
            if (!allChildrenAreListItems) {
                throw new DiscordComponentsError('All direct children inside of a <discord-unordered-list> components must be one of <discord-unordered-list>, <discord-ordered-list>, or <discord-list-item>.');
            }
        }
        /**
         * Sets {@link DiscordUnorderedList.nested | nested} to true if the parent is either
         * `<discord-unordered-list>` or `<discord-ordered-list>`.
         */
        willUpdate() {
            if (this.parentElement?.tagName.toLowerCase() === 'discord-unordered-list' ||
                this.parentElement?.tagName.toLowerCase() === 'discord-ordered-list') {
                this.nested = true;
            }
        }
        render() {
            this.checkChildren();
            // We disable the eslint rule here because users should use the <discord-list-item> component inside of this component.
            // eslint-disable-next-line lit-a11y/list
            return html `<ul>
			<slot></slot>
		</ul>`;
        }
        constructor() {
            super(...arguments);
            __runInitializers(this, _nested_extraInitializers);
        }
        static {
            __runInitializers(_classThis, _classExtraInitializers);
        }
    };
    return DiscordUnorderedList = _classThis;
})();
export { DiscordUnorderedList };
//# sourceMappingURL=DiscordUnorderedList.js.map