import type { LightTheme } from '../../types.js';
import { DiscordMediaLifecycle } from '../_private/DiscordMediaLifecycle.js';
import '../discord-link/DiscordLink.js';
export declare class DiscordVideoAttachment extends DiscordMediaLifecycle implements LightTheme {
    /**
     * @internal
     */
    static readonly styles: import("lit").CSSResult[];
    /**
     * The URL to vidoe file
     *
     * @example
     * ```ts
     * 'https://interactive-examples.mdn.mozilla.net/media/cc0-videos/flower.webm'
     * ```
     */
    accessor href: string;
    /**
     * A poster of the video, this is a static image of the video that is used as thumbnail when not yet having played the video
     *
     * @example
     * ```ts
     * 'https://favna.s-ul.eu/On2pqpAq.png'
     * ```
     */
    accessor poster: string;
    accessor lightTheme: boolean;
    private playPausePopAnimationContainerRef;
    private handleFullScreenClicked;
    private handleHasStartedPlayingOrHasPaused;
    protected render(): import("lit-html").TemplateResult<1>;
}
declare global {
    interface HTMLElementTagNameMap {
        'discord-video-attachment': DiscordVideoAttachment;
    }
}
//# sourceMappingURL=DiscordVideoAttachment.d.ts.map