import { Crystal, Diamond, Explosion, Flame, Flower, Heart, Key, Leaf, Lightning, Magic, Moon, Mushroom, Mythical, Ornament, Plasma, Rock, Shell, Skull, Sun, Sword, Water } from './components/svgs/clan-icons/index.js';
let config = globalThis.$discordMessage ?? {};
export function getConfig() {
    return config;
}
export function setConfig(partialConfig) {
    config = Object.assign(config, partialConfig);
}
export const defaultDiscordAvatars = {
    blue: 'https://cdn.discordapp.com/embed/avatars/0.png',
    gray: 'https://cdn.discordapp.com/embed/avatars/1.png',
    green: 'https://cdn.discordapp.com/embed/avatars/2.png',
    orange: 'https://cdn.discordapp.com/embed/avatars/3.png',
    red: 'https://cdn.discordapp.com/embed/avatars/4.png',
    pink: 'https://cdn.discordapp.com/embed/avatars/5.png'
};
const globalAvatars = getConfig().avatars ?? {};
export const avatars = Object.assign(defaultDiscordAvatars, globalAvatars, {
    default: defaultDiscordAvatars[globalAvatars.default] ?? globalAvatars.default ?? defaultDiscordAvatars.blue
});
export const profiles = getConfig().profiles ?? {};
export const defaultTheme = getConfig().defaultTheme === 'light' ? 'light' : 'dark';
export const defaultMode = getConfig().defaultMode === 'compact' ? 'compact' : 'cozy';
export const defaultBackground = getConfig().defaultBackground === 'none' ? 'none' : 'discord';
export const icons = new Map([
    ['heart', Heart()],
    ['crystal', Crystal()],
    ['diamond', Diamond()],
    ['explosion', Explosion()],
    ['flame', Flame()],
    ['flower', Flower()],
    ['key', Key()],
    ['leaf', Leaf()],
    ['lightning', Lightning()],
    ['magic', Magic()],
    ['moon', Moon()],
    ['mushroom', Mushroom()],
    ['mythical', Mythical()],
    ['ornament', Ornament()],
    ['plasma', Plasma()],
    ['rock', Rock()],
    ['shell', Shell()],
    ['skull', Skull()],
    ['sun', Sun()],
    ['sword', Sword()],
    ['water', Water()]
]);
//# sourceMappingURL=config.js.map